﻿namespace CraftBot
{
    using CraftBot.Properties;

    using Decal.Adapter;
    using Decal.Adapter.Wrappers;
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.IO;
    using System.Reflection;
    using System.Security.Cryptography;
    using System.Text;
    using System.Windows.Forms;
    using System.Xml;
    using System.Xml.XPath;

    [View("CraftBot.ViewXML.mainView.xml"), WireUpControlEvents]
    class UnusedPluginCore : PluginBase
	{
        [ControlReference("btnAddReturn")]
        protected PushButtonWrapper btnAddReturn;
        [ControlReference("btnClearMessages")]
        protected PushButtonWrapper btnClearMessages;
        [ControlReference("btnRemoveReturn")]
        protected PushButtonWrapper btnRemoveReturn;
        [ControlReference("chkAlchemy")]
        protected CheckBoxWrapper chkAlchemy;
        [ControlReference("chkArmorTink")]
        protected CheckBoxWrapper chkArmorTink;
        [ControlReference("chkArtisanPet")]
        protected CheckBoxWrapper chkArtisanPet;
        [ControlReference("chkBuffOnStart")]
        protected CheckBoxWrapper chkBuffOnStart;
        [ControlReference("chkBuffsEnabled")]
        protected CheckBoxWrapper chkBuffsEnabled;
        [ControlReference("chkCalcMajors")]
        protected CheckBoxWrapper chkCalcMajors;
        [ControlReference("chkCooking")]
        protected CheckBoxWrapper chkCooking;
        [ControlReference("chkEnabled")]
        protected CheckBoxWrapper chkEnabled;
        [ControlReference("chkEnableMail")]
        protected CheckBoxWrapper chkEnableMail;
        [ControlReference("chkEnterSpamMail")]
        protected CheckBoxWrapper chkEnterSpamMail;
        [ControlReference("chkEnterSpamRare")]
        protected CheckBoxWrapper chkEnterSpamRare;
        [ControlReference("chkEquip")]
        protected CheckBoxWrapper chkEquip;
        [ControlReference("chkFletching")]
        protected CheckBoxWrapper chkFletching;
        [ControlReference("chkItemTink")]
        protected CheckBoxWrapper chkItemTink;
        [ControlReference("chkJourneymanPet")]
        protected CheckBoxWrapper chkJourneymanPet;
        [ControlReference("chkLockpick")]
        protected CheckBoxWrapper chkLockpick;
        [ControlReference("chkLogOff")]
        protected CheckBoxWrapper chkLogOff;
        [ControlReference("chkMagicItemTink")]
        protected CheckBoxWrapper chkMagicItemTink;
        [ControlReference("chkMasterPet")]
        protected CheckBoxWrapper chkMasterPet;
        [ControlReference("chkRareAllegChan")]
        protected CheckBoxWrapper chkRareAllegChan;
        [ControlReference("chkRareTradeChan")]
        protected CheckBoxWrapper chkRareTradeChan;
        [ControlReference("chkTier4Rares")]
        protected CheckBoxWrapper chkTier4Rares;
        [ControlReference("chkUseBeers")]
        protected CheckBoxWrapper chkUseBeers;
        [ControlReference("chkUseBuffBot")]
        protected CheckBoxWrapper chkUseBuffBot;
        [ControlReference("chkUseCharge")]
        protected CheckBoxWrapper chkUseCharge;
        [ControlReference("chkUseRares")]
        protected CheckBoxWrapper chkUseRares;
        [ControlReference("chkUseWeb")]
        protected CheckBoxWrapper chkUseWeb;
        [ControlReference("chkWeaponTink")]
        protected CheckBoxWrapper chkWeaponTink;
        [ControlReference("listMessages")]
        protected ListWrapper listMessages;
        [ControlReference("listReturn")]
        protected ListWrapper listReturn;
        [ControlReference("txtReturnTo")]
        protected TextBoxWrapper txtReturnTo;

        protected static int BRILLIANCE_DELAY = 30;
        protected static int MAX_RARE_COMMANDS = 25;
        protected static int EQUIP_MAX_COLS = 15;
        protected static int EQUIP_MAX_ROWS = 9;
        
        #region enum Salvages

        private enum Salvages
        {
            Agate =	10,
            Alabaster =	66,
            Amber =	11,
            Amethyst = 12,
            Aquamarine = 13,
            Armoredillo_Hide = 53,
            Azurite = 14,
            Black_Garnet = 15,
            Black_Opal = 16,
            Bloodstone = 17,
            Brass = 57,
            Bronze = 58,
            Carnelian = 18,
            Ceramic = 1,
            Citrine = 19,
            Copper = 59,
            Diamond = 20,
            Ebony =	73,
            Emerald = 21,
            Fire_Opal =	22,
            Gold = 60,
            Granite = 67,
            Green_Garnet = 23,
            Green_Jade = 24,
            Gromnie_Hide = 54,
            Hematite = 25,
            Imperial_Topaz = 26,
            Iron = 61,
            Ivory =	51,
            Jet = 27,
            Lapis_Lazuli = 28,
            Lavender_Jade =	29,
            Leather = 52,
            Linen =	4,
            Mahogany = 74,
            Malachite =	30,
            Marble = 68,
            Moonstone = 31,
            Oak = 75,
            Obsidian = 69,
            Onyx = 32,
            Opal = 33,
            Peridot = 34,
            Pine = 76,
            Porcelain = 2,
            Pyreal = 62,
            Red_Garnet = 35,
            Red_Jade = 36,
            Reed_Shark_Hide = 55,
            Rose_Quartz = 37,
            Ruby = 38,
            Sandstone =	70,
            Sapphire = 39,
            Satin =	5,
            Serpentine = 71,
            Silk = 6,
            Silver = 63,
            Smokey_Quartz =	40,
            Steel = 64,
            Sunstone = 41,
            Teak = 77,
            Tiger_Eye =	42,
            Tourmaline = 43,
            Turquoise =	44,
            Velvet = 7,
            White_Jade = 45,
            White_Quartz = 46,
            White_Sapphire = 47,
            Wool = 8,
            Yellow_Garnet =	48,
            Yellow_Topaz = 49,
            Zircon = 50
        }

        #endregion

        private string systemMessagePrefix = "[CraftBot2]";
        private int systemMessageColor = 5; //Purple+Red
        private List<ReturnObject> returnObjects;
        private Boolean isEnabled;
        private double faceHeading;

        public string personalFolderPath = (Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\Paraduck\CraftBot");

        #region Properties

        public string debugFile
        {
            get
            {
                return (personalFolderPath + @"\debug.txt");
            }
        }

        public string errorLogFile
        {
            get
            {
                return (personalFolderPath + @"\errorLog.txt");
            }
        }

        public string giftFile
        {
            get
            {
                return (personalFolderPath + @"\gifts.txt");
            }
        }

        public string mailFile
        {
            get
            {
                return (personalFolderPath + @"\mail.txt");
            }
        }

        public string mailFileXML
        {
            get
            {
                return (personalFolderPath + @"\mail.xml");
            }
        }

        public string riFile
        {
            get
            {
                return (personalFolderPath + @"\return_items.xml");
            }
        }

        #endregion

        #region ControlEvents

        [ControlEvent("chkEnterSpamRare", "Change")]
        private void chkEnterSpamRare_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            //if (Settings.Default.enterSpamRares)
            //{
            //    Settings.Default.enterSpamRares = chkEnterSpamRare.Checked;
            //    Settings.Default.Save();
            //    WriteToChat("Bot will no longer advertise the tier 4 rares feature outside of the help command.");
            //}
            //else if (_cn)
            //{
            //    Settings.Default.enterSpamRares = chkEnterSpamRare.Checked;
            //    Settings.Default.Save();
            //    WriteToChat("Bot will now advertise the tier 4 rares feature to people who open the trade window.");
            //}
            //else
            //{
            //    WriteToChat("This feature cannot be enabled as the bot does not know any tier 4 rare recipes!");
            //}
        }

        [ControlEvent("chkTier4Rares", "Change")]
        private void chkTier4Rares_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useTier4Rares)
            {
                Settings.Default.useTier4Rares = chkTier4Rares.Checked;
                Settings.Default.Save();
                WriteToChat("Tier 4 Rare Use is now disabled.");
            }
            else
            {
                Settings.Default.useTier4Rares = chkTier4Rares.Checked;
                Settings.Default.Save();
                WriteToChat("Tier 4 Rare Use is now enabled.");
            }
        }

        [ControlEvent("chkLockpick", "Change")]
        private void chkLockpick_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useLockpick)
            {
                Settings.Default.useLockpick = chkLockpick.Checked;
                Settings.Default.Save();
                WriteToChat("Lockpick is now disabled.");
            }
            else
            {
                Settings.Default.useLockpick = chkLockpick.Checked;
                Settings.Default.Save();
                WriteToChat("Lockpick is now enabled.");
            }
        }

        [ControlEvent("chkFletching", "Change")]
        private void chkFletch_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useFletching)
            {
                Settings.Default.useFletching = chkFletching.Checked;
                Settings.Default.Save();
                WriteToChat("Fletching is now disabled.");
            }
            else
            {
                Settings.Default.useFletching = chkFletching.Checked;
                Settings.Default.Save();
                WriteToChat("Fletching is now enabled.");
            }
        }

        [ControlEvent("chkCooking", "Change")]
        private void chkCooking_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useCooking)
            {
                Settings.Default.useCooking = chkCooking.Checked;
                Settings.Default.Save();
                WriteToChat("Cooking is now disabled.");
            }
            else
            {
                Settings.Default.useCooking = chkCooking.Checked;
                Settings.Default.Save();
                WriteToChat("Cooking is now enabled.");
            }
        }

        [ControlEvent("chkAlchemy", "Change")]
        private void chkAlchemy_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useAlchemy)
            {
                Settings.Default.useAlchemy = chkAlchemy.Checked;
                Settings.Default.Save();
                WriteToChat("Alchemy is now disabled.");
            }
            else
            {
                Settings.Default.useAlchemy = chkAlchemy.Checked;
                Settings.Default.Save();
                WriteToChat("Alchemy is now enabled.");
            }
        }

        [ControlEvent("chkWeaponTink", "Change")]
        private void chkWeaponTink_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useWeaponTinkering)
            {
                Settings.Default.useWeaponTinkering = chkWeaponTink.Checked;
                Settings.Default.Save();
                WriteToChat("Weapon Tinkering is now disabled.");
            }
            else
            {
                Settings.Default.useWeaponTinkering = chkWeaponTink.Checked;
                Settings.Default.Save();
                WriteToChat("Weapon Tinkering is now enabled.");
            }
        }

        [ControlEvent("chkMagicItemTink", "Change")]
        private void chkMagicItemTink_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useMagicItemTinkering)
            {
                Settings.Default.useMagicItemTinkering = chkMagicItemTink.Checked;
                Settings.Default.Save();
                WriteToChat("Magic Item Tinkering is now disabled.");
            }
            else
            {
                Settings.Default.useMagicItemTinkering = chkMagicItemTink.Checked;
                Settings.Default.Save();
                WriteToChat("Magic Item Tinkering is now enabled.");
            }
        }

        [ControlEvent("chkItemTink", "Change")]
        private void chkItemTink_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useItemTinerking)
            {
                Settings.Default.useItemTinerking = chkItemTink.Checked;
                Settings.Default.Save();
                WriteToChat("Item Tinkering is now disabled.");
            }
            else
            {
                Settings.Default.useItemTinerking = chkItemTink.Checked;
                Settings.Default.Save();
                WriteToChat("Item Tinkering is now enabled.");
            }
        }

        [ControlEvent("chkEnterSpamMail", "Change")]
        private void chkEnterSpamMail_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.enterSpamMail)
            {
                Settings.Default.enterSpamMail = chkEnterSpamMail.Checked;
                Settings.Default.Save();
                WriteToChat("Bot will no longer advertise the mail feature outside of the help command.");
            }
            else if (Settings.Default.useMail)
            {
                Settings.Default.enterSpamMail = chkEnterSpamMail.Checked;
                Settings.Default.Save();
                WriteToChat("Bot will now advertise the mail feature to people who open the trade window.");
            }
            else
            {
                WriteToChat("Mail is not enabled! Please enable it before specifiying to advertise it.");
            }
        }

        [ControlEvent("chkArmorTink", "Change")]
        private void chkArmorTink_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useArmorTinkering)
            {
                Settings.Default.useArmorTinkering = chkArmorTink.Checked;
                Settings.Default.Save();
                WriteToChat("Armor Tinkering is now disabled.");
            }
            else
            {
                Settings.Default.useArmorTinkering = chkArmorTink.Checked;
                Settings.Default.Save();
                WriteToChat("Armor Tinkering is now enabled.");
            }
        }

        [ControlEvent("chkEnabled", "Change")]
        private void chkEnabled_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            try
            {
                if (isEnabled)
                {
                    isEnabled = false;
                    //rareTimer.Stop();
                    //actionTimer.Stop();
                    //resetCraftingState();
                }
                else
                {
                    isEnabled = true;
                    faceHeading = base.Host.Actions.Heading;
                    //initTimers();
                    if (Settings.Default.useBuffs && Settings.Default.rebuffOnStart)
                    {
                        //buff();
                    }
                    if (Settings.Default.useWeb)
                    {
                        //loadRecipes(personalFolderPath + @"\recipes.xml");
                        //sendBotInfo();
                    }
                    int num = 0;
                    foreach (WorldObject wldObj in base.Core.WorldFilter.GetByContainer(base.Core.CharacterFilter.Id))
                    {
                        if ((!wldObj.ObjectClass.Equals((ObjectClass)10) && !wldObj.ObjectClass.Equals((ObjectClass)0x26)) && (wldObj.Values(LongValueKey.EquippedSlots) <= 0))
                        {
                            num++;
                        }
                    }
                    if ((num >= 90) && Settings.Default.useMail)
                    {
                        clsMessageWriter.Write_Split_Message(debugFile, "Only 12 pack slots left! Disabling mail...");
                        WriteToChat("Low on pack space! Disabling mail.");
                        Settings.Default.useMail = false;
                        chkEnableMail.Checked = false;
                        Settings.Default.recoverMail = true;
                    }
                    else if ((num < 90) && Settings.Default.recoverMail)
                    {
                        WriteToChat("Mail was previously enabled and there are more than 12 slots in the main pack free! Enabling mail...");
                        clsMessageWriter.Write_Split_Message(debugFile, "Re-enabling mail due to free pack space.");
                        Settings.Default.useMail = true;
                        chkEnableMail.Checked = false;
                        Settings.Default.recoverMail = false;
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        [ControlEvent("chkCalcMajors", "Change")]
        private void chkCalcMagors_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useMajorsForSkillCheck)
            {
                Settings.Default.useMajorsForSkillCheck = chkCalcMajors.Checked;
                Settings.Default.Save();
                WriteToChat("Majors will no longer be used in skill checks.");
            }
            else
            {
                Settings.Default.useMajorsForSkillCheck = chkCalcMajors.Checked;
                Settings.Default.Save();
                WriteToChat("Majors will now be used in skill checks.");
            }
        }

        [ControlEvent("chkJourneymanPet", "Change")]
        private void chkJourneymanPet_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useJourneymanPetsSkillChecks)
            {
                Settings.Default.useJourneymanPetsSkillChecks = chkJourneymanPet.Checked;
                Settings.Default.Save();
                WriteToChat("Journeyman Pets (+10) will no longer be used in skill checks.");
            }
            else
            {
                Settings.Default.useJourneymanPetsSkillChecks = chkJourneymanPet.Checked;
                Settings.Default.useMasterPetsSkillCheck = false;
                chkMasterPet.Checked = false;
                Settings.Default.useArtisanPetsSkillCheck = false;
                chkArtisanPet.Checked = false;
                Settings.Default.Save();
                WriteToChat("Journeyman Pets (+10) will now be used in skill checks.");
            }
        }

        [ControlEvent("chkMasterPet", "Change")]
        private void chkMasterPet_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useMasterPetsSkillCheck)
            {
                Settings.Default.useMasterPetsSkillCheck = chkMasterPet.Checked;
                Settings.Default.Save();
                WriteToChat("Master Pets (+20) will no longer be used in skill checks.");
            }
            else
            {
                Settings.Default.useMasterPetsSkillCheck = chkMasterPet.Checked;
                Settings.Default.useJourneymanPetsSkillChecks = false;
                chkJourneymanPet.Checked = false;
                Settings.Default.useArtisanPetsSkillCheck = false;
                chkArtisanPet.Checked = false;
                Settings.Default.Save();
                WriteToChat("Master Pets (+20) will now be used in skill checks.");
            }
        }

        [ControlEvent("chkArtisanPet", "Change")]
        private void chkArtisanPet_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useArtisanPetsSkillCheck)
            {
                Settings.Default.useArtisanPetsSkillCheck = chkArtisanPet.Checked;
                Settings.Default.Save();
                WriteToChat("Artisan Pets (+30) will no longer be used in skill checks.");
            }
            else
            {
                Settings.Default.useArtisanPetsSkillCheck = chkArtisanPet.Checked;
                Settings.Default.useJourneymanPetsSkillChecks = false;
                chkJourneymanPet.Checked = false;
                Settings.Default.useMasterPetsSkillCheck = false;
                chkMasterPet.Checked = false;
                Settings.Default.Save();
                WriteToChat("Artisan Pets (+30) will now be used in skill checks.");
            }
        }

        [ControlEvent("chkBuffsEnabled", "Change")]
        private void chkBuffsEnabled_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useBuffs)
            {
                Settings.Default.useBuffs = chkBuffsEnabled.Checked;
                Settings.Default.Save();
                WriteToChat("Buffing is now disabled.");
            }
            else
            {
                Settings.Default.useBuffs = chkBuffsEnabled.Checked;
                Settings.Default.Save();
                WriteToChat("Buffing is now enabled.");
            }
        }

        [ControlEvent("chkBuffOnStart", "Change")]
        private void chkBuffOnStart_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.rebuffOnStart)
            {
                Settings.Default.rebuffOnStart = chkBuffOnStart.Checked;
                Settings.Default.Save();
                WriteToChat("Rebuffing when the bot starts is now disabled.");
            }
            else
            {
                Settings.Default.rebuffOnStart = chkBuffOnStart.Checked;
                Settings.Default.Save();
                WriteToChat("Rebuffing when the bot starts is now enabled.");
            }
        }

        [ControlEvent("chkUseBeers", "Change")]
        private void chkUseBeers_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useBeers)
            {
                Settings.Default.useBeers = chkUseBeers.Checked;
                Settings.Default.Save();
                WriteToChat("Beers are now disabled.");
            }
            else
            {
                Settings.Default.useBeers = chkUseBeers.Checked;
                Settings.Default.Save();
                WriteToChat("Beers are now enabled.");
            }
        }

        [ControlEvent("chkUseRares", "Change")]
        private void chkUseRares_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useBuffRares)
            {
                Settings.Default.useBuffRares = chkUseRares.Checked;
                Settings.Default.Save();
                WriteToChat("Buffing Rares are now disabled.");
            }
            else
            {
                Settings.Default.useBuffRares = chkUseRares.Checked;
                Settings.Default.Save();
                WriteToChat("Buffing Rares are now enabled.");
            }
        }

        [ControlEvent("chkUseBuffBot", "Change")]
        private void chkUseBuffBot_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useBuffBot)
            {
                Settings.Default.useBuffBot = chkUseBuffBot.Checked;
                Settings.Default.Save();
                WriteToChat("Buff Bot use is now disabled.");
            }
            else
            {
                Settings.Default.useBuffBot = chkUseBuffBot.Checked;
                Settings.Default.Save();
                WriteToChat("Buff Bot use is now enabled.");
            }
        }

        [ControlEvent("chkLogOff", "Change")]
        private void chkLogOff_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.logoffOnMonsterDetect)
            {
                Settings.Default.logoffOnMonsterDetect = chkLogOff.Checked;
                Settings.Default.Save();
                WriteToChat("Log Off on Monster Detection is now disabled.");
            }
            else
            {
                Settings.Default.logoffOnMonsterDetect = chkLogOff.Checked;
                Settings.Default.Save();
                WriteToChat("Log Off on Monster Detection is now enabled.");
            }
        }

        [ControlEvent("chkUseCharge", "Change")]
        private void chkUseCharge_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useManaStones)
            {
                Settings.Default.useManaStones = chkUseCharge.Checked;
                Settings.Default.Save();
                WriteToChat("Mana Stones and Charges are now disabled.");
            }
            else
            {
                Settings.Default.useManaStones = chkUseCharge.Checked;
                Settings.Default.Save();
                WriteToChat("Mana Stones and Charges are now enabled.");
            }
        }

        [ControlEvent("chkEquip", "Change")]
        private void chkEquip_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.equipItems)
            {
                Settings.Default.equipItems = chkEquip.Checked;
                Settings.Default.Save();
                WriteToChat("Equipping/Dequipping Items is now disabled.");
            }
            else
            {
                Settings.Default.equipItems = chkEquip.Checked;
                Settings.Default.Save();
                WriteToChat("Equipping/Dequipping Items is now enabled.");
            }
        }

        [ControlEvent("chkRareTradeChan", "Change")]
        private void chkRareTradeChan_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.rareBroadcastToTradeChan)
            {
                Settings.Default.rareBroadcastToTradeChan = chkRareTradeChan.Checked;
                Settings.Default.Save();
                WriteToChat("You will no longer broadcast rare gem usage to the Trade channel.");
            }
            else
            {
                Settings.Default.rareBroadcastToTradeChan = chkRareTradeChan.Checked;
                Settings.Default.Save();
                WriteToChat("You will now broadcast rare gem usage to the Trade channel.");
            }
        }

        [ControlEvent("chkEnableMail", "Change")]
        private void chkEnableMail_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useMail)
            {
                Settings.Default.useMail = chkEnableMail.Checked;
                Settings.Default.recoverMail = false;
                Settings.Default.Save();
                WriteToChat("New mail requests will no longer be processed. Existing mail items will be returned, however.");
            }
            else
            {
                Settings.Default.useMail = chkEnableMail.Checked;
                Settings.Default.Save();
                WriteToChat("New mail requests will now be processed.");
            }
        }

        [ControlEvent("chkRareAllegChan", "Change")]
        private void chkRareAllegChan_Click(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.rareBroadcastToAllegianceChan)
            {
                Settings.Default.rareBroadcastToAllegianceChan = chkRareAllegChan.Checked;
                Settings.Default.Save();
                WriteToChat("You will no longer broadcast rare gem usage to the Allegiance chat channel.");
            }
            else
            {
                Settings.Default.rareBroadcastToAllegianceChan = chkRareAllegChan.Checked;
                Settings.Default.Save();
                WriteToChat("You will now broadcast rare gem usage to the Allegiance chat channel.");
            }
        }

        [ControlEvent("chkUseWeb", "Change")]
        private void chkUseWeb_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useWeb)
            {
                Settings.Default.useWeb = chkUseWeb.Checked;
                Settings.Default.Save();
                WriteToChat("You will no longer appear as online or send stats to the CraftBot website.");
            }
            else
            {
                Settings.Default.useWeb = chkUseWeb.Checked;
                Settings.Default.Save();
                WriteToChat("You will now appear on the CraftBot website the next time you start the bot.");
            }
        }

        [ControlEvent("listReturn", "Selected")]
        private void listReturn_Selected(object A_0, ListSelectEventArgs A_1)
        {
            try
            {
                WriteToChat(string.Concat(new object[] { "Person: ", listReturn[A_1.Row][0][0], " Item to Return: ", listReturn[A_1.Row][1][0], " Added: ", listReturn[A_1.Row][2][0] }));
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        [ControlEvent("listMessages", "Selected")]
        private void listMessages_Selected(object A_0, ListSelectEventArgs A_1)
        {
            try
            {
                WriteToChat(string.Concat(new object[] { "Sender: ", listMessages[A_1.Row][0][0], " Message: ", listMessages[A_1.Row][1][0], " Time: ", listMessages[A_1.Row][2][0] }));
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        [ControlEvent("txtReturnTo", "End")]
        private void txtReturnTo_End(object A_0, TextBoxEndEventArgs A_1)
        {
            try
            {
                if (((txtReturnTo.Text != null) && !this.txtReturnTo.Text.Equals("")) && !this.txtReturnTo.Text.Equals(" "))
                {
                    txtReturnTo.Text = txtReturnTo.Text.Trim();
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        [ControlEvent("btnRemoveReturn", "Click")]
        private void btnRemoveReturn_Click(object A_0, Decal.Adapter.ControlEventArgs A_1)
        {
            try
            {
                ReturnObject rtnObj = null;
                foreach (ReturnObject obj in returnObjects)
                {
                    if (((obj != null) && (base.Host.Actions.CurrentSelection != 0)) && ((base.Core.WorldFilter[base.Host.Actions.CurrentSelection] != null) && (obj.getID() == base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Id)))
                    {
                        rtnObj = obj;
                        break;
                    }
                }
                if (rtnObj != null)
                {
                    deleteReturnItem(riFile, rtnObj);
                    WriteToChat(base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Name + " has been removed from the return item list.");
                }
                else
                {
                    WriteToChat("Error: Could not find " + base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Name + "!");
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        [ControlEvent("btnAddReturn", "Click")]
        private void btnAddReturn_Click(object A_0, Decal.Adapter.ControlEventArgs A_1)
        {
            try
            {
                if (((txtReturnTo.Text == null) || txtReturnTo.Text.Equals("")) || txtReturnTo.Text.Equals(" "))
                {
                    WriteToChat("Error: Player name missing!");
                }
                else if (base.Core.WorldFilter[base.Host.Actions.CurrentSelection] == null)
                {
                    WriteToChat("Object reference is null. This item cannot be returned at this time.");
                }
                else
                {
                    WorldObjectCollection inventory = base.Core.WorldFilter.GetInventory();
                    bool flag = false;
                    foreach (WorldObject obj2 in inventory)
                    {
                        if (base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Id == obj2.Id)
                        {
                            flag = true;
                            break;
                        }
                    }
                    if (!flag)
                    {
                        WriteToChat("Error: " + base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Name + " is not in your inventory!");
                    }
                    else
                    {
                        writeReturnItem(riFile, new ReturnObject(base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Id, txtReturnTo.Text.Trim().ToLower()));
                        WriteToChat(base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Name + " will be returned to " + txtReturnTo.Text.Trim().ToLower() + " when they next open a trade window.");
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        [ControlEvent("btnClearMessages", "Click")]
        private void btnClearMessages_Click(object A_0, Decal.Adapter.ControlEventArgs A_1)
        {
            try
            {
                clearMessages(personalFolderPath + @"\messages.xml");
                WriteToChat("Messages cleared.");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        #endregion

        #region ChatCode

        public void WriteToChat(string message)
        {
            try
            {
                base.Host.Actions.AddChatText(systemMessagePrefix + " " + message, systemMessageColor);
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        #endregion

        #region ReturnObjectCode

        public void writeReturnItem(string filename, ReturnObject ro)
        {
            try
            {
                XmlDocument document = new XmlDocument();
                try
                {
                    document.Load(filename);
                }
                catch (FileNotFoundException)
                {
                    XmlDeclaration declaration = document.CreateXmlDeclaration("1.0", "utf-8", null);
                    XmlElement element = document.CreateElement("items");
                    document.InsertBefore(declaration, document.DocumentElement);
                    document.AppendChild(element);
                }
                string str = DateTime.Now.ToString();
                XmlElement newChild = document.CreateElement("item");
                newChild.SetAttribute("player", ro.getReturnTo());
                newChild.SetAttribute("iid", ro.getID().ToString());
                newChild.SetAttribute("time", str);
                document.DocumentElement.PrependChild(newChild);
                document.Save(filename);
                returnObjects.Add(ro);
                ListRow row = listReturn.Add();
                row[0][0] = ro.getReturnTo();
                if (base.Core.WorldFilter[ro.getID()] != null)
                {
                    row[1][0] = base.Core.WorldFilter[ro.getID()].Name;
                }
                else
                {
                    row[1][0] = "Invalid Item";
                }
                row[2][0] = str;
                listReturn.ScrollPosition = 0;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                returnObjects.Add(ro);
            }
        }

        public void deleteReturnItem(string filename, ReturnObject ro)
        {
            try
            {
                XmlDocument document = new XmlDocument();
                try
                {
                    document.Load(filename);
                }
                catch (FileNotFoundException)
                {
                    XmlDeclaration newChild = document.CreateXmlDeclaration("1.0", "utf-8", null);
                    XmlElement element = document.CreateElement("items");
                    document.InsertBefore(newChild, document.DocumentElement);
                    document.AppendChild(element);
                }
                XmlElement documentElement = document.DocumentElement;
                foreach (XmlNode node in documentElement.ChildNodes)
                {
                    if (int.Parse(node.Attributes["iid"].Value) == ro.getID())
                    {
                        documentElement.RemoveChild(node);
                        document.Save(filename);
                        returnObjects.Remove(ro);
                        for (int i = 0; i < listReturn.RowCount; i++)
                        {
                            if ((base.Core.WorldFilter[ro.getID()] != null) && listReturn[i][1][0].ToString().Equals(base.Core.WorldFilter[ro.getID()].Name))
                            {
                                listReturn.Delete(i);
                                listReturn.ScrollPosition = 0;
                                return;
                            }
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        #endregion

        #region MessageCode

        public void clearMessages(string filename)
        {
            try
            {
                XmlDocument document = new XmlDocument();
                document.Load(filename);
                XPathNavigator navigator = document.CreateNavigator();
                while (navigator.MoveToFirstChild())
                {
                    if (navigator.Name.Equals("message"))
                    {
                        navigator.DeleteSelf();
                    }
                }
                document.Save(filename);
                listMessages.Clear();
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        #endregion

        private void processToldCommand(string cmd)
        {
            try
            {
                if ((cmd.Equals("") || (cmd == null)) || cmd.Equals(" "))
                {
                    return;
                }

                if ((cmd.Length >= 9) && cmd.StartsWith("message"))
                {
                    writeMessage(personalFolderPath + @"\messages.xml", _tellPerson, cmd.Substring(8));
                    ListRow row = listMessages.Add();
                    row[0][0] = _tellPerson;
                    row[1][0] = cmd.Substring(8);
                    row[2][0] = DateTime.Now;
                    tellMessageResponse();
                    return;
                }

                if ((cmd.Length >= 12) && cmd.StartsWith("mailcancel"))
                {
                    clsMessageWriter.Write_Message(mailFile, "Got mail cancel command from " + _tellPerson + ". Target Player: " + cmd.Substring(11));
                    processMailCancel(cmd.Substring(11), _tellPerson);
                    return;
                }

                if ((Settings.Default.useMail && (cmd.Length >= 6)) && cmd.StartsWith("mail"))
                {
                    if (wObjTrade.Count > 0)
                    {
                        clsMessageWriter.Write_Message(mailFile, "Got mail command from " + _tellPerson + ". Target Player: " + cmd.Substring(5));
                        processMail(cmd.Substring(5), _tellPerson);
                    }
                    else
                    {
                        tellMustAddItemsBeforeCommand();
                    }
                    return;
                }

                if ((!Settings.Default.useMail && (cmd.Length >= 6)) && cmd.StartsWith("mail"))
                {
                    tellNotProcessingNewMail();
                    return;
                }

                if ((_WaitForRecipeName && (trader != null)) && _tellPerson.Equals(trader.Name))
                {
                    if (recipeExists(cmd, personalFolderPath + @"\recipes.xml"))
                    {
                        setSkill(cmd, personalFolderPath + @"\recipes.xml");
                        startCrafting();
                    }
                    else if ((int.Parse(cmd) <= _RecipeList.Count) && (int.Parse(cmd) >= 1))
                    {
                        if (recipeExists((string)_RecipeList[int.Parse(cmd) - 1], personalFolderPath + @"\recipes.xml"))
                        {
                            setSkill((string)_RecipeList[int.Parse(cmd) - 1], personalFolderPath + @"\recipes.xml");
                            startCrafting();
                        }
                        else
                        {
                            tellDoNotKnowRecipe(cmd);
                            resetCraftingState();
                        }
                    }
                    else
                    {
                        tellDoNotKnowRecipe(cmd);
                        resetCraftingState();
                    }
                    return;
                }

                if (cmd.Equals("help"))
                {
                    @tellHelp();
                    return;
                }

                if ((cmd.Equals("loc") || cmd.Equals("location")) || cmd.Equals("where"))
                {
                    tellCurrentLocation();
                    return;
                }

                if (cmd.Equals("reset"))
                {
                    tellResetCommandResponse();
                    resetCraftingState();
                    return;
                }

                if (cmd.Equals("whereto"))
                {
                    tellWhereTo();
                    return;
                }

                if (cmd.Equals("skills") || cmd.Equals("skill"))
                {
                    tellCurrentSkillLevels();
                    return;
                }

                if (cmd.Equals("firesickle") || cmd.Equals("firesickle"))
                {
                    foreach (Salvage wObj in sortedSalvage)
                    {
                        addToChatQueue("TradeData " + wObj.getSalvageType() + " Work: " + wObj.getWork());
                    }
                }

                if (!this.inTrade)
                {
                    if (inCraft)
                    {
                        if (cmd.Equals("go") && !this._ignoreGo)
                        {
                            _bz = true;
                            if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                            {
                                actionQueue.Dequeue();
                                _State = "Idle";
                                craftingDoWork();
                            }
                            else
                            {
                                _waitTimer = 0;
                                _State = "Idle";
                                craftingDoWork();
                            }
                        }
                        else if (cmd.Equals("primary"))
                        {
                            tellPortalFailure();
                        }
                        else if (cmd.Equals("secondary"))
                        {
                            tellPortalFailure();
                        }
                    }
                    else if (cmd.Equals("primary"))
                    {
                        if ((_primaryPortalSpellId > 0) && (_primaryPortalLocation != null))
                        {
                            if (_buffWand == 0)
                            {
                                WriteToChat("Error: No buff wand set!");
                            }
                            else if (base.Core.WorldFilter[_buffWand] == null)
                            {
                                WriteToChat("Error: Buff wand does not exist!");
                            }
                            else
                            {
                                if (base.Core.WorldFilter[_buffWand].Values(LongValueKey.EquippedSlots) != 0x1000000)
                                {
                                    actionQueue.Enqueue(new CAction(_buffWand, "Buff"));
                                }
                                actionQueue.Enqueue(new CAction(_faceHeading + 45.0, "Face Heading"));
                                actionQueue.Enqueue(new CAction(_primaryPortalSpellId, "Cast Spell"));
                                tellIamNowSummoningPrimary();
                                sayIamNowSummoningPrimary();
                            }
                        }
                        else
                        {
                            tellPortalConfigError();
                        }
                    }
                    else if (cmd.Equals("secondary"))
                    {
                        if ((_secondaryPortalSpellId > 0) && (_secondaryPortalLocation != null))
                        {
                            if (_buffWand == 0)
                            {
                                WriteToChat("Error: No buff wand set!");
                            }
                            else if (base.Core.WorldFilter[_buffWand] == null)
                            {
                                WriteToChat("Error: Buff wand does not exist!");
                            }
                            else
                            {
                                if (base.Core.WorldFilter[_buffWand].Values(LongValueKey.EquippedSlots) != 0x1000000)
                                {
                                    actionQueue.Enqueue(new CAction(_buffWand, "Buff"));
                                }
                                actionQueue.Enqueue(new CAction(_faceHeading - 45.0, "Face Heading"));
                                actionQueue.Enqueue(new CAction(_secondaryPortalSpellId, "Cast Spell"));
                                tellIamNowSummoningSecondary();
                                sayIamNowSummoningSecondary();
                            }
                        }
                        else
                        {
                            tellPortalConfigError();
                        }
                    }
                    return;
                }
                string key = cmd;
                if (key != null)
                {
                    int num3;
                    if (_dictionaryCmds == null)
                    {
                        Dictionary<string, int> dictionary1 = new Dictionary<string, int>(0x10);
                        dictionary1.Add("help", 0);
                        dictionary1.Add("y", 1);
                        dictionary1.Add("yes", 2);
                        dictionary1.Add("go", 3);
                        dictionary1.Add("t1", 4);
                        dictionary1.Add("t2", 5);
                        dictionary1.Add("t3", 6);
                        dictionary1.Add("t4", 7);
                        dictionary1.Add("t5", 8);
                        dictionary1.Add("t6", 9);
                        dictionary1.Add("t7", 10);
                        dictionary1.Add("t8", 11);
                        dictionary1.Add("t9", 12);
                        dictionary1.Add("t10", 13);
                        dictionary1.Add("primary", 14);
                        dictionary1.Add("secondary", 15);
                        _dictionaryCmds = dictionary1;
                    }
                    if (_dictionaryCmds.TryGetValue(key, out num3))
                    {
                        switch (num3)
                        {
                            case 0: //help
                                @tellHelp();
                                return;

                            case 1: //y
                                if (inCraft && !this._ignoreYes)
                                {
                                    tinkerStopAt = 10;
                                    craftingAccept();
                                }
                                return;

                            case 2: //yes
                                if (inCraft && !this._ignoreYes)
                                {
                                    tinkerStopAt = 10;
                                    craftingAccept();
                                }
                                return;

                            case 3: //go
                                if (!this._ignoreGo)
                                {
                                    _bz = true;
                                    if (((actionQueue.Count <= 0) || !this.actionQueue.Peek().getType().Equals("Wait")) || !this.inCraft)
                                    {
                                        goto Label_085B;
                                    }
                                    actionQueue.Dequeue();
                                    _waitTimer = 0;
                                    _State = "Idle";
                                    craftingDoWork();
                                }
                                return;

                            case 4: //t1
                                if (!this.inCraft)
                                {
                                    goto Label_08FD;
                                }
                                tinkerStopAt = 1;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_08B1;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 5: //t2
                                if (!this.inCraft)
                                {
                                    goto Label_0992;
                                }
                                tinkerStopAt = 2;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0946;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 6: //t3
                                if (!this.inCraft)
                                {
                                    goto Label_0A27;
                                }
                                tinkerStopAt = 3;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_09DB;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 7: //t4
                                if (!this.inCraft)
                                {
                                    goto Label_0ABC;
                                }
                                tinkerStopAt = 4;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0A70;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 8: //t5
                                if (!this.inCraft)
                                {
                                    goto Label_0B51;
                                }
                                tinkerStopAt = 5;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0B05;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 9: //t6
                                if (!this.inCraft)
                                {
                                    goto Label_0BE6;
                                }
                                tinkerStopAt = 6;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0B9A;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 10: //t7
                                if (!this.inCraft)
                                {
                                    goto Label_0C7B;
                                }
                                tinkerStopAt = 7;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0C2F;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 11: //t8
                                if (!this.inCraft)
                                {
                                    goto Label_0D10;
                                }
                                tinkerStopAt = 8;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0CC4;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 12: //t9
                                if (!this.inCraft)
                                {
                                    goto Label_0DA6;
                                }
                                tinkerStopAt = 9;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0D5A;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 13: //t10
                                if (!this.inCraft)
                                {
                                    goto Label_0E39;
                                }
                                tinkerStopAt = 10;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0DF0;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 14: //primary
                                tellPortalFailure();
                                return;

                            case 15: //secondary
                                tellPortalFailure();
                                return;
                        }
                    }
                }
                goto Label_0E61;
            Label_085B:
                if (inCraft)
                {
                    _State = "Idle";
                    _waitTimer = 0;
                    craftingDoWork();
                }
                return;
            Label_08B1:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_08FD:
                clsMessageWriter.Write_Split_Message(debugFile, "T1 command received at invalid time.");
                debugOutput();
                return;
            Label_0946:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0992:
                clsMessageWriter.Write_Split_Message(debugFile, "T2 command received at invalid time.");
                debugOutput();
                return;
            Label_09DB:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0A27:
                clsMessageWriter.Write_Split_Message(debugFile, "T3 command received at invalid time.");
                debugOutput();
                return;
            Label_0A70:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0ABC:
                clsMessageWriter.Write_Split_Message(debugFile, "T4 command received at invalid time.");
                debugOutput();
                return;
            Label_0B05:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0B51:
                clsMessageWriter.Write_Split_Message(debugFile, "T5 command received at invalid time.");
                debugOutput();
                return;
            Label_0B9A:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0BE6:
                clsMessageWriter.Write_Split_Message(debugFile, "T6 command received at invalid time.");
                debugOutput();
                return;
            Label_0C2F:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0C7B:
                clsMessageWriter.Write_Split_Message(debugFile, "T7 command received at invalid time.");
                debugOutput();
                return;
            Label_0CC4:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0D10:
                clsMessageWriter.Write_Split_Message(debugFile, "T8 command received at invalid time.");
                debugOutput();
                return;
            Label_0D5A:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0DA6:
                clsMessageWriter.Write_Split_Message(debugFile, "T9 command received at invalid time.");
                debugOutput();
                return;
            Label_0DF0:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0E39:
                clsMessageWriter.Write_Split_Message(debugFile, "T10 command received at invalid time.");
                debugOutput();
                return;
            Label_0E61:
                if (Settings.Default.useTier4Rares)
                {
                    if (!processRareCommand(cmd))
                    {
                        tellInvalidCommand();
                    }
                }
                else
                {
                    tellInvalidCommand();
                }
            }
            catch (Exception exception)
            {
                if (_WaitForRecipeName)
                {
                    tellDoNotKnowRecipe(cmd);
                    resetCraftingState();
                }
                else
                {
                    clsMessageWriter.Write_Error(errorLogFile, exception);
                    resetCraftingState();
                }
            }
        }
    }

}
