﻿using System;
using System.IO;
using System.Net;
using System.Threading;

internal class clsGetWebContents
{
    public string sFolderPath;
    private string sContent;

    /// <summary>
    /// Constuctor
    /// </summary>
    public clsGetWebContents()
    {
        sFolderPath = (Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\Paraduck\CraftBot");

    }

    /// <summary>
    /// (a) Returns the path of errorLog.txt
    /// </summary>
    /// <returns></returns>
    public string ErrorLogPath()
    {
        return (this.sFolderPath + @"\errorLog.txt");
    }

    /// <summary>
    /// (a) Gets contents of a HttpWebRequest from the supplied IAsyncResult
    /// </summary>
    /// <param name="aResult">IAsyncResult to get contents from</param>
    private void GetContentFromWeb(IAsyncResult aResult)
    {
        try
        {
            clsWebState asyncState = (clsWebState)aResult.AsyncState;
            HttpWebResponse response = (HttpWebResponse)asyncState.wRequest.EndGetResponse(aResult);
            Stream responseStream = response.GetResponseStream();
            StreamReader reader = new StreamReader(responseStream);
            this.sContent = reader.ReadToEnd();
            response.Close();
            responseStream.Close();
            reader.Close();
            if (response.Headers["last-modified"] != null)
            {
                string text2 = response.Headers["last-modified"];
            }
        }
        catch (Exception exception)
        {
            clsMessageWriter.Write_Error(ErrorLogPath(), exception);
        }
    }

    /// <summary>
    /// (a) Posts String
    /// </summary>
    /// <param name="PostThis">String to Post</param>
    public void PostString(string PostThis)
    {
        try
        {
            WebRequest request = WebRequest.Create(PostThis);
            request.Method = "POST";
            //request.= 512;
            object obj2 = new object();
            clsWebState state = new clsWebState(request, obj2, PostThis);
            ThreadPool.RegisterWaitForSingleObject(request.BeginGetResponse(new AsyncCallback(this.GetContentFromWeb), state).AsyncWaitHandle, new WaitOrTimerCallback(this.a), state, 0xea60, true);
        }
        catch (Exception exception)
        {
            clsMessageWriter.Write_Error(ErrorLogPath(), exception);
        }
    }

    /// <summary>
    /// Gets string data
    /// </summary>
    /// <param name="PostThis">String to Post</param>
    public void GetString(string PostThis)
    {
        try
        {
            WebRequest request = WebRequest.Create(PostThis);
            request.Method = "GET";
            //request.= 512;
            object obj2 = new object();
            clsWebState state = new clsWebState(request, obj2, PostThis);
            ThreadPool.RegisterWaitForSingleObject(request.BeginGetResponse(new AsyncCallback(this.GetContentFromWeb), state).AsyncWaitHandle, new WaitOrTimerCallback(this.a), state, 0xea60, true);
        }
        catch (Exception exception)
        {
            clsMessageWriter.Write_Error(ErrorLogPath(), exception);
        }
    }

    /// <summary>
    /// (a) Forces clsWebState to time out
    /// </summary>
    /// <param name="A_0"></param>
    /// <param name="A_1"></param>
    private void a(object wState, bool ShouldAbort)
    {
        try
        {
            if (ShouldAbort)
            {
                clsWebState WebState = (clsWebState)wState;
                if (WebState != null)
                {
                    WebState.wRequest.Abort();
                }
                sContent = "Connection timed out.";
            }
        }
        catch (Exception exception)
        {
            clsMessageWriter.Write_Error(ErrorLogPath(), exception);
        }
    }

    /// <summary>
    /// (b) Sets sContent to null
    /// </summary>
    public void SetContentToNull()
    {
        try
        {
            sContent = null;
        }
        catch (Exception exception)
        {
            clsMessageWriter.Write_Error(ErrorLogPath(), exception);
        }
    }

    /// <summary>
    /// (c) Returns sContent
    /// </summary>
    /// <returns></returns>
    public string GetContent()
    {
        try
        {
            return sContent;
        }
        catch (Exception exception)
        {
            clsMessageWriter.Write_Error(ErrorLogPath(), exception);
            return @"Error. Please see C:\errorLog.txt and report this!";
        }
    }

    /// <summary>
    /// Is used to manage WebRequests
    /// </summary>
    private class clsWebState
    {
        public WebRequest wRequest; //a
        public object oObject;      //b
        public string Message;      //c
        public string sFolderPath;   //d

        public clsWebState(WebRequest webR, object oObj, string sMsg)
        {
            sFolderPath = (Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\Paraduck\CraftBot"); //d
            try
            {
                wRequest = webR;
                oObject = oObj;
                Message = sMsg;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(ErrorLogPath(), exception);
            }
        }

        public string ErrorLogPath()
        {
            return (sFolderPath + @"\errorLog.txt");
        }
    }
}

