﻿using System;
using System.IO;

internal class clsMessageWriter
{
    /// <summary>
    /// (a) Write error message and stack
    /// </summary>
    /// <param name="Filename">Filename</param>
    /// <param name="exErr">Exception</param>
    internal static void Write_Error(string Filename, Exception exErr)
    {
        StreamWriter writer = new StreamWriter(Filename, true);
        writer.WriteLine("============================================================================");
        writer.WriteLine(DateTime.Now.ToString());
        writer.WriteLine("Error: " + exErr.Message);
        writer.WriteLine("Source: " + exErr.Source);
        writer.WriteLine("Stack: " + exErr.StackTrace);
        if (exErr.InnerException != null)
        {
            writer.WriteLine("Inner: " + exErr.InnerException.Message);
            writer.WriteLine("Inner Stack: " + exErr.InnerException.StackTrace);
        }
        writer.WriteLine("============================================================================");
        writer.WriteLine("");
        writer.Close();
    }

    /// <summary>
    /// (b) Write string to file
    /// </summary>
    /// <param name="Filename">Filename</param>
    /// <param name="sMessage">Message</param>
    internal static void Write_Message(string Filename, string sMessage)
    {
        StreamWriter writer = new StreamWriter(Filename, true);
        writer.WriteLine(sMessage);
        writer.Close();
    }

    /// <summary>
    /// (c) Write Date.Now and string to file
    /// </summary>
    /// <param name="Filename">Filename</param>
    /// <param name="sMessage">sMessage</param>
    internal static void Write_Message_And_Time(string Filename, string sMessage)
    {
        StreamWriter writer = new StreamWriter(Filename, true);
        writer.WriteLine(DateTime.Now.ToString() + " -- " + sMessage);
        writer.WriteLine("");
        writer.Close();
    }

    /// <summary>
    /// (d) Write string split on "-=+" to file
    /// </summary>
    /// <param name="Filename">Filename</param>
    /// <param name="sMessage">Message</param>
    internal static void Write_Split_Message(string Filename, string sMessage)
    {
        try
        {
            if (sMessage.Contains("-=+"))
            {
                string[] separator = new string[] { "-=+" };
                string[] strArray2 = new string[250];
                strArray2 = sMessage.Split(separator, StringSplitOptions.RemoveEmptyEntries);
                StreamWriter writer = new StreamWriter(Filename, true);
                writer.WriteLine("============================================================================");
                writer.WriteLine(DateTime.Now.ToString());
                foreach (string str in strArray2)
                {
                    if (strArray2 != null)
                    {
                        writer.WriteLine(str);
                    }
                }
                writer.WriteLine("============================================================================");
                writer.WriteLine("");
                writer.Close();
            }
            else
            {
                StreamWriter writer2 = new StreamWriter(Filename, true);
                writer2.WriteLine("============================================================================");
                writer2.WriteLine(DateTime.Now.ToString());
                writer2.WriteLine(sMessage);
                writer2.WriteLine("============================================================================");
                writer2.WriteLine("");
                writer2.Close();
            }
        }
        catch (Exception)
        {
        }
    }
}

