﻿namespace CraftBot
{
    using CraftBot.Properties;

    using Decal.Adapter;
    using Decal.Adapter.Wrappers;
    using Decal.Filters;
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.IO;
    using System.Reflection;
    using System.Security.Cryptography;
    using System.Text;
    using System.Windows.Forms;
    using System.Xml;
    using System.Xml.XPath;

    [View("CraftBot.ViewXML.mainView.xml"), WireUpControlEvents]
    public class PluginCore : PluginBase
    {
        protected static int BRILLIANCE_DELAY = 30;
        [ControlReference("btnAddReturn")]
        protected PushButtonWrapper btnAddReturn;
        [ControlReference("btnClearMessages")]
        protected PushButtonWrapper btnClearMessages;
        [ControlReference("btnRemoveReturn")]
        protected PushButtonWrapper btnRemoveReturn;
        [ControlReference("chkAlchemy")]
        protected CheckBoxWrapper chkAlchemy;
        [ControlReference("chkArmorTink")]
        protected CheckBoxWrapper chkArmorTink;
        [ControlReference("chkArtisanPet")]
        protected CheckBoxWrapper chkArtisanPet;
        [ControlReference("chkBuffOnStart")]
        protected CheckBoxWrapper chkBuffOnStart;
        [ControlReference("chkBuffsEnabled")]
        protected CheckBoxWrapper chkBuffsEnabled;
        [ControlReference("chkCalcMajors")]
        protected CheckBoxWrapper chkCalcMajors;
        [ControlReference("chkCooking")]
        protected CheckBoxWrapper chkCooking;
        [ControlReference("chkEnabled")]
        protected CheckBoxWrapper chkEnabled;
        [ControlReference("chkEnableMail")]
        protected CheckBoxWrapper chkEnableMail;
        [ControlReference("chkEnterSpamMail")]
        protected CheckBoxWrapper chkEnterSpamMail;
        [ControlReference("chkEnterSpamRare")]
        protected CheckBoxWrapper chkEnterSpamRare;
        [ControlReference("chkEquip")]
        protected CheckBoxWrapper chkEquip;
        [ControlReference("chkFletching")]
        protected CheckBoxWrapper chkFletching;
        [ControlReference("chkItemTink")]
        protected CheckBoxWrapper chkItemTink;
        [ControlReference("chkJourneymanPet")]
        protected CheckBoxWrapper chkJourneymanPet;
        [ControlReference("chkLockpick")]
        protected CheckBoxWrapper chkLockpick;
        [ControlReference("chkLogOff")]
        protected CheckBoxWrapper chkLogOff;
        [ControlReference("chkMagicItemTink")]
        protected CheckBoxWrapper chkMagicItemTink;
        [ControlReference("chkMasterPet")]
        protected CheckBoxWrapper chkMasterPet;
        [ControlReference("chkRareAllegChan")]
        protected CheckBoxWrapper chkRareAllegChan;
        [ControlReference("chkRareTradeChan")]
        protected CheckBoxWrapper chkRareTradeChan;
        [ControlReference("chkTier4Rares")]
        protected CheckBoxWrapper chkTier4Rares;
        [ControlReference("chkUseBeers")]
        protected CheckBoxWrapper chkUseBeers;
        [ControlReference("chkUseBuffBot")]
        protected CheckBoxWrapper chkUseBuffBot;
        [ControlReference("chkUseCharge")]
        protected CheckBoxWrapper chkUseCharge;
        [ControlReference("chkUseRares")]
        protected CheckBoxWrapper chkUseRares;
        [ControlReference("chkUseWeb")]
        protected CheckBoxWrapper chkUseWeb;
        [ControlReference("chkWeaponTink")]
        protected CheckBoxWrapper chkWeaponTink;
        [ControlReference("listMessages")]
        protected ListWrapper listMessages;
        [ControlReference("listReturn")]
        protected ListWrapper listReturn;
        [ControlReference("txtReturnTo")]
        protected TextBoxWrapper txtReturnTo;
        [ControlReference("btnCheckVersion")]
        protected TextBoxWrapper btnCheckVersion;

        protected static int MAX_RARE_COMMANDS = 0x19;
        protected static int EQUIP_MAX_COLS = 15;
        protected static int EQUIP_MAX_ROWS = 9;

        public Timer buffTimer;
        public Queue<CAction> actionQueue;
        public Timer actionTimer;
        public ArrayList activationList;
        public bool charmedSmith;
        public Queue<string> chatQueue;
        public Timer chatTimer;
        public int craftStepNum;
        public string curEquip;
        public string curSkill;
        public string[,] equipList;
        public string finalResult;
        public Timer heartbeat;
        public Timer idleTimer;
        public int idleWeapon;
        public bool ignoreReset = true;
        public bool ignoreTrades;
        public bool inCraft;
        public bool inTrade;
        public bool itemsQueued;
        public string personalFolderPath = (Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\Paraduck\CraftBot");
        public ArrayList rareCommands;
        public ArrayList rareDesc;
        public ArrayList rareRecipeList;
        public Timer rareTimer;
        public ArrayList recipeList;
        public string RecipeName;
        public bool returnItems;
        public List<Salvage> sortedSalvage;
        public Timer spamTimer;
        public int tinkerCount;
        public int tinkerCountCopy;
        public ArrayList tinkerIgnoreIIDs;
        public WorldObject tinkeringTarget;
        public int tinkerStopAt;
        public WorldObject trader;
        public bool waitForBrill;
        public Timer webTimer;
        public WorldObject[] wObjResult;
        public ArrayList wObjTrade;

        private int _nonTinkRepeatTimes;
        private string _tellPerson;
        private bool _lowCompsMessageSent;
        private bool _lowCompsMessageSentUntargeted;
        private bool _lowManaSent;
        private string _State = "Idle";
        private string _waitFor = "None";
        private bool _byPassCheck;
        private int _waitTimer;
        private bool _lookForCharge;
        private ArrayList _UseItems;
        private ArrayList _onItems;
        private ArrayList _ResultItems;
        private ArrayList _SkillChecks;
        private string _activateItem;
        private bool _ignoreApply;
        private bool _bt;
        private bool _isRareCraft;
        private bool _waitForAccept;
        private bool _craftIncremented;
        private bool _ignoreGo;
        private bool _ignoreYes;
        private bool _noManaChargeSent;
        private bool _lookForRares;
        private bool _isEnabled;
        private ArrayList _returnObjects;
        private double _faceHeading;
        private ArrayList _createdItems;
        private Dictionary<string, int> _dictionaryCmds;
        private Dictionary<string, int> _dictionaryCmds2;
        private Dictionary<string, int> _dictionaryCmds3;

        private const double _a = 1.0;
        private const int _a0 = 20;
        private const int _a1 = 11;
        private const int _a2 = 20;
        private const int _a3 = 12;
        private const int _a4 = 20;
        private const int _a5 = 12;
        private const int _a6 = 10;
        private const int _a7 = 20;
        private const int _a8 = 11;
        private const int _a9 = 20;
        private const int _aa = 11;
        private const int _ab = 12;
        private const int _ac = 12;
        private const int _ad = 0x19;
        private const int _ae = 15;
        private const int _af = 12;
        private const int _ag = 20;
        private const int _ah = 20;
        private const int _ai = 20;
        private const int _aj = 0x19;
        private const int _ak = 0x19;
        private const int _al = 0x19;
        private const int _am = 20;
        private const int _an = 0x19;
        private const int _ao = 12;
        private const int _ap = 0x19;
        private const int _aq = 0x19;
        private const int _ar = 0x19;
        private const int @_as = 11;
        private const int _at = 0x19;
        private const int _au = 0x19;
        private const int _av = 0x19;
        private const int _aw = 20;
        private const int _ax = 20;
        private const int _ay = 20;
        private const int _az = 11;
        private const double _b = 1.1;
        private string _b0;
        private int _b2;
        private int _b3 = 5;
        private static string _b4 = "[CraftBot]";
        private static string _b5 = " -b-";
        private int _bf;
        private XmlDocument _XmlDoc;
        private XmlNodeList _bi;
        private bool _WaitForRecipeName;
        private ArrayList _recipeItems;
        private int _craftStepCount;
        private const double _c = 1.3;
        private string _versionCheckingPath = "http://www.firesickle.com/craftbot/craftbot.php?mode=version&version=";
        private string _c3 = "release";
        private string _currentLocation = "Unknown";
        private bool _isSendingMail;
        private string _mailReturnPlayer;
        private string _mailFromPlayer;
        private ArrayList _c8;
        private bool _c9;
        private bool _cb;
        private bool _cc;
        private string _cd = "key=JS(@naO0+sjm+*2a=3Map2Mapqm!amA";
        private static string[] _RareList = new string[] { "Alchemist's Crystal", "Smithy's Crystal", "Chef's Crystal", "Fletcher's Crystal", "Tinker's Crystal", "Imbuer's Crystal", "Artist's Crystal", "Thief's Crystal", "Lugian's Pearl", "Ursuin's Pearl", "Wayfarer's Pearl", "Magus's Pearl" };
        private ArrayList _buffList;
        private ArrayList _ck;
        private ArrayList _RecipeList;
        private bool _cn;
        private Random _RandomObj;
        private ArrayList _cp;
        private clsGetWebContents _WebReq;
        private static string[] _cs = new string[] { "Tusker Spit Ale", "Amber Ape", "Apothecary Zongo's Stout", "Hunter's Stock Amber" };
        private int _buffWand;
        private int _primaryPortalSpellId;
        private int _secondaryPortalSpellId;
        private string _primaryPortalLocation;
        private string _secondaryPortalLocation;
        private bool _isBuffing;
        private string _cz = "http://craftbot.acvault.ign.com/processor/heartbeat.php?";
        private const double _d = 1.6;
        private const double _e = 2.0;
        private const double _f = 2.5;
        private const double _g = 3.0;
        private const double _h = 3.5;
        private const double _i = 4.0;
        private const double _j = 4.5;
        private const int _k = 11;
        private const int _l = 11;
        private const int _m = 11;
        private const int _n = 11;
        private const int _o = 11;
        private const int _p = 20;
        private const int _q = 11;
        private const int _r = 12;
        private const int _s = 11;
        private const int _t = 20;
        private const int _u = 20;
        private const int _v = 15;
        private const int _w = 12;
        private const int _x = 10;
        private const int _y = 11;
        private const int _z = 11;

        private bool _sayDebugMessages = false;

        private int _bc;
        private bool _bj;
        private bool _givenGo;
        private string _c0 = "http://craftbot.acvault.ign.com/processor/info_processor.php?";
        private string _c2 = "http://craftbot.acvault.ign.com/processor/location_processor.php?";
        private bool _queBuff;

        private enum Salvages
        {
            Agate =	10,
            Alabaster =	66,
            Amber =	11,
            Amethyst =	12,
            Aquamarine 	=13,
            Armoredillo_Hide =	53,
            Azurite =	14,
            Black_Garnet =	15,
            Black_Opal =	16,
            Bloodstone 	=17,
            Brass =	57,
            Bronze =	58,
            Carnelian =	18,
            Ceramic =	1,
            Citrine =	19,
            Copper 	=59,
            Diamond =	20,
            Ebony =	73,
            Emerald 	=21,
            Fire_Opal =	22,
            Gold =	60,
            Granite 	=67,
            Green_Garnet =	23,
            Green_Jade =	24,
            Gromnie_Hide =	54,
            Hematite =	25,
            Imperial_Topaz =	26,
            Iron 	=61,
            Ivory =	51,
            Jet 	=27,
            Lapis_Lazuli =	28,
            Lavender_Jade =	29,
            Leather 	=52,
            Linen =	4,
            Mahogany =	74,
            Malachite =	30,
            Marble= 	68,
            Moonstone 	=31,
            Oak =	75,
            Obsidian 	=69,
            Onyx 	=32,
            Opal =	33,
            Peridot 	=34,
            Pine 	=76,
            Porcelain 	=2,
            Pyreal =	62,
            Red_Garnet =	35,
            Red_Jade =	36,
            Reed_Shark_Hide =	55,
            Rose_Quartz =	37,
            Ruby =	38,
            Sandstone =	70,
            Sapphire =	39,
            Satin =	5,
            Serpentine =	71,
            Silk 	=6,
            Silver =	63,
            Smokey_Quartz =	40,
            Steel 	=64,
            Sunstone 	=41,
            Teak 	=77,
            Tiger_Eye =	42,
            Tourmaline =	43,
            Turquoise =	44,
            Velvet =	7,
            White_Jade =	45,
            White_Quartz =	46,
            White_Sapphire =	47,
            Wool =	8,
            Yellow_Garnet =	48,
            Yellow_Topaz =	49,
            Zircon =	50
        }

        #region ControlEvents

        [ControlEvent("chkEnterSpamRare", "Change")]
        private void chkEnterSpamRare_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.enterSpamRares)
            {
                Settings.Default.enterSpamRares = chkEnterSpamRare.Checked;
                Settings.Default.Save();
                WriteToChat("Bot will no longer advertise the tier 4 rares feature outside of the help command.");
            }
            else if (_cn)
            {
                Settings.Default.enterSpamRares = chkEnterSpamRare.Checked;
                Settings.Default.Save();
                WriteToChat("Bot will now advertise the tier 4 rares feature to people who open the trade window.");
            }
            else
            {
                WriteToChat("This feature cannot be enabled as the bot does not know any tier 4 rare recipes!");
            }
        }

        [ControlEvent("btnRemoveReturn", "Click")]
        private void btnRemoveReturn_Click(object A_0, Decal.Adapter.ControlEventArgs A_1)
        {
            try
            {
                ReturnObject rtnObj = null;
                foreach (ReturnObject obj in _returnObjects)
                {
                    if (((obj != null) && (base.Host.Actions.CurrentSelection != 0)) && ((base.Core.WorldFilter[base.Host.Actions.CurrentSelection] != null) && (obj.getID() == base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Id)))
                    {
                        rtnObj = obj;
                        break;
                    }
                }
                if (rtnObj != null)
                {
                    deleteReturnItem(riFile, rtnObj);
                    WriteToChat(base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Name + " has been removed from the return item list.");
                }
                else
                {
                    WriteToChat("Error: Could not find " + base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Name + "!");
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        [ControlEvent("listReturn", "Selected")]
        private void listReturn_Selected(object A_0, ListSelectEventArgs A_1)
        {
            try
            {
                WriteToChat(string.Concat(new object[] { "Person: ", listReturn[A_1.Row][0][0], " Item to Return: ", listReturn[A_1.Row][1][0], " Added: ", listReturn[A_1.Row][2][0] }));
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        [ControlEvent("chkTier4Rares", "Change")]
        private void chkTier4Rares_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useTier4Rares)
            {
                Settings.Default.useTier4Rares = chkTier4Rares.Checked;
                Settings.Default.Save();
                WriteToChat("Tier 4 Rare Use is now disabled.");
            }
            else
            {
                Settings.Default.useTier4Rares = chkTier4Rares.Checked;
                Settings.Default.Save();
                WriteToChat("Tier 4 Rare Use is now enabled.");
            }
        }

        [ControlEvent("chkLockpick", "Change")]
        private void chkLockpick_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useLockpick)
            {
                Settings.Default.useLockpick = chkLockpick.Checked;
                Settings.Default.Save();
                WriteToChat("Lockpick is now disabled.");
            }
            else
            {
                Settings.Default.useLockpick = chkLockpick.Checked;
                Settings.Default.Save();
                WriteToChat("Lockpick is now enabled.");
            }
        }

        [ControlEvent("chkFletching", "Change")]
        private void chkFletch_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useFletching)
            {
                Settings.Default.useFletching = chkFletching.Checked;
                Settings.Default.Save();
                WriteToChat("Fletching is now disabled.");
            }
            else
            {
                Settings.Default.useFletching = chkFletching.Checked;
                Settings.Default.Save();
                WriteToChat("Fletching is now enabled.");
            }
        }

        [ControlEvent("chkCooking", "Change")]
        private void chkCooking_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useCooking)
            {
                Settings.Default.useCooking = chkCooking.Checked;
                Settings.Default.Save();
                WriteToChat("Cooking is now disabled.");
            }
            else
            {
                Settings.Default.useCooking = chkCooking.Checked;
                Settings.Default.Save();
                WriteToChat("Cooking is now enabled.");
            }
        }

        [ControlEvent("chkAlchemy", "Change")]
        private void chkAlchemy_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useAlchemy)
            {
                Settings.Default.useAlchemy = chkAlchemy.Checked;
                Settings.Default.Save();
                WriteToChat("Alchemy is now disabled.");
            }
            else
            {
                Settings.Default.useAlchemy = chkAlchemy.Checked;
                Settings.Default.Save();
                WriteToChat("Alchemy is now enabled.");
            }
        }

        [ControlEvent("chkWeaponTink", "Change")]
        private void chkWeaponTink_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useWeaponTinkering)
            {
                Settings.Default.useWeaponTinkering = chkWeaponTink.Checked;
                Settings.Default.Save();
                WriteToChat("Weapon Tinkering is now disabled.");
            }
            else
            {
                Settings.Default.useWeaponTinkering = chkWeaponTink.Checked;
                Settings.Default.Save();
                WriteToChat("Weapon Tinkering is now enabled.");
            }
        }

        [ControlEvent("chkMagicItemTink", "Change")]
        private void chkMagicItemTink_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useMagicItemTinkering)
            {
                Settings.Default.useMagicItemTinkering = chkMagicItemTink.Checked;
                Settings.Default.Save();
                WriteToChat("Magic Item Tinkering is now disabled.");
            }
            else
            {
                Settings.Default.useMagicItemTinkering = chkMagicItemTink.Checked;
                Settings.Default.Save();
                WriteToChat("Magic Item Tinkering is now enabled.");
            }
        }

        [ControlEvent("chkItemTink", "Change")]
        private void chkItemTink_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useItemTinerking)
            {
                Settings.Default.useItemTinerking = chkItemTink.Checked;
                Settings.Default.Save();
                WriteToChat("Item Tinkering is now disabled.");
            }
            else
            {
                Settings.Default.useItemTinerking = chkItemTink.Checked;
                Settings.Default.Save();
                WriteToChat("Item Tinkering is now enabled.");
            }
        }

        [ControlEvent("txtReturnTo", "End")]
        private void txtReturnTo_End(object A_0, TextBoxEndEventArgs A_1)
        {
            try
            {
                if (((txtReturnTo.Text != null) && !this.txtReturnTo.Text.Equals("")) && !this.txtReturnTo.Text.Equals(" "))
                {
                    txtReturnTo.Text = txtReturnTo.Text.Trim();
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        [ControlEvent("chkEnterSpamMail", "Change")]
        private void chkEnterSpamMail_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.enterSpamMail)
            {
                Settings.Default.enterSpamMail = chkEnterSpamMail.Checked;
                Settings.Default.Save();
                WriteToChat("Bot will no longer advertise the mail feature outside of the help command.");
            }
            else if (Settings.Default.useMail)
            {
                Settings.Default.enterSpamMail = chkEnterSpamMail.Checked;
                Settings.Default.Save();
                WriteToChat("Bot will now advertise the mail feature to people who open the trade window.");
            }
            else
            {
                WriteToChat("Mail is not enabled! Please enable it before specifiying to advertise it.");
            }
        }

        [ControlEvent("btnAddReturn", "Click")]
        private void btnAddReturn_Click(object A_0, Decal.Adapter.ControlEventArgs A_1)
        {
            try
            {
                if (((txtReturnTo.Text == null) || txtReturnTo.Text.Equals("")) || txtReturnTo.Text.Equals(" "))
                {
                    WriteToChat("Error: Player name missing!");
                }
                else if (base.Core.WorldFilter[base.Host.Actions.CurrentSelection] == null)
                {
                    WriteToChat("Object reference is null. This item cannot be returned at this time.");
                }
                else
                {
                    WorldObjectCollection inventory = base.Core.WorldFilter.GetInventory();
                    bool flag = false;
                    foreach (WorldObject obj2 in inventory)
                    {
                        if (base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Id == obj2.Id)
                        {
                            flag = true;
                            break;
                        }
                    }
                    if (!flag)
                    {
                        WriteToChat("Error: " + base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Name + " is not in your inventory!");
                    }
                    else
                    {
                        writeReturnItem(riFile, new ReturnObject(base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Id, txtReturnTo.Text.Trim().ToLower()));
                        WriteToChat(base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Name + " will be returned to " + txtReturnTo.Text.Trim().ToLower() + " when they next open a trade window.");
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        [ControlEvent("listMessages", "Selected")]
        private void listMessages_Selected(object A_0, ListSelectEventArgs A_1)
        {
            try
            {
                WriteToChat(string.Concat(new object[] { "Sender: ", listMessages[A_1.Row][0][0], " Message: ", listMessages[A_1.Row][1][0], " Time: ", listMessages[A_1.Row][2][0] }));
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        [ControlEvent("chkArmorTink", "Change")]
        private void chkArmorTink_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useArmorTinkering)
            {
                Settings.Default.useArmorTinkering = chkArmorTink.Checked;
                Settings.Default.Save();
                WriteToChat("Armor Tinkering is now disabled.");
            }
            else
            {
                Settings.Default.useArmorTinkering = chkArmorTink.Checked;
                Settings.Default.Save();
                WriteToChat("Armor Tinkering is now enabled.");
            }
        }

        [ControlEvent("chkEnabled", "Change")]
        private void chkEnabled_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            try
            {
                if (_isEnabled)
                {
                    _isEnabled = false;
                    rareTimer.Stop();
                    actionTimer.Stop();
                    resetCraftingState();
                }
                else
                {
                    _isEnabled = true;
                    _faceHeading = base.Host.Actions.Heading;
                    initTimers();
                    if (Settings.Default.useBuffs && Settings.Default.rebuffOnStart)
                    {
                        buff();
                    }
                    if (Settings.Default.useWeb)
                    {
                        loadRecipes(personalFolderPath + @"\recipes.xml");
                        sendBotInfo();
                    }
                    int num = 0;
                    foreach (WorldObject wldObj in base.Core.WorldFilter.GetByContainer(base.Core.CharacterFilter.Id))
                    {
                        if ((!wldObj.ObjectClass.Equals((ObjectClass)10) && !wldObj.ObjectClass.Equals((ObjectClass)0x26)) && (wldObj.Values(LongValueKey.EquippedSlots) <= 0))
                        {
                            num++;
                        }
                    }
                    if ((num >= 90) && Settings.Default.useMail)
                    {
                        clsMessageWriter.Write_Split_Message(debugFile, "Only 12 pack slots left! Disabling mail...");
                        WriteToChat("Low on pack space! Disabling mail.");
                        Settings.Default.useMail = false;
                        chkEnableMail.Checked = false;
                        Settings.Default.recoverMail = true;
                    }
                    else if ((num < 90) && Settings.Default.recoverMail)
                    {
                        WriteToChat("Mail was previously enabled and there are more than 12 slots in the main pack free! Enabling mail...");
                        clsMessageWriter.Write_Split_Message(debugFile, "Re-enabling mail due to free pack space.");
                        Settings.Default.useMail = true;
                        chkEnableMail.Checked = false;
                        Settings.Default.recoverMail = false;
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        [ControlEvent("chkCalcMajors", "Change")]
        private void chkCalcMagors_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useMajorsForSkillCheck)
            {
                Settings.Default.useMajorsForSkillCheck = chkCalcMajors.Checked;
                Settings.Default.Save();
                WriteToChat("Majors will no longer be used in skill checks.");
            }
            else
            {
                Settings.Default.useMajorsForSkillCheck = chkCalcMajors.Checked;
                Settings.Default.Save();
                WriteToChat("Majors will now be used in skill checks.");
            }
        }

        [ControlEvent("chkJourneymanPet", "Change")]
        private void chkJourneymanPet_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useJourneymanPetsSkillChecks)
            {
                Settings.Default.useJourneymanPetsSkillChecks = chkJourneymanPet.Checked;
                Settings.Default.Save();
                WriteToChat("Journeyman Pets (+10) will no longer be used in skill checks.");
            }
            else
            {
                Settings.Default.useJourneymanPetsSkillChecks = chkJourneymanPet.Checked;
                Settings.Default.useMasterPetsSkillCheck = false;
                chkMasterPet.Checked = false;
                Settings.Default.useArtisanPetsSkillCheck = false;
                chkArtisanPet.Checked = false;
                Settings.Default.Save();
                WriteToChat("Journeyman Pets (+10) will now be used in skill checks.");
            }
        }

        [ControlEvent("chkMasterPet", "Change")]
        private void chkMasterPet_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useMasterPetsSkillCheck)
            {
                Settings.Default.useMasterPetsSkillCheck = chkMasterPet.Checked;
                Settings.Default.Save();
                WriteToChat("Master Pets (+20) will no longer be used in skill checks.");
            }
            else
            {
                Settings.Default.useMasterPetsSkillCheck = chkMasterPet.Checked;
                Settings.Default.useJourneymanPetsSkillChecks = false;
                chkJourneymanPet.Checked = false;
                Settings.Default.useArtisanPetsSkillCheck = false;
                chkArtisanPet.Checked = false;
                Settings.Default.Save();
                WriteToChat("Master Pets (+20) will now be used in skill checks.");
            }
        }

        [ControlEvent("chkArtisanPet", "Change")]
        private void chkArtisanPet_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useArtisanPetsSkillCheck)
            {
                Settings.Default.useArtisanPetsSkillCheck = chkArtisanPet.Checked;
                Settings.Default.Save();
                WriteToChat("Artisan Pets (+30) will no longer be used in skill checks.");
            }
            else
            {
                Settings.Default.useArtisanPetsSkillCheck = chkArtisanPet.Checked;
                Settings.Default.useJourneymanPetsSkillChecks = false;
                chkJourneymanPet.Checked = false;
                Settings.Default.useMasterPetsSkillCheck = false;
                chkMasterPet.Checked = false;
                Settings.Default.Save();
                WriteToChat("Artisan Pets (+30) will now be used in skill checks.");
            }
        }

        [ControlEvent("chkBuffsEnabled", "Change")]
        private void chkBuffsEnabled_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useBuffs)
            {
                Settings.Default.useBuffs = chkBuffsEnabled.Checked;
                Settings.Default.Save();
                WriteToChat("Buffing is now disabled.");
            }
            else
            {
                Settings.Default.useBuffs = chkBuffsEnabled.Checked;
                Settings.Default.Save();
                WriteToChat("Buffing is now enabled.");
            }
        }

        [ControlEvent("chkBuffOnStart", "Change")]
        private void chkBuffOnStart_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.rebuffOnStart)
            {
                Settings.Default.rebuffOnStart = chkBuffOnStart.Checked;
                Settings.Default.Save();
                WriteToChat("Rebuffing when the bot starts is now disabled.");
            }
            else
            {
                Settings.Default.rebuffOnStart = chkBuffOnStart.Checked;
                Settings.Default.Save();
                WriteToChat("Rebuffing when the bot starts is now enabled.");
            }
        }

        [ControlEvent("chkUseBeers", "Change")]
        private void chkUseBeers_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useBeers)
            {
                Settings.Default.useBeers = chkUseBeers.Checked;
                Settings.Default.Save();
                WriteToChat("Beers are now disabled.");
            }
            else
            {
                Settings.Default.useBeers = chkUseBeers.Checked;
                Settings.Default.Save();
                WriteToChat("Beers are now enabled.");
            }
        }

        [ControlEvent("chkUseRares", "Change")]
        private void chkUseRares_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useBuffRares)
            {
                Settings.Default.useBuffRares = chkUseRares.Checked;
                Settings.Default.Save();
                WriteToChat("Buffing Rares are now disabled.");
            }
            else
            {
                Settings.Default.useBuffRares = chkUseRares.Checked;
                Settings.Default.Save();
                WriteToChat("Buffing Rares are now enabled.");
            }
        }

        [ControlEvent("chkUseBuffBot", "Change")]
        private void chkUseBuffBot_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useBuffBot)
            {
                Settings.Default.useBuffBot = chkUseBuffBot.Checked;
                Settings.Default.Save();
                WriteToChat("Buff Bot use is now disabled.");
            }
            else
            {
                Settings.Default.useBuffBot = chkUseBuffBot.Checked;
                Settings.Default.Save();
                WriteToChat("Buff Bot use is now enabled.");
            }
        }

        [ControlEvent("chkLogOff", "Change")]
        private void chkLogOff_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.logoffOnMonsterDetect)
            {
                Settings.Default.logoffOnMonsterDetect = chkLogOff.Checked;
                Settings.Default.Save();
                WriteToChat("Log Off on Monster Detection is now disabled.");
            }
            else
            {
                Settings.Default.logoffOnMonsterDetect = chkLogOff.Checked;
                Settings.Default.Save();
                WriteToChat("Log Off on Monster Detection is now enabled.");
            }
        }

        [ControlEvent("chkUseCharge", "Change")]
        private void chkUseCharge_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useManaStones)
            {
                Settings.Default.useManaStones = chkUseCharge.Checked;
                Settings.Default.Save();
                WriteToChat("Mana Stones and Charges are now disabled.");
            }
            else
            {
                Settings.Default.useManaStones = chkUseCharge.Checked;
                Settings.Default.Save();
                WriteToChat("Mana Stones and Charges are now enabled.");
            }
        }

        [ControlEvent("chkEquip", "Change")]
        private void chkEquip_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.equipItems)
            {
                Settings.Default.equipItems = chkEquip.Checked;
                Settings.Default.Save();
                WriteToChat("Equipping/Dequipping Items is now disabled.");
            }
            else
            {
                Settings.Default.equipItems = chkEquip.Checked;
                Settings.Default.Save();
                WriteToChat("Equipping/Dequipping Items is now enabled.");
            }
        }

        [ControlEvent("chkRareTradeChan", "Change")]
        private void chkRareTradeChan_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.rareBroadcastToTradeChan)
            {
                Settings.Default.rareBroadcastToTradeChan = chkRareTradeChan.Checked;
                Settings.Default.Save();
                WriteToChat("You will no longer broadcast rare gem usage to the Trade channel.");
            }
            else
            {
                Settings.Default.rareBroadcastToTradeChan = chkRareTradeChan.Checked;
                Settings.Default.Save();
                WriteToChat("You will now broadcast rare gem usage to the Trade channel.");
            }
        }

        [ControlEvent("chkEnableMail", "Change")]
        private void chkEnableMail_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useMail)
            {
                Settings.Default.useMail = chkEnableMail.Checked;
                Settings.Default.recoverMail = false;
                Settings.Default.Save();
                WriteToChat("New mail requests will no longer be processed. Existing mail items will be returned, however.");
            }
            else
            {
                Settings.Default.useMail = chkEnableMail.Checked;
                Settings.Default.Save();
                WriteToChat("New mail requests will now be processed.");
            }
        }

        [ControlEvent("btnClearMessages", "Click")]
        private void btnClearMessages_Click(object A_0, Decal.Adapter.ControlEventArgs A_1)
        {
            try
            {
                clearMessages(personalFolderPath + @"\messages.xml");
                WriteToChat("Messages cleared.");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        [ControlEvent("chkRareAllegChan", "Change")]
        private void chkRareAllegChan_Click(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.rareBroadcastToAllegianceChan)
            {
                Settings.Default.rareBroadcastToAllegianceChan = chkRareAllegChan.Checked;
                Settings.Default.Save();
                WriteToChat("You will no longer broadcast rare gem usage to the Allegiance chat channel.");
            }
            else
            {
                Settings.Default.rareBroadcastToAllegianceChan = chkRareAllegChan.Checked;
                Settings.Default.Save();
                WriteToChat("You will now broadcast rare gem usage to the Allegiance chat channel.");
            }
        }

        [ControlEvent("chkUseWeb", "Change")]
        private void chkUseWeb_Change(object A_0, CheckBoxChangeEventArgs A_1)
        {
            if (Settings.Default.useWeb)
            {
                Settings.Default.useWeb = chkUseWeb.Checked;
                Settings.Default.Save();
                WriteToChat("You will no longer appear as online or send stats to the CraftBot website.");
            }
            else
            {
                Settings.Default.useWeb = chkUseWeb.Checked;
                Settings.Default.Save();
                WriteToChat("You will now appear on the CraftBot website the next time you start the bot.");
            }
        }

        [ControlEvent("btnCheckVersion", "Click")]
        private void btnCheckVersion_Click(object A_0, Decal.Adapter.ControlEventArgs A_1)
        {
            try
            {
                checkVersion();
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

#endregion

        #region Static

        private static string ByteToString(byte[] A_0)
        {
            return BitConverter.ToString(new MD5CryptoServiceProvider().ComputeHash(A_0)).Replace("-", "").ToLower();
        }

        public static string initActions(string s1, string s2)
        {
            string s = ByteToString(Encoding.ASCII.GetBytes(s2)).Substring(0, 0x18);
            s1 = s1.Trim();
            ASCIIEncoding encoding = new ASCIIEncoding();
            TripleDES edes = TripleDES.Create();
            edes.Padding = PaddingMode.Zeros;
            edes.Mode = CipherMode.ECB;
            edes.Key = encoding.GetBytes(s);
            edes.GenerateIV();
            MemoryStream stream = new MemoryStream();
            CryptoStream stream2 = new CryptoStream(stream, edes.CreateEncryptor(), CryptoStreamMode.Write);
            stream2.Write(encoding.GetBytes(s1), 0, encoding.GetByteCount(s1));
            stream2.FlushFinalBlock();
            byte[] inArray = stream.ToArray();
            stream.Close();
            stream2.Close();
            return Convert.ToBase64String(inArray, 0, inArray.GetLength(0)).Trim();
        }

#endregion

        #region StartupShutdown

        protected override void Startup()
        {
            try
            {
                _WebReq = new clsGetWebContents();
                recipeList = new ArrayList();
                rareRecipeList = new ArrayList();
                activationList = new ArrayList();
                tinkerIgnoreIIDs = new ArrayList();
                _recipeItems = new ArrayList();
                _returnObjects = new ArrayList();
                _ck = new ArrayList();
                loadDefaultSettings();
                _cp = new ArrayList();
                _createdItems = new ArrayList();
                _RandomObj = new Random();
                _buffList = new ArrayList();
                equipList = new string[EQUIP_MAX_ROWS, EQUIP_MAX_COLS];
                actionQueue = new Queue<CAction>();
                chatQueue = new Queue<string>();
                wObjTrade = new ArrayList();
                _UseItems = new ArrayList();
                _onItems = new ArrayList();
                _ResultItems = new ArrayList();
                _SkillChecks = new ArrayList();
                sortedSalvage = new List<Salvage>();
                rareCommands = new ArrayList();
                rareDesc = new ArrayList();
                _RecipeList = new ArrayList();
                buffTimer = new Timer();
                rareTimer = new Timer();
                actionTimer = new Timer();
                idleTimer = new Timer();
                spamTimer = new Timer();
                webTimer = new Timer();
                heartbeat = new Timer();
                chatTimer = new Timer();
                webTimer.Interval = 0x3e8;
                webTimer.Tick += new EventHandler(WebRequestSuccessful);
                //webTimer.Start();
                //checkVersion();
                addLoggingEvents();
                addTradeEvents();
                addChatParses();
                addServerDispatchEvent();
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        protected override void Shutdown()
        {
            try
            {
                Settings.Default.Save();
                removeChatParses();
                removeLogoffEvents();
                removeTradeEvents();
                removeServerDispatchEvent();
                _RandomObj = null;
                _buffList = null;
                equipList = null;
                actionQueue = null;
                chatQueue = null;
                rareCommands = null;
                rareDesc = null;
                _returnObjects = null;
                _ck = null;
                buffTimer.Stop();
                rareTimer.Stop();
                actionTimer.Stop();
                idleTimer.Stop();
                spamTimer.Stop();
                webTimer.Stop();
                heartbeat.Stop();
                chatTimer.Stop();
                _WebReq = null;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

#endregion

        #region PrivateVoids

        /// <summary>
        /// (a)(ChatParserInterceptEventArgs)
        /// This Pases the user's typed text and does logic based on it
        /// </summary>
        /// <param name="A_0"></param>
        /// <param name="A_1"></param>
        private void ParsePlayerInput(object A_0, ChatParserInterceptEventArgs ChatParser)
        {
            try
            {
                string str = ChatParser.Text.Substring(0, 1);
                if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("cb iid"))
                {
                    ChatParser.Eat = true;
                    int curSelect = base.Host.Actions.CurrentSelection;
                    if (curSelect != 0)
                    {
                        WriteToChat(base.Core.WorldFilter[curSelect].Name + " has an IID of " + curSelect);
                    }
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("cb btest"))
                {
                    ChatParser.Eat = true;
                    int numItems = 0;
                    foreach (WorldObject obj2 in base.Core.WorldFilter.GetByContainer(base.Core.CharacterFilter.Id))
                    {
                        if ((!obj2.ObjectClass.Equals((ObjectClass)10) && !obj2.ObjectClass.Equals((ObjectClass)0x26)) && (obj2.Values(LongValueKey.EquippedSlots) <= 0))
                        {
                            numItems++;
                        }
                    }
                    WriteToChat("Number of items in main pack: " + numItems);
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("cb buff"))
                {
                    ChatParser.Eat = true;
                    if (Settings.Default.useBuffs)
                    {
                        buffEvent(A_0, (EventArgs)ChatParser);
                    }
                    else
                    {
                        WriteToChat("You do not have buffing enabled!");
                    }
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("cb help"))
                {
                    ChatParser.Eat = true;
                    Assembly executingAssembly = Assembly.GetExecutingAssembly();
                    WriteToChat("CraftBot Help");
                    WriteToChat("----------------------------------------");
                    WriteToChat("COMMANDS");
                    WriteToChat("/cb buff - Forces a rebuff.");
                    WriteToChat("/cb iid - Gets the IID of the currently selected item. For use in configuration.");
                    WriteToChat("/cb getspelllist - Saves a list of all spells in the game to " + personalFolderPath + @"\spells.txt.");
                    WriteToChat("/cb return playername - Tells the bot to return the currently selected item to the passed playername. This will be in effect until the item is returned.");
                    WriteToChat("/cb start - Starts the bot.");
                    WriteToChat("/cb stop - Stops the bot.");
                    WriteToChat("/cb vr - Displays the conents of the return item list.");
                    WriteToChat("/cb rr - Removes the currently selected item from the return item list.");
                    WriteToChat("----------------------------------------");
                    WriteToChat("SHORTCUTS");
                    WriteToChat("/ah - Alias for /allegiance hometown");
                    WriteToChat("/hr - Alias for /house recall");
                    WriteToChat("/ls - Alias for /lifestone");
                    WriteToChat("/mp - Alias for /marketplace");
                    WriteToChat("/mr - Alias for /house mansion_recall");
                    WriteToChat("----------------------------------------");
                    WriteToChat("DEBUG");
                    WriteToChat("/cb aqp - \"Peeks\" at the action queue. Used for debugging.");
                    WriteToChat("/cb debug - Verbose debug output.");
                    WriteToChat("/cb timer debug - Information about some of the timers the bot uses.");
                    WriteToChat("----------------------------------------");
                    WriteToChat("SUPPORT");
                    WriteToChat("For support, please post a request on the CraftBot support forums: http://craftbot.acvault.ign.com/forums/");
                    WriteToChat("----------------------------------------");
                    WriteToChat("ABOUT");
                    WriteToChat("Version " + executingAssembly.GetName().Version + " by FireSickle II (Makain) of Harvestgain");
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("ah"))
                {
                    ChatParser.Eat = true;
                    base.Host.Actions.InvokeChatParser("/allegiance hometown");
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("hr"))
                {
                    ChatParser.Eat = true;
                    base.Host.Actions.InvokeChatParser("/house recall");
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("ls"))
                {
                    ChatParser.Eat = true;
                    base.Host.Actions.InvokeChatParser("/lifestone");
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("mp"))
                {
                    ChatParser.Eat = true;
                    base.Host.Actions.InvokeChatParser("/marketplace");
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("mr"))
                {
                    ChatParser.Eat = true;
                    base.Host.Actions.InvokeChatParser("/house mansion_recall");
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("cb aqp"))
                {
                    ChatParser.Eat = true;
                    if (actionQueue.Count > 0)
                    {
                        CAction action = actionQueue.Peek();
                        WriteToChat(string.Concat(new object[] { "Next Action: ", action.getType(), " First IID: ", action.getFirstIID(), " State: ", _State }));
                    }
                    else
                    {
                        WriteToChat("No actions in queue!");
                    }
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("cb debug"))
                {
                    ChatParser.Eat = true;
                    debugOutput();
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).StartsWith("cb vr"))
                {
                    ChatParser.Eat = true;
                    if (_returnObjects.Count == 0)
                    {
                        WriteToChat("No items to return!");
                    }
                    else
                    {
                        foreach (ReturnObject rtnObj in _returnObjects)
                        {
                            if (base.Core.WorldFilter[rtnObj.getID()] != null)
                            {
                                WriteToChat(base.Core.WorldFilter[rtnObj.getID()].Name + " will be returned to " + rtnObj.getReturnTo() + " when they next open a trade window.");
                            }
                        }
                    }
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).StartsWith("cb rr"))
                {
                    ChatParser.Eat = true;
                    int curSelect = base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Id;
                    ReturnObject ro = null;
                    bool flag = false;
                    foreach (ReturnObject rtnObj in _returnObjects)
                    {
                        if (rtnObj.getID() == curSelect)
                        {
                            ro = new ReturnObject(rtnObj.getID(), rtnObj.getReturnTo());
                            flag = true;
                            break;
                        }
                    }
                    if (flag)
                    {
                        deleteReturnItem(riFile, ro);
                        if (base.Core.WorldFilter[ro.getID()] != null)
                        {
                            WriteToChat(base.Core.WorldFilter[ro.getID()].Name + " has been removed from the return item list.");
                        }
                    }
                    else
                    {
                        WriteToChat(base.Core.WorldFilter[curSelect].Name + " was not found in the return item list.");
                    }
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).StartsWith("cb return"))
                {
                    ChatParser.Eat = true;
                    string playerName = ChatParser.Text.Substring(11);
                    if (((playerName == null) || playerName.Equals("")) || playerName.Equals(" "))
                    {
                        WriteToChat("Error: Player name missing!");
                    }
                    else
                    {
                        writeReturnItem(riFile, new ReturnObject(base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Id, playerName.ToLower()));
                        WriteToChat(base.Core.WorldFilter[base.Host.Actions.CurrentSelection].Name + " will be returned to " + playerName + " when they next open a trade window.");
                    }
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("cb getspelllist"))
                {
                    ChatParser.Eat = true;
                    printSpellTable();
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("cb start"))
                {
                    ChatParser.Eat = true;
                    if (!this._isEnabled)
                    {
                        chkEnabled_Change(this, null);
                        chkEnabled.Checked = true;
                    }
                    else
                    {
                        WriteToChat("Bot is already started!");
                    }
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("cb stop"))
                {
                    ChatParser.Eat = true;
                    if (_isEnabled)
                    {
                        chkEnabled_Change(this, null);
                        chkEnabled.Checked = false;
                    }
                    else
                    {
                        WriteToChat("Bot is already stopped!");
                    }
                }
                else if ((str.Equals("/") || str.Equals("@")) && ChatParser.Text.Substring(1).Equals("cb timer debug"))
                {
                    ChatParser.Eat = true;
                    WriteToChat("Timer Debug");
                    WriteToChat("Buff Timer:");
                    if (buffTimer.Enabled)
                    {
                        WriteToChat("Enabled");
                    }
                    else
                    {
                        WriteToChat("Disabled.");
                    }
                    WriteToChat("Interval: " + buffTimer.Interval + " ms");
                    WriteToChat("Rare Timer:");
                    if (rareTimer.Enabled)
                    {
                        WriteToChat("Enabled");
                    }
                    else
                    {
                        WriteToChat("Disabled.");
                    }
                    WriteToChat("Interval: " + rareTimer.Interval + " ms");
                    WriteToChat("Idle Timer:");
                    if (idleTimer.Enabled)
                    {
                        WriteToChat("Enabled");
                    }
                    else
                    {
                        WriteToChat("Disabled.");
                    }
                    WriteToChat("Interval: " + idleTimer.Interval + " ms");
                    WriteToChat("Spam Timer:");
                    if (spamTimer.Enabled)
                    {
                        WriteToChat("Enabled");
                    }
                    else
                    {
                        WriteToChat("Disabled.");
                    }
                    WriteToChat("Interval: " + spamTimer.Interval + " ms");
                    WriteToChat("Web Timer:");
                    if (webTimer.Enabled)
                    {
                        WriteToChat("Enabled");
                    }
                    else
                    {
                        WriteToChat("Disabled.");
                    }
                    WriteToChat("Interval: " + webTimer.Interval + " ms");
                    WriteToChat("Heartbeat:");
                    if (heartbeat.Enabled)
                    {
                        WriteToChat("Enabled");
                    }
                    else
                    {
                        WriteToChat("Disabled.");
                    }
                    WriteToChat("Interval: " + heartbeat.Interval + " ms");
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        /// <summary>
        /// (a)(ChatTextInterceptEventArgs) 
        /// This function parses Chat Text and does logic based on it
        /// </summary>
        /// <param name="A_0"></param>
        /// <param name="A_1"></param>
        private void ParseChatText(object A_0, ChatTextInterceptEventArgs ChatText)
        {
            try
            {
                if (_isEnabled)
                {
                    if (ChatText.Color.Equals(0) && ChatText.Text.Contains("gives you"))
                    {
                        int iOfGivesYou = ChatText.Text.LastIndexOf("gives you");
                        string playerName = ChatText.Text.Substring(0, iOfGivesYou - 1);
                        string itemName = ChatText.Text.Substring(iOfGivesYou + 10);
                        addToChatQueue("Thank you, " + playerName.Trim() + ", for the gift of " + itemName.Trim());
                        clsMessageWriter.Write_Message_And_Time(giftFile, "Gift: " + playerName.Trim() + " gave you " + itemName.Trim());
                    }
                    if ((((!this._waitFor.Equals("Apply Item") || !ChatText.Text.Contains("Your craft attempt fails")) || ((ChatText.Color == 2) || (ChatText.Color == 3))) || (((ChatText.Color == 4) || (ChatText.Color == 8)) || ((ChatText.Color == 10) || (ChatText.Color == 11)))) || ((ChatText.Color == 12) || (ChatText.Color == 0x12)))
                    {
                        if (((_waitFor.Equals("Apply Item") && !ChatText.Text.Contains("is recalling to")) && !ChatText.Text.Contains("Tell:IIDString")) && ((((ChatText.Color == 0) || (ChatText.Color == 1)) || ((ChatText.Color == 0x10) || (ChatText.Color == 20))) || (((ChatText.Color == 0x17) || (ChatText.Color == 0x18)) || (ChatText.Color == 0x19))))
                        {
                            if (!this._ignoreApply)
                            {
                                _ignoreApply = true;
                                _waitFor = "";
                                _State = "Idle";
                                if (actionQueue.Count > 0)
                                {
                                    actionQueue.Dequeue();
                                }
                                if (ChatText.Text.Contains(base.Core.CharacterFilter.Name + " fails to apply"))
                                {
                                    tellTraderFailure();
                                    if (actionQueue.Count > 0)
                                    {
                                        actionQueue.Clear();
                                    }
                                    bool flag = false;
                                    foreach (WorldObject tradeObj in wObjTrade)
                                    {
                                        if (tradeObj != tinkeringTarget)
                                        {
                                            flag = true;
                                            break;
                                        }
                                    }
                                    if (flag)
                                    {
                                        actionQueue.Enqueue(new CAction("Return Items"));
                                    }
                                    _State = "Idle";
                                    resetCraftingState();
                                }
                                else if (actionQueue.Count == 0)
                                {
                                    actionQueue.Enqueue(new CAction("Return Items"));
                                }
                            }
                        }
                        else if (_waitFor.Equals("Spell Cast") && ChatText.Text.Contains("You cast"))
                        {
                            _waitFor = "";
                            _State = "Idle";
                            if (actionQueue.Count > 0)
                            {
                                actionQueue.Dequeue();
                                if ((actionQueue.Count > 0) && !this.actionQueue.Peek().getType().Equals("Cast Spell"))
                                {
                                    _isBuffing = false;
                                }
                                else if (actionQueue.Count == 0)
                                {
                                    _isBuffing = false;
                                }
                            }
                        }
                        else if (_waitFor.Equals("Spell Cast") && ChatText.Text.Equals("You don't know that spell!"))
                        {
                            _waitFor = "";
                            _State = "Idle";
                            WriteToChat("Error: Spell unknown!");
                            if (actionQueue.Count > 0)
                            {
                                clsMessageWriter.Write_Split_Message(debugFile, "Unknown Spell, ID:" + actionQueue.Peek().getFirstIID());
                                actionQueue.Dequeue();
                                if ((actionQueue.Count > 0) && !this.actionQueue.Peek().getType().Equals("Cast Spell"))
                                {
                                    _isBuffing = false;
                                }
                                else if (actionQueue.Count == 0)
                                {
                                    _isBuffing = false;
                                }
                            }
                        }
                        else if (_waitFor.Equals("Spell Cast") && ChatText.Text.Equals("You don't have all the components for this spell."))
                        {
                            _waitFor = "";
                            _State = "Idle";
                            WriteToChat("Error: Out of components!");
                            if (!this._lowCompsMessageSentUntargeted)
                            {
                                sayNoComponents();
                                _lowCompsMessageSentUntargeted = true;
                            }
                            if (actionQueue.Count > 0)
                            {
                                actionQueue.Dequeue();
                                if ((actionQueue.Count > 0) && !this.actionQueue.Peek().getType().Equals("Cast Spell"))
                                {
                                    _isBuffing = false;
                                }
                                else if (actionQueue.Count == 0)
                                {
                                    _isBuffing = false;
                                }
                            }
                            clsMessageWriter.Write_Split_Message(debugFile, "Out of components.");
                        }
                        else if (_waitFor.Equals("Spell Cast") && (ChatText.Text.Contains("You say, \"Roiga Thiloi\"") || ChatText.Text.Contains("You say, \"Roiga Thiril\"")))
                        {
                            _waitFor = "";
                            _State = "Idle";
                            if (actionQueue.Count > 0)
                            {
                                actionQueue.Dequeue();
                            }
                            resetCraftingState();
                        }
                        else if (ChatText.Color == 3)
                        {
                            if (ChatText.Text.Contains("tells you"))
                            {
                                string newCmd;
                                if (_WaitForRecipeName)
                                {
                                    int tellIndex = ChatText.Text.LastIndexOf("tells you,") + 12;
                                    newCmd = ChatText.Text.Substring(tellIndex);
                                    int length = newCmd.Length - 2;
                                    newCmd = newCmd.Substring(0, length);
                                    _tellPerson = ChatText.Text.Substring(0, tellIndex - 13);
                                    int index = _tellPerson.IndexOf('>');
                                    _tellPerson = _tellPerson.Substring(index + 1);
                                    _tellPerson = _tellPerson.Substring(0, _tellPerson.Length - 7);
                                }
                                else
                                {
                                    string str = ChatText.Text.ToLower();
                                    int tellIndex = ChatText.Text.LastIndexOf("tells you,") + 12;
                                    newCmd = str.Substring(tellIndex);
                                    int cmdLen = newCmd.Length - 2;
                                    newCmd = newCmd.Substring(0, cmdLen);
                                    _tellPerson = ChatText.Text.Substring(0, tellIndex - 13);
                                    int num7 = _tellPerson.IndexOf('>');
                                    _tellPerson = _tellPerson.Substring(num7 + 1);
                                    _tellPerson = _tellPerson.Substring(0, _tellPerson.Length - 7);
                                }
                                processToldCommand(newCmd);
                            }
                        }
                        else if (((ChatText.Color == 7) && Settings.Default.useManaStones) && (ChatText.Text.Contains("is low on Mana") || ChatText.Text.Contains("is out of Mana")))
                        {
                            findManaCharge();
                        }
                        else if (waitForBrill && ChatText.Text.Contains("cast Brilliance on you"))
                        {
                            if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                            {
                                actionQueue.Dequeue();
                                _waitTimer = 0;
                                _State = "Idle";
                                _byPassCheck = false;
                                craftingDoWork();
                            }
                            else if (RecipeName != null)
                            {
                                craftingDoWork();
                            }
                            else
                            {
                                resetCraftingState();
                            }
                            waitForBrill = false;
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void ServerDispatch_Handler(object A_0, NetworkMessageEventArgs A_1)
        {
            try
            {
                if ((_isEnabled && (A_1.Message != null)) && ((A_1.Message.Type == 0xf7b0) && (A_1.Message.Value<int>("event") == 650)))
                {
                    switch (A_1.Message.Value<int>("type"))
                    {
                        case 0x400:
                            {
                                int num = base.Core.WorldFilter.GetByName("Prismatic Taper").Quantity;
                                int num2 = base.Core.WorldFilter.GetByName("Platinum Scarab").Quantity;
                                if (!this._lowCompsMessageSent)
                                {
                                    addToChatQueue(string.Concat(new object[] { "I am out of components! Please hand me some so I may buff myself. I currently have ", num, " tapers and ", num2, " Platinum Scarabs." }));
                                    _lowCompsMessageSent = true;
                                }
                                actionQueue.Clear();
                                return;
                            }
                        case 0x401:
                            if (!this._lowManaSent)
                            {
                                addToChatQueue("I am low on mana! Please cast infuse mana on me.");
                                _lowManaSent = true;
                            }
                            return;
                    }
                }
                else if (((A_1.Message != null) && (A_1.Message.Type == 0xf7b0)) && (A_1.Message.Value<int>("event") == 0x13))
                {
                    MessageStruct struct2 = A_1.Message.Struct("properties").Struct("dwords");
                    if ((struct2 != null) && (struct2.Count > 0))
                    {
                        for (int i = 0; i < struct2.Count; i++)
                        {
                            if ((struct2.Struct(i).Count > 0) && (((int)struct2.Struct(i).Value<object>("key")) == 0xec))
                            {
                                charmedSmith = true;
                            }
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void a(object A_0, AcceptTradeEventArgs A_1)
        {
            if (!this._c9)
            {
                if (returnItems)
                {
                    base.Host.Actions.TradeAccept();
                    if (!this._cc)
                    {
                        m();
                        _cc = true;
                    }
                    if (trader != null)
                    {
                        clsMessageWriter.Write_Split_Message(debugFile, "Items returned to " + trader.Name);
                    }
                    base.Host.Actions.TradeEnd();
                }
                else if (_isSendingMail && A_1.TargetId.Equals(trader.Id))
                {
                    base.Host.Actions.TradeAccept();
                    foreach (WorldObject obj2 in wObjTrade)
                    {
                        string err = string.Concat(new object[] { "Adding mail item: Item: ", obj2.Name, " (", obj2.Id, ") Deliver To: ", _mailReturnPlayer });
                        clsMessageWriter.Write_Message(mailFile, err);
                        writeMailLogXML(mailFileXML, _mailFromPlayer, _mailReturnPlayer, obj2.Id.ToString());
                        writeReturnItem(riFile, new ReturnObject(obj2.Id, _mailReturnPlayer));
                    }
                    c(_mailFromPlayer, _mailReturnPlayer);
                    resetCraftingState();
                }
                else if (!this.ignoreTrades)
                {
                    if (_b2 > 1)
                    {
                        r();
                        resetCraftingState();
                    }
                    else
                    {
                        if (_lookForRares && A_1.TargetId.Equals(trader.Id))
                        {
                            aj();
                        }
                        try
                        {
                            if (_waitForAccept && A_1.TargetId.Equals(trader.Id))
                            {
                                actionQueue.Enqueue(new CAction(3, "Wait"));
                            }
                            else if ((_isEnabled && !this.inCraft) && ((trader != null) && A_1.TargetId.Equals(trader.Id)))
                            {
                                inTrade = true;
                                inCraft = true;
                                bool flag = false;
                                foreach (WorldObject obj3 in wObjTrade)
                                {
                                    if (obj3 != null)
                                    {
                                        //addToChatQueue(obj3.Values(LongValueKey.Material).ToString());

                                        bool foundRecipe = false;
                                        if (obj3.ObjectClass == ObjectClass.Salvage) 
                                        {
                                            foundRecipe = findRecipe(obj3.Values(LongValueKey.Material).ToString(), personalFolderPath + @"\recipes.xml");
                                        } else {
                                            foundRecipe = findRecipe(obj3.Name, personalFolderPath + @"\recipes.xml");
                                        }


                                        if (!flag && foundRecipe)
                                        {
                                            if (_RecipeList.Count > 1)
                                            {
                                                tellFoundMultipleRecipes();
                                                _WaitForRecipeName = true;
                                            }
                                            else
                                            {
                                                flag = true;
                                                setSkill(RecipeName, personalFolderPath + @"\recipes.xml");
                                                startCrafting();
                                            }
                                            return;
                                        }
                                        clsMessageWriter.Write_Split_Message(debugFile, "No recipe found for " + obj3.Name);
                                    }
                                }
                                if (!flag)
                                {
                                    aq();
                                    resetCraftingState();
                                }
                            }
                        }
                        catch (Exception exception)
                        {
                            clsMessageWriter.Write_Split_Message(debugFile, "Error in accept trade.");
                            clsMessageWriter.Write_Error(errorLogFile, exception);
                        }
                    }
                }
            }
        }

        private void a(object A_0, AddTradeItemEventArgs A_1)
        {
            try
            {
                if (!this.ignoreTrades && ((_isEnabled && !this.returnItems) && (!this.inCraft && !this.waitForBrill)))
                {
                    inTrade = true;
                    if ((base.Core.WorldFilter[A_1.ItemId] != null) && !base.Core.WorldFilter[A_1.ItemId].ObjectClass.Equals((ObjectClass)0x18))
                    {
                        if (((base.Core.WorldFilter[A_1.ItemId].ObjectClass.Equals((ObjectClass)2) || base.Core.WorldFilter[A_1.ItemId].ObjectClass.Equals((ObjectClass)3)) || (base.Core.WorldFilter[A_1.ItemId].ObjectClass.Equals((ObjectClass)4) || base.Core.WorldFilter[A_1.ItemId].ObjectClass.Equals((ObjectClass)1))) || (base.Core.WorldFilter[A_1.ItemId].ObjectClass.Equals((ObjectClass)9) || base.Core.WorldFilter[A_1.ItemId].ObjectClass.Equals((ObjectClass)0x1f)))
                        {
                            _b2++;
                        }
                        wObjTrade.Add(base.Core.WorldFilter[A_1.ItemId]);
                        base.Host.Actions.RequestId(A_1.ItemId);
                        foreach (string str in _RareList)
                        {
                            if (base.Core.WorldFilter[A_1.ItemId].Name.Equals(str))
                            {
                                _lookForRares = true;
                            }
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Split_Message(debugFile, "Error in add trade item.");
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void a(object A_0, ChangeObjectEventArgs A_1)
        {
            try
            {
                if (_isEnabled)
                {
                    if ((_waitFor.Equals("Equip") && A_1.Change.Equals((WorldChangeType)1)) && A_1.Changed.Id.Equals(_bc))
                    {
                        _State = "Idle";
                        _bc = 0;
                        actionQueue.Dequeue();
                        _waitFor = "";
                    }
                    else if ((_waitFor.Equals("Apply Item") && A_1.Changed.Container.Equals(base.Core.CharacterFilter.Id)) && (A_1.Change.Equals((WorldChangeType)0) || A_1.Change.Equals((WorldChangeType)1)))
                    {
                        if (!this._ignoreApply)
                        {
                            _ignoreApply = true;
                            _State = "Idle";
                            actionQueue.Dequeue();
                            if (actionQueue.Count == 0)
                            {
                                actionQueue.Enqueue(new CAction("Return Items"));
                            }
                            else
                            {
                                actionQueue.Dequeue();
                                actionQueue.Enqueue(new CAction(craftStepNum, "Check Craft Step"));
                            }
                        }
                    }
                    else if ((((finalResult != null) && A_1.Changed.Equals(finalResult)) && A_1.Changed.Container.Equals(base.Core.CharacterFilter.Id)) && (A_1.Change.Equals((WorldChangeType)0) || A_1.Change.Equals((WorldChangeType)1)))
                    {
                        if ((craftStepNum <= 0) || (craftStepNum >= _craftStepCount))
                        {
                            wObjResult[0] = A_1.Changed;
                            actionQueue.Enqueue(new CAction("Return Items"));
                        }
                    }
                    else if (A_1.Change.Equals(WorldChangeType.IdentReceived) && A_1.Changed.Equals(tinkeringTarget))
                    {
                        tinkerCount = A_1.Changed.Values(LongValueKey.NumberTimesTinkered);
                        tinkerCountCopy = A_1.Changed.Values(LongValueKey.NumberTimesTinkered);
                    }
                    else if (A_1.Change.Equals(WorldChangeType.IdentReceived) && A_1.Changed.ObjectClass.Equals((ObjectClass)5))
                    {
                        if ((A_1.Changed.HasIdData && (A_1.Changed.Values(LongValueKey.CreatureLevel) >= 100)) && Settings.Default.logoffOnMonsterDetect)
                        {
                            g(A_1.Changed.Name);
                            base.Host.Actions.Logout();
                        }
                    }
                    else if ((A_1.Change.Equals(WorldChangeType.IdentReceived) && A_1.Changed.ObjectClass.Equals(ObjectClass.ManaStone)) && (_lookForCharge && (A_1.Changed.Values(LongValueKey.CurrentMana) > 0)))
                    {
                        actionQueue.Enqueue(new CAction(A_1.Changed.Id, "Use"));
                        _lookForCharge = false;
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Split_Message(debugFile, "Error in change object.");
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void a(object A_0, CreateObjectEventArgs A_1)
        {
            try
            {
                if (_isEnabled)
                {
                    if (A_1.New.ObjectClass.Equals(ObjectClass.Monster) && Settings.Default.logoffOnMonsterDetect)
                    {
                        base.Host.Actions.RequestId(A_1.New.Id);
                        if (!A_1.New.Name.Equals("White Rabbit") && (A_1.New.Name.Contains("Rabbit") || A_1.New.Name.Contains("Chicken")))
                        {
                            if (A_1.New.HasIdData && (A_1.New.Values(LongValueKey.Value) >= 100))
                            {
                                g(A_1.New.Name);
                                clsMessageWriter.Write_Split_Message(debugFile, string.Concat(new object[] { "Logged off due to level ", A_1.New.Values(LongValueKey.Value), " ", A_1.New.Name }));
                                base.Host.Actions.Logout();
                            }
                        }
                        else if (A_1.New.HasIdData && (A_1.New.Values(LongValueKey.Value) >= 100))
                        {
                            g(A_1.New.Name);
                            clsMessageWriter.Write_Split_Message(debugFile, string.Concat(new object[] { "Logged off due to level ", A_1.New.Values(LongValueKey.Value), " ", A_1.New.Name }));
                            base.Host.Actions.Logout();
                        }
                    }
                    if (inCraft || returnItems)
                    {
                        foreach (string str in _onItems)
                        {
                            if ((str != null) && A_1.New.Name.Equals(str))
                            {
                                _cp.Add(A_1.New);
                                return;
                            }
                        }
                        _createdItems.Add(A_1.New);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Split_Message(debugFile, "Error in create object.");
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void a(object A_0, DeclineTradeEventArgs A_1)
        {
            try
            {
                if (!this.ignoreTrades && (_isEnabled && !this.ignoreReset))
                {
                    ad();
                    resetCraftingState();
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Split_Message(debugFile, "Error in decline trade.");
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void a(object A_0, EndTradeEventArgs A_1)
        {
            try
            {
                ArrayList list = new ArrayList();
                foreach (ReturnObject obj2 in _ck)
                {
                    if (trader != null)
                    {
                        //trader.Name;
                    }
                    list.Add(obj2);
                }
                int num = 0;
                WorldObjectCollection byContainer = base.Core.WorldFilter.GetByContainer(base.Core.CharacterFilter.Id);
                bool flag = false;
                foreach (WorldObject obj3 in byContainer)
                {
                    if ((!obj3.ObjectClass.Equals((ObjectClass)10) && !obj3.ObjectClass.Equals((ObjectClass)0x26)) && (obj3.Values(LongValueKey.EquippedSlots) <= 0))
                    {
                        foreach (ReturnObject obj4 in _ck)
                        {
                            if (obj3.Id == obj4.getID())
                            {
                                list.Remove(obj4);
                            }
                        }
                        num++;
                    }
                }
                foreach (ReturnObject obj5 in list)
                {
                    string playerTo = "Unknown";
                    if (trader != null)
                    {
                        playerTo = trader.Name;
                    }
                    deleteReturnItem(riFile, obj5);
                    deleteMailLogXML(mailFileXML, "Unknown", playerTo, obj5.getID().ToString(), false);
                    if (!flag)
                    {
                        if (RecipeName != null)
                        {
                            clsMessageWriter.Write_Split_Message(debugFile, "Crafting complete! Recipe: " + RecipeName);
                        }
                        if (trader != null)
                        {
                            clsMessageWriter.Write_Split_Message(debugFile, "Items returned to " + trader.Name);
                        }
                        flag = true;
                    }
                }
                if ((num >= 90) && Settings.Default.useMail)
                {
                    clsMessageWriter.Write_Split_Message(debugFile, "Only 12 pack slots left! Disabling mail...");
                    WriteToChat("Low on pack space! Disabling mail.");
                    Settings.Default.useMail = false;
                    chkEnableMail.Checked = false;
                    Settings.Default.recoverMail = true;
                }
                else if ((num < 90) && Settings.Default.recoverMail)
                {
                    WriteToChat("Mail was previously enabled and there are more than 12 slots in the main pack free! Enabling mail...");
                    clsMessageWriter.Write_Split_Message(debugFile, "Re-enabling mail due to free pack space.");
                    Settings.Default.useMail = true;
                    chkEnableMail.Checked = false;
                    Settings.Default.recoverMail = false;
                }
                if (!this.ignoreTrades && (_isEnabled && !this.inCraft))
                {
                    resetCraftingState();
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Split_Message(debugFile, "Error in end trade.");
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void a(object A_0, EnterTradeEventArgs A_1)
        {
            try
            {
                _c9 = false;
                if (!this._isBuffing && ((actionQueue.Count <= 0) || !this.actionQueue.Peek().getType().Equals("Cast Spell")))
                {
                    if (_returnObjects.Count > 0)
                    {
                        inTrade = true;
                        bool flag = false;
                        foreach (ReturnObject obj2 in _returnObjects)
                        {
                            if ((base.Core.WorldFilter[A_1.TradeeId] != null) && base.Core.WorldFilter[A_1.TradeeId].Name.ToLower().Equals(obj2.getReturnTo().ToLower()))
                            {
                                foreach (WorldObject obj3 in base.Core.WorldFilter.GetInventory())
                                {
                                    if (obj3.Id == obj2.getID())
                                    {
                                        returnItems = true;
                                        flag = true;
                                        base.Host.Actions.TradeAdd(obj2.getID());
                                        _ck.Add(obj2);
                                        break;
                                    }
                                }
                            }
                        }
                        if (flag)
                        {
                            tellAcceptTrade();
                            return;
                        }
                    }
                    else if (ignoreTrades)
                    {
                        return;
                    }
                    if (_isEnabled && inCraft)
                    {
                        base.Host.Actions.TradeEnd();
                    }
                    else if (_isEnabled)
                    {
                        _ignoreGo = false;
                        _ignoreYes = false;
                        idleTimer.Start();
                        idleTimer.Enabled = true;
                        inTrade = true;
                        trader = base.Core.WorldFilter[A_1.TradeeId];
                        _recipeItems = new ArrayList();
                        ar();
                        ArrayList list = spamFindOutstandingMail(mailFileXML, trader.Name, trader.Name);
                        if (list.Count > 0)
                        {
                            b(list);
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Split_Message(debugFile, "Error in enter trade.");
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void a(object A_0, LogoffEventArgs A_1)
        {
            _isEnabled = false;
            buffTimer.Stop();
            rareTimer.Stop();
            actionTimer.Stop();
            idleTimer.Stop();
            spamTimer.Stop();
            webTimer.Stop();
            heartbeat.Stop();
            chatTimer.Stop();
            _WebReq = null;
        }

        private void a(object A_0, MoveObjectEventArgs A_1)
        {
        }

        private void a(object A_0, ReleaseObjectEventArgs A_1)
        {
            try
            {
                if ((wObjTrade != null) && wObjTrade.Contains(A_1.Released))
                {
                    wObjTrade.Remove(A_1.Released);
                }
                if ((finalResult != null) && finalResult.Equals(A_1.Released))
                {
                    finalResult = null;
                }
                if ((tinkeringTarget != null) && tinkeringTarget.Equals(A_1.Released))
                {
                    tinkeringTarget = null;
                }
                if (wObjResult != null)
                {
                    for (int i = 0; i < wObjResult.Length; i++)
                    {
                        if ((wObjResult[i] != null) && wObjResult[i].Equals(A_1.Released))
                        {
                            wObjResult[i] = null;
                        }
                    }
                }
                if (sortedSalvage != null)
                {
                    foreach (Salvage salvage in sortedSalvage)
                    {
                        if ((salvage != null) && (salvage.getIID() == A_1.Released.Id))
                        {
                            sortedSalvage.Remove(salvage);
                            break;
                        }
                    }
                }
                if ((_cp != null) && _cp.Contains(A_1.Released))
                {
                    _cp.Remove(A_1.Released);
                }
                if ((_createdItems != null) && _createdItems.Contains(A_1.Released))
                {
                    _createdItems.Remove(A_1.Released);
                }
                if ((A_1.Released != null) && (trader != null))
                {
                    deleteReturnItem(riFile, new ReturnObject(A_1.Released.Id, trader.Name));
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Split_Message(debugFile, "Error in release object.");
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void a(object A_0, ResetTradeEventArgs A_1)
        {
            try
            {
                if ((_isEnabled && (trader != null)) && (A_1.TraderId.Equals(trader.Id) && !this.ignoreReset))
                {
                    ad();
                    resetCraftingState();
                }
                else if (_isEnabled && !this.ignoreReset)
                {
                    resetCraftingState();
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Split_Message(debugFile, "Error in reset trade.");
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void a(object A_0, EventArgs A_1)
        {
            try
            {
                f();
                getLandblockInfo();
                Assembly executingAssembly = Assembly.GetExecutingAssembly();
                WriteToChat("CraftBot loaded! Version " + executingAssembly.GetName().Version + " by FireSickle II (Makain) of Harvestgain (Based on the original software by Paraduck)");
                WriteToChat("For a list of commands, type /cb help");
                checkVersion();
                base.Host.Actions.SetIdleTime(99999.0);
                _faceHeading = base.Host.Actions.HeadingRadians;
                foreach (WorldObject obj2 in base.Core.WorldFilter.GetInventory())
                {
                    _cp.Add(obj2);
                }
                if (checkMessages(personalFolderPath + @"\messages.xml"))
                {
                    WriteToChat("You have new messages.");
                }
                loadMessages(personalFolderPath + @"\messages.xml");
                loadReturnItems(riFile);
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void actionTimer_Handler(object A_0, EventArgs A_1)
        {
            try
            {
                if ((_givenGo && (actionQueue.Count > 0)) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                    _waitTimer = 0;
                    _State = "Idle";
                    _waitFor = "";
                }
                if (!this._byPassCheck)
                {
                    if ((!this._isEnabled || _State.Equals("Busy")) && !this._waitFor.Equals("Equip"))
                    {
                        return;
                    }
                    if (_waitFor.Equals("Change Combat - Magic"))
                    {
                        if (!base.Host.Actions.CombatMode.Equals((CombatState)8))
                        {
                            base.Host.Actions.SetCombatMode((CombatState)8);
                            _State = "Idle";
                            _byPassCheck = true;
                            _waitFor = "Change Combat - Magic";
                            if (actionQueue.Count > 0)
                            {
                                actionQueue.Dequeue();
                            }
                        }
                        else
                        {
                            _byPassCheck = false;
                            _waitFor = "";
                        }
                    }
                    else if (_waitFor.Equals("Change Combat - Peace"))
                    {
                        if (!base.Host.Actions.CombatMode.Equals((CombatState)1))
                        {
                            base.Host.Actions.SetCombatMode((CombatState)1);
                            _State = "Idle";
                            _byPassCheck = true;
                            _waitFor = "Change Combat - Peace";
                            if (actionQueue.Count > 0)
                            {
                                actionQueue.Dequeue();
                            }
                        }
                        else
                        {
                            _byPassCheck = false;
                            _waitFor = "";
                        }
                    }
                }
                else
                {
                    if (_waitFor.Equals("Change Combat - Magic"))
                    {
                        if (!base.Host.Actions.CombatMode.Equals((CombatState)8))
                        {
                            base.Host.Actions.SetCombatMode((CombatState)8);
                            _State = "Idle";
                            _byPassCheck = true;
                            _waitFor = "Change Combat - Magic";
                            if (actionQueue.Count > 0)
                            {
                                actionQueue.Dequeue();
                            }
                        }
                        else
                        {
                            _byPassCheck = false;
                            _waitFor = "";
                        }
                    }
                    else if (_waitFor.Equals("Change Combat - Peace"))
                    {
                        if (!base.Host.Actions.CombatMode.Equals((CombatState)1))
                        {
                            base.Host.Actions.SetCombatMode((CombatState)1);
                            _State = "Idle";
                            _byPassCheck = true;
                            _waitFor = "Change Combat - Peace";
                            if (actionQueue.Count > 0)
                            {
                                actionQueue.Dequeue();
                            }
                        }
                        else
                        {
                            _byPassCheck = false;
                            _waitFor = "";
                        }
                    }
                    if (_State.Equals("Busy") && (_waitTimer > 0))
                    {
                        _waitTimer--;
                        if (((_waitTimer == 0) && inCraft) && ((craftStepNum > 0) && (actionQueue.Count > 0)))
                        {
                            actionQueue.Dequeue();
                        }
                        else if ((_waitTimer == 0) && (_b0 != null))
                        {
                            _State = "Idle";
                            _byPassCheck = false;
                            actionQueue.Dequeue();
                            _waitForAccept = false;
                            rareUse(_b0);
                        }
                        else if ((_waitTimer == 0) && inCraft)
                        {
                            _State = "Idle";
                            actionQueue.Dequeue();
                            _byPassCheck = false;
                            craftingDoWork();
                        }
                        return;
                    }
                }
                if (base.Host.Actions.BusyState == 0)
                {
                    if (actionQueue.Count > 0)
                    {
                        CAction item = actionQueue.Peek();
                        if (_State.Equals("Busy") && (_waitTimer > 0))
                        {
                            _waitTimer--;
                            if ((_waitTimer == 0) && (_b0 != null))
                            {
                                _State = "Idle";
                                _byPassCheck = false;
                                actionQueue.Dequeue();
                                _waitForAccept = false;
                                rareUse(_b0);
                            }
                            else if ((_waitTimer == 0) && inCraft)
                            {
                                _State = "Idle";
                                actionQueue.Dequeue();
                                _byPassCheck = false;
                                craftingDoWork();
                            }
                        }
                        else
                        {
                            if (((actionQueue.Count == 0) && (craftStepNum == _craftStepCount)) && _bt)
                            {
                                _bt = false;
                                actionQueue.Enqueue(new CAction("Return Items"));
                            }
                            if (item.getType().Equals("Equip"))
                            {
                                if (base.Core.WorldFilter[item.getFirstIID()] == null)
                                {
                                    _waitFor = "";
                                    _State = "Idle";
                                    actionQueue.Dequeue();
                                }
                                else
                                {
                                    base.Host.Actions.UseItem(item.getFirstIID(), 0);
                                    _waitFor = "Equip";
                                    _State = "Busy";
                                    _bc = item.getFirstIID();
                                }
                            }
                            else if (item.getType().Equals("Wait"))
                            {
                                _State = "Busy";
                                _waitTimer = item.getFirstIID();
                                _byPassCheck = true;
                            }
                            else if (item.getType().Equals("Use"))
                            {
                                base.Host.Actions.SelectItem(base.Core.CharacterFilter.Id);
                                base.Host.Actions.UseItem(item.getFirstIID(), 1);
                                actionQueue.Dequeue();
                            }
                            else if (item.getType().Equals("Use Beer"))
                            {
                                base.Host.Actions.UseItem(item.getFirstIID(), 0);
                                _State = "Busy";
                                _waitFor = "Spell Cast";
                            }
                            else if (item.getType().Equals("Use Rare"))
                            {
                                base.Host.Actions.UseItem(item.getFirstIID(), 0);
                                _State = "Busy";
                                _waitFor = "Spell Cast";
                            }
                            else if (item.getType().Equals("Apply Item"))
                            {
                                if ((base.Core.WorldFilter[item.getFirstIID()] != null) && (base.Core.WorldFilter[item.getSecondIID()] != null))
                                {
                                    _ignoreApply = false;
                                    base.Host.Actions.ApplyItem(item.getFirstIID(), item.getSecondIID());
                                    _State = "Busy";
                                    _waitFor = "Apply Item";
                                    if (((craftStepNum > 0) && (craftStepNum < _craftStepCount)) && !this._craftIncremented)
                                    {
                                        craftStepNum++;
                                        _craftIncremented = true;
                                        actionQueue.Enqueue(new CAction(craftStepNum, "Check Craft Step"));
                                    }
                                }
                                else
                                {
                                    actionQueue.Clear();
                                    ah();
                                    actionQueue.Enqueue(new CAction("Return Items"));
                                }
                            }
                            else if (item.getType().Equals("Check Craft Step"))
                            {
                                doCraftStep(item.getFirstIID());
                            }
                            else if (item.getType().Equals("Buff"))
                            {
                                if (inTrade || inCraft)
                                {
                                    actionQueue.Enqueue(item);
                                }
                                else
                                {
                                    base.Host.Actions.UseItem(item.getFirstIID(), 0);
                                    _waitFor = "Equip";
                                    _State = "Busy";
                                    _bc = _buffWand;
                                }
                            }
                            else if (item.getType().Equals("Cast Spell"))
                            {
                                if (inTrade || inCraft)
                                {
                                    actionQueue.Dequeue();
                                    actionQueue.Enqueue(item);
                                }
                                else if (!base.Host.Actions.CombatMode.Equals((CombatState)8))
                                {
                                    base.Host.Actions.SetCombatMode((CombatState)8);
                                    _State = "Busy";
                                    _byPassCheck = true;
                                    _waitFor = "Change Combat - Magic";
                                }
                                else
                                {
                                    IndexedCollection<CharFilterIndex, CharFilterVitalType, SkillInfoWrapper> indexeds = base.Core.CharacterFilter.Vitals;
                                    int num = indexeds[(CharFilterVitalType)6].Current;
                                    int num2 = indexeds[(CharFilterVitalType)4].Current;
                                    if (num <= Settings.Default.manaThreshold)
                                    {
                                        if (num2 < Settings.Default.staminaThreshold)
                                        {
                                            base.Host.Actions.CastSpell(Settings.Default.restamSpell, 0);
                                            _State = "Busy";
                                        }
                                        else
                                        {
                                            base.Host.Actions.CastSpell(Settings.Default.s2mSpell, 0);
                                            _State = "Busy";
                                        }
                                    }
                                    else
                                    {
                                        base.Host.Actions.CastSpell(item.getFirstIID(), 0);
                                        _State = "Busy";
                                        _waitFor = "Spell Cast";
                                    }
                                }
                            }
                            else if (item.getType().Equals("Peace Mode"))
                            {
                                base.Host.Actions.SetCombatMode((CombatState)1);
                                _State = "Idle";
                                _byPassCheck = true;
                                _waitFor = "Change Combat - Peace";
                                actionQueue.Dequeue();
                            }
                            else if (item.getType().Equals("Return Items"))
                            {
                                actionQueue.Dequeue();
                                initReturnRemainingItems();
                                _State = "Idle";
                                _byPassCheck = false;
                                _waitFor = "";
                            }
                            else if (item.getType().Equals("Face Heading"))
                            {
                                base.Host.Actions.FaceHeading(item.getHeading(), false);
                                _State = "Idle";
                                _waitFor = "";
                                actionQueue.Dequeue();
                            }
                            else if (item.getType().Equals("Face Heading Reset"))
                            {
                                if (!base.Host.Actions.CombatMode.Equals((CombatState)1))
                                {
                                    actionQueue.Enqueue(new CAction("Peace Mode"));
                                    actionQueue.Dequeue();
                                    actionQueue.Enqueue(item);
                                }
                                else
                                {
                                    base.Host.Actions.FaceHeading(_faceHeading, false);
                                    _State = "Idle";
                                    _waitFor = "";
                                    actionQueue.Dequeue();
                                }
                            }
                        }
                    }
                    else
                    {
                        if (!base.Host.Actions.CombatMode.Equals((CombatState)1))
                        {
                            actionQueue.Enqueue(new CAction("Peace Mode"));
                        }
                        if (((idleWeapon != 0) && (base.Core.WorldFilter[idleWeapon] != null)) && (base.Core.WorldFilter[idleWeapon].Values(LongValueKey.EquippedSlots) <= 0))
                        {
                            actionQueue.Enqueue(new CAction(idleWeapon, "Equip"));
                        }
                        if (Settings.Default.equipItems)
                        {
                            equipItems("No Craft");
                        }
                        if (!base.Host.Actions.Heading.Equals(_faceHeading))
                        {
                            actionQueue.Enqueue(new CAction("Face Heading Reset"));
                        }
                        _cb = false;
                        if (_queBuff)
                        {
                            buff();
                            _queBuff = false;
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void b(object A_0, EventArgs A_1)
        {
            if (_isEnabled)
            {
                _State = "Idle";
            }
        }

        private void c(object A_0, EventArgs A_1)
        {
            try
            {
                if (!this.ignoreTrades && _isEnabled)
                {
                    _c9 = true;
                    readdItemsMail();
                    ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "tradefail");
                    if ((list != null) && (list.Count > 0))
                    {
                        foreach (string str in list)
                        {
                            if (trader != null)
                            {
                                addToChatQueue("/tell " + trader.Name + ", " + str);
                            }
                        }
                        base.Host.Actions.TradeEnd();
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Split_Message(debugFile, "Error in fail to complete trade.");
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void e(object A_0, EventArgs A_1)
        {
            try
            {
                if (chatQueue.Count > 0)
                {
                    base.Host.Actions.InvokeChatParser(chatQueue.Dequeue());
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void processOutStandingMail(object A_0, EventArgs A_1)
        {
            try
            {
                ArrayList list = spamFindOutstandingMail(mailFileXML);
                if (list.Count > 0)
                {
                    generalchatPlayersHaveNotRespondedToMail(list);
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void i(object A_0, EventArgs A_1)
        {
            try
            {
                if (!this._cb)
                {
                    ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "spam");
                    if ((list.Count > 0) && _isEnabled)
                    {
                        string textToSend = (string)list[this._RandomObj.Next(0, list.Count)];
                        addToChatQueue(textToSend);
                        _cb = true;
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void j(object A_0, EventArgs A_1)
        {
            al();
            idleTimer.Stop();
        }

        private void k(object A_0, EventArgs A_1)
        {
            try
            {
                rareTimer.Stop();
                rareTimer.Enabled = false;
                actionQueue.Clear();
                actionQueue.Enqueue(new CAction("Return Items"));
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void removeLogoffEvents()
        {
            base.Core.CharacterFilter.Logoff -= new EventHandler<LogoffEventArgs>(a);
            base.Core.CharacterFilter.LoginComplete -= new EventHandler(a);
            base.Core.CharacterFilter.ActionComplete -= new EventHandler(b);
        }
                
        private void generalchatPlayersHaveNotRespondedToMail(ArrayList A_0)
        {
            try
            {
                if (A_0.Count > 0)
                {
                    addToChatQueue("/cg The following players still have not checked their mail. Please remind them! If you are the person that added their items, you can cancel their request by @telling me \"mailcancel playernametocancel\".");
                }
                else
                {
                    return;
                }
                int length = 0;
                string str = null;
                foreach (string str2 in A_0)
                {
                    if ((length + str2.Length) <= 100)
                    {
                        if (str == null)
                        {
                            str = str2;
                        }
                        else if (str.Length != 0)
                        {
                            str = str + ", " + str2;
                        }
                        else
                        {
                            str = str + str2;
                        }
                        length += str2.Length;
                    }
                    else if (str != null)
                    {
                        addToChatQueue("/cg " + str);
                        length = str2.Length;
                        str = str + str2;
                    }
                }
                if (str != null)
                {
                    addToChatQueue("/cg " + str);
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void a(int A_0)
        {
            try
            {
                addToChatQueue(string.Concat(new object[] { "/tell ", _tellPerson, ", Sorry, but you have added too many items to the window. I can hold a maximum of ", A_0, " items." }));
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellCTUsedRare(string A_0)
        {
            try
            {
                addToChatQueue(string.Concat(new object[] { "/ct I have used the ", A_0, "! Come to me within the next ", Settings.Default.rareTime, " minutes to take advantage of this rare." }));
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellMailItemsNotFound(string A_0, string A_1)
        {
            try
            {
                addToChatQueue("/tell " + _tellPerson + ", Mail items from " + A_0 + " to " + A_1 + " not found. Please check your spelling and try again.");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellAcceptTrade()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "accepttrade");
                if (((list != null) && (list.Count > 0)) && (trader != null))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellInvalidCommand()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "invalidcommand");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + _tellPerson + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellResetCommandResponse()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "resetcommandresponse");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + _tellPerson + ", " + str);
                    }
                    resetCraftingState();
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                resetCraftingState();
            }
        }

        private void ad()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "reset");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }
        
        private void sayNoComponents()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "nocomponents");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue(str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellInvalidTinkerNum()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "invalidtinkernum");
                bool flag = false;
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        flag = true;
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                    if (!flag)
                    {
                        addToChatQueue("/tell " + trader.Name + ", You cannot stop at a lower number of tinkers than the number already on the item!");
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellTraderFailure()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "failure");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void ah()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "itemnotfound");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void ai()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "rareusetargeted");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                    list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "rareuseuntargeted");
                    if ((list != null) && (list.Count > 0))
                    {
                        foreach (string str2 in list)
                        {
                            addToChatQueue(str2);
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void aj()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "rareoneuse");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void sayNoManaCharge()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "nocharge");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue(str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void al()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "inactive");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                    clsMessageWriter.Write_Split_Message(debugFile, "Closed trade window due to inactivity. Trader: " + trader.Name);
                    resetCraftingState();
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                resetCraftingState();
            }
        }

        private void am()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "returnitemsbegin");
                if ((list != null) && (list.Count > 0))
                {
                    if ((trader == null) && (_tellPerson != null))
                    {
                        foreach (string str in list)
                        {
                            addToChatQueue("/tell " + _tellPerson + ", " + str);
                        }
                    }
                    else if (trader != null)
                    {
                        foreach (string str2 in list)
                        {
                            addToChatQueue("/tell " + trader.Name + ", " + str2);
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void an()
        {
            try
            {
                addToChatQueue(string.Concat(new object[] { "/tell ", trader.Name, ", I am pausing for ", BRILLIANCE_DELAY, " seconds to give you time to cast Brilliance, should you want to. @tell me \"go\" to skip " }));
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void ao()
        {
            try
            {
                for (int i = 0; i < sortedSalvage.Count; i++)
                {
                    int num2 = ((tinkerCount - sortedSalvage.Count) + i) + 1;
                    Salvage salvage = sortedSalvage[i];
                    addToChatQueue(string.Concat(new object[] { "/tell ", trader.Name, ", Tinker ", num2, ": I have a ", salvage.getChanceOfSuccess(), "% chance to succeed WITH Brilliance and will use ", ((Salvages)salvage.getSalvageType()).ToString().Replace("_"," "), " Work: ", salvage.getWork(), "." }));
                }
                addToChatQueue("/tell " + trader.Name + ", Tell me \"yes\" to do all tinkers, or /tell me T# to have me go up to that many tinkers on the item. (i.e., to have me stop at the 8th tinker on the item, tell me \"T8\".)");
                addToChatQueue("/tell " + trader.Name + ", In other words, tell me the total number of tinkers that you want to be on the item after I am done tinkering it.");
                addToChatQueue("/tell " + trader.Name + ", If you do not wish to continue, please close the trade window.");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void ap()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "toomanytinkers");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void aq()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "invalidrecipe");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void ar()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "tradestart");
                if (((list != null) && (list.Count > 0)) && (trader != null))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                    if ((_cn && Settings.Default.enterSpamRares) && Settings.Default.useTier4Rares)
                    {
                        addToChatQueue("/tell " + trader.Name + ", I know recipes that take use of Infinite and/or Foolproof (100% success) Rare items. Please @tell me 'help' for more information.");
                    }
                    if (Settings.Default.enterSpamMail && Settings.Default.useMail)
                    {
                        addToChatQueue("/tell " + trader.Name + ", Did you know that you can send mail? Add items to the trade window and @tell me \"mail playername\" to have me give the items in the window to the specified player when they open a trade window.");
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void @tellHelp()
        {
            try
            {
                Assembly executingAssembly = Assembly.GetExecutingAssembly();
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "help");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + _tellPerson + ", " + str);
                    }
                    if (_cn && Settings.Default.useTier4Rares)
                    {
                        addToChatQueue("/tell " + _tellPerson + ", The following commands activate my tier 4 rares. NOTE: You must have a trade window open to use these commands.");
                        for (int i = 0; i < rareCommands.Count; i++)
                        {
                            if (rareCommands[i] != null)
                            {
                                addToChatQueue("/tell " + _tellPerson + ", " + rareCommands[i].ToString().Trim() + " - " + rareDesc[i].ToString().Trim());
                            }
                        }
                        addToChatQueue("/tell " + _tellPerson + ", By @telling me one of the above rare commands followed by a comma and a number (i.e., @tell " + base.Core.CharacterFilter.Name + ", stamrations, 3), I will repeat the command that many times (Max Limit: 10.)");
                    }
                    if (Settings.Default.useMail)
                    {
                        addToChatQueue("/tell " + _tellPerson + ", Did you know that you can send mail? Add items to the trade window and @tell me \"mail playername\" to have me give the items in the window to the specified player when they open a trade window.");
                    }
                    addToChatQueue(string.Concat(new object[] { "/tell ", _tellPerson, ", I am currently running CraftBot version ", executingAssembly.GetName().Version, " FireSickle II (Makain) of Harvestgain (Based on the original software by Paraduck)" }));
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void debugOutput()
        {
            try
            {
                string str = null;
                str = str + "DEBUG OUTPUT" + "-=+ACTION QUEUE:";
                foreach (CAction action in actionQueue)
                {
                    object str2 = str;
                    str = string.Concat(new object[] { str2, "-=+Action Type: ", action.getType(), " First IID: ", action.getFirstIID(), " Second IID: ", action.getSecondIID() });
                }
                str = str + "-=+PROPERTIES:";
                if (_activateItem != null)
                {
                    str = str + "-=+activateItem: " + _activateItem;
                }

                if (_byPassCheck)
                {
                    str = str + "-=+byPassCheck: true";
                }
                else
                {
                    str = str + "-=+byPassCheck: false";
                }
                
                if (_craftIncremented)
                {
                    str = str + "-=+craftIncremented: true";
                }
                else
                {
                    str = str + "-=+craftIncremented: false";
                }

                str = str + "-=+craftStepNum: " + craftStepNum;

                if (_ignoreApply)
                {
                    str = str + "-=+ignoreApply: true";
                }
                else
                {
                    str = str + "-=+ignoreApply: false";
                }

                if (_ignoreGo)
                {
                    str = str + "-=+ignoreGo: true";
                }
                else
                {
                    str = str + "-=+ignoreGo: false";
                }

                if (ignoreReset)
                {
                    str = str + "-=+ignoreReset: true";
                }
                else
                {
                    str = str + "-=+ignoreReset: false";
                }

                if (_ignoreYes)
                {
                    str = str + "-=+ignoreYes: true";
                }
                else
                {
                    str = str + "-=+ignoreYes: false";
                }

                if (tinkerIgnoreIIDs != null)
                {
                    str = str + "-=+Ignored IIDs (Tinkering):";
                    foreach (int IID in tinkerIgnoreIIDs)
                    {
                        str = str + IID.ToString();
                    }
                }

                if (ignoreTrades)
                {
                    str = str + "-=+ignoreTrades: true";
                }
                else
                {
                    str = str + "-=+ignoreTrades: false";
                }

                if (inCraft)
                {
                    str = str + "-=+inCraft: true";
                }
                else
                {
                    str = str + "-=+inCraft: false";
                }

                if (inTrade)
                {
                    str = str + "-=+inTrade: true";
                }
                else
                {
                    str = str + "-=+inTrade: false";
                }

                if (_isRareCraft)
                {
                    str = str + "-=+isRareCraft: true";
                }
                else
                {
                    str = str + "-=+isRareCraft: false";
                }

                if (_returnObjects != null)
                {
                    foreach (ReturnObject rtnObj in _returnObjects)
                    {
                        object str2 = str;
                        str = string.Concat(new object[] { str2, "-=+itemsToReturn: ", rtnObj.getID(), " to ", rtnObj.getReturnTo() });
                    }
                }

                if (_lookForCharge)
                {
                    str = str + "-=+lookForCharge: true";
                }
                else
                {
                    str = str + "-=+lookForCharge: false";
                }

                if (_lookForRares)
                {
                    str = str + "-=+lookForRares: true";
                }
                else
                {
                    str = str + "-=+lookForRares: false";
                }

                if (_lowCompsMessageSent)
                {
                    str = str + "-=+lowCompsMessageSent: true";
                }
                else
                {
                    str = str + "-=+lowCompsMessageSent: false";
                }

                if (_lowCompsMessageSentUntargeted)
                {
                    str = str + "-=+lowCompsMessageSentUntargeted: true";
                }
                else
                {
                    str = str + "-=+lowCompsMessageSentUntargeted: false";
                }
                
                if (_lowManaSent)
                {
                    str = str + "-=+lowManaSent: true";
                }
                else
                {
                    str = str + "-=+lowManaSent: false";
                }

                if (_noManaChargeSent)
                {
                    str = str + "-=+noManaChargeSent: true";
                }
                else
                {
                    str = str + "-=+noManaChargeSent: false";
                }

                str = str + "-=+nonTinkRepeatTimes: " + _nonTinkRepeatTimes;

                if (curSkill != null)
                {
                    str = str + "-=+Current Skill: " + curSkill;
                }
                
                if (finalResult != null)
                {
                    str = str + "-=+Final Result: " + finalResult;
                }

                if (_onItems != null)
                {
                    foreach (string onItem in _onItems)
                    {
                        if (onItem != null)
                        {
                            str = str + "-=+onItems: " + onItem;
                        }
                    }
                }

                if (RecipeName != null)
                {
                    str = str + "-=+Recipe Name: " + RecipeName;
                }
                
                if (_ResultItems != null)
                {
                    foreach (string resItem in _ResultItems)
                    {
                        if (resItem != null)
                        {
                            str = str + "-=+ResultItems: " + resItem;
                        }
                    }
                }

                if (_SkillChecks != null)
                {
                    foreach (string skillCheck in _SkillChecks)
                    {
                        if (skillCheck != null)
                        {
                            str = str + "-=+SkillChecks: " + skillCheck;
                        }
                    }
                }

                if (sortedSalvage != null)
                {
                    foreach (Salvage salvage in sortedSalvage)
                    {
                        if (salvage != null)
                        {
                            object str2 = str;
                            str = string.Concat(new object[] { str2, "-=+sortedSalvage: ", salvage.getName(), " Work: ", salvage.getWork(), " IID: ", salvage.getIID() });
                        }
                    }
                }

                if (_State != null)
                {
                    str = str + "-=+State: " + _State;
                }
                
                if (_tellPerson != null)
                {
                    str = str + "-=+tellPerson: " + _tellPerson;
                }
                
                if (tinkeringTarget != null)
                {
                    object obj9 = str;
                    str = string.Concat(new object[] { obj9, "-=+tinkeringTarget: ", tinkeringTarget.Name, " IID: ", tinkeringTarget.Id });
                }

                str = (str + "-=+tinkerCount: " + tinkerCount) + "-=+tinkerStopAt: " + tinkerStopAt;

                if (trader != null)
                {
                    str = str + "-=+Trader: " + trader.Name;
                }

                if (Settings.Default.useBuffs)
                {
                    str = str + "-=+useBuffs: true";
                }
                else
                {
                    str = str + "-=+useBuffs: false";
                }

                if (Settings.Default.useWeb)
                {
                    str = str + "-=+useWeb: true";
                }
                else
                {
                    str = str + "-=+useWeb: false";
                }

                if (_UseItems != null)
                {
                    foreach (string useItem in _UseItems)
                    {
                        if (useItem != null)
                        {
                            str = str + "-=+UseItems: " + useItem.ToString();
                        }
                    }
                }

                if (_waitFor != null)
                {
                    str = str + "-=+waitFor: " + _waitFor;
                }

                if (_waitForAccept)
                {
                    str = str + "-=+waitForAccept: true";
                }
                else
                {
                    str = str + "-=+waitForAccept: false";
                }

                if (waitForBrill)
                {
                    str = str + "-=+waitForBrill: true";
                }
                else
                {
                    str = str + "-=+waitForBrill: false";
                }

                str = str + "-=+waitTimer: " + _waitTimer;
                
                if (wObjResult != null)
                {
                    foreach (WorldObject objRes in wObjResult)
                    {
                        if (objRes != null)
                        {
                            object str2 = str;
                            str = string.Concat(new object[] { str2, "-=+wObjResult: ", objRes.Name, " IID: ", objRes.Id });
                        }
                    }
                }

                if (wObjTrade != null)
                {
                    foreach (WorldObject objTrade in wObjTrade)
                    {
                        if (objTrade != null)
                        {
                            object str2 = str;
                            str = string.Concat(new object[] { str2, "-=+wObjTrade: ", objTrade.Name, " IID: ", objTrade.Id });
                        }
                    }
                }

                if (_createdItems.Count > 0)
                {
                    foreach (WorldObject createdItem in _createdItems)
                    {
                        if (createdItem != null)
                        {
                            object str2 = str;
                            str = string.Concat(new object[] { str2, "-=+createdItems: ", createdItem.Name, " IID: ", createdItem.Id });
                        }
                    }
                }
                clsMessageWriter.Write_Split_Message(debugFile, str);
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void removeChatParses()
        {
            base.Core.ChatBoxMessage -= new EventHandler<ChatTextInterceptEventArgs>(ParseChatText);
            base.Core.CommandLineText -= new EventHandler<ChatParserInterceptEventArgs>(ParsePlayerInput);
        }

        private void addChatParses()
        {
            base.Core.ChatBoxMessage += new EventHandler<ChatTextInterceptEventArgs>(ParseChatText);
            base.Core.CommandLineText += new EventHandler<ChatParserInterceptEventArgs>(ParsePlayerInput);
        }

        private void removeServerDispatchEvent()
        {
            base.Core.EchoFilter.ServerDispatch -= new EventHandler<NetworkMessageEventArgs>(ServerDispatch_Handler);
        }

        private void addServerDispatchEvent()
        {
            base.Core.EchoFilter.ServerDispatch += new EventHandler<NetworkMessageEventArgs>(ServerDispatch_Handler);
        }

        private void loadDefaultSettings()
        {
            try
            {
                chkArmorTink.Checked = Settings.Default.useArmorTinkering;
                chkItemTink.Checked = Settings.Default.useItemTinerking;
                chkMagicItemTink.Checked = Settings.Default.useMagicItemTinkering;
                chkWeaponTink.Checked = Settings.Default.useWeaponTinkering;
                chkAlchemy.Checked = Settings.Default.useAlchemy;
                chkCooking.Checked = Settings.Default.useCooking;
                chkFletching.Checked = Settings.Default.useFletching;
                chkLockpick.Checked = Settings.Default.useLockpick;
                chkTier4Rares.Checked = Settings.Default.useTier4Rares;
                chkCalcMajors.Checked = Settings.Default.useMajorsForSkillCheck;
                chkJourneymanPet.Checked = Settings.Default.useJourneymanPetsSkillChecks;
                chkMasterPet.Checked = Settings.Default.useMasterPetsSkillCheck;
                chkArtisanPet.Checked = Settings.Default.useArtisanPetsSkillCheck;
                chkBuffsEnabled.Checked = Settings.Default.useBuffs;
                chkUseBeers.Checked = Settings.Default.useBeers;
                chkUseRares.Checked = Settings.Default.useBuffRares;
                chkUseBuffBot.Checked = Settings.Default.useBuffBot;
                chkLogOff.Checked = Settings.Default.logoffOnMonsterDetect;
                chkUseCharge.Checked = Settings.Default.useManaStones;
                chkEquip.Checked = Settings.Default.equipItems;
                chkBuffOnStart.Checked = Settings.Default.rebuffOnStart;
                chkUseWeb.Checked = Settings.Default.useWeb;
                chkRareAllegChan.Checked = Settings.Default.rareBroadcastToAllegianceChan;
                chkRareTradeChan.Checked = Settings.Default.rareBroadcastToTradeChan;
                chkEnableMail.Checked = Settings.Default.useMail;
                chkEnterSpamMail.Checked = Settings.Default.enterSpamMail;
                chkEnterSpamRare.Checked = Settings.Default.enterSpamRares;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void findManaCharge()
        {
            try
            {
                _lookForCharge = true;
                foreach (WorldObject wObj in base.Core.WorldFilter.GetInventory())
                {
                    if (wObj.Name.Contains("Mana Charge"))
                    {
                        base.Host.Actions.RequestId(wObj.Id);
                        return;
                    }
                    if (wObj.Name.Contains("Mana Stone"))
                    {
                        base.Host.Actions.RequestId(wObj.Id);
                        return;
                    }
                }
                if (!this._noManaChargeSent)
                {
                    sayNoManaCharge();
                    _noManaChargeSent = true;
                }
                _lookForCharge = false;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void addLoggingEvents()
        {
            base.Core.CharacterFilter.Logoff += new EventHandler<LogoffEventArgs>(a);
            base.Core.CharacterFilter.LoginComplete += new EventHandler(a);
            base.Core.CharacterFilter.ActionComplete += new EventHandler(b);
        }

        private void b(ArrayList A_0)
        {
            try
            {
                if (A_0 != null)
                {
                    int num = 1;
                    addToChatQueue("/tell " + trader.Name + ", The following players still have not checked their mail. Please remind them, or cancel their request by @telling me \"mailcancel playernametocancel\".");
                    foreach (string str in A_0)
                    {
                        addToChatQueue(string.Concat(new object[] { "/tell ", trader.Name, ", ", str, " (", num, " of ", A_0.Count, ")" }));
                        num++;
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void b(int A_0)
        {
            try
            {
                addToChatQueue(string.Concat(new object[] { "/tell ", trader.Name, ", I have a ", A_0, "% chance to succeed. Please /tell me \"yes\" to continue. If you do not wish to do so, please close the trade window." }));
                if (A_0 == 0)
                {
                    addToChatQueue("/tell " + trader.Name + ", This is a bug, and I am resetting myself.");
                    resetCraftingState();
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellAllegianceUsedRare(string A_0)
        {
            try
            {
                addToChatQueue(string.Concat(new object[] { "/a I have used the ", A_0, "! Come to me within the next ", Settings.Default.rareTime, " minutes to take advantage of this rare." }));
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellMailItemsSuccessfullyRemoved(string A_0, string A_1)
        {
            try
            {
                addToChatQueue("/tell " + _tellPerson + ", Mail items to " + A_1 + " successfully removed. Please come to me and open a trade window to pick up your items.");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void removeTradeEvents()
        {
            base.Core.WorldFilter.ResetTrade -= new EventHandler<ResetTradeEventArgs>(a);
            base.Core.WorldFilter.ReleaseObject -= new EventHandler<ReleaseObjectEventArgs>(a);
            base.Core.WorldFilter.FailToCompleteTrade -= new EventHandler(c);
            base.Core.WorldFilter.EnterTrade -= new EventHandler<EnterTradeEventArgs>(a);
            base.Core.WorldFilter.EndTrade -= new EventHandler<EndTradeEventArgs>(a);
            base.Core.WorldFilter.DeclineTrade -= new EventHandler<DeclineTradeEventArgs>(a);
            base.Core.WorldFilter.CreateObject -= new EventHandler<CreateObjectEventArgs>(a);
            base.Core.WorldFilter.ChangeObject -= new EventHandler<ChangeObjectEventArgs>(a);
            base.Core.WorldFilter.AddTradeItem -= new EventHandler<AddTradeItemEventArgs>(a);
            base.Core.WorldFilter.AcceptTrade -= new EventHandler<AcceptTradeEventArgs>(a);
        }

        private void c(string A_0)
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "invalidplayer");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + A_0 + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void c(string A_0, string A_1)
        {
            try
            {
                addToChatQueue("/tell " + _tellPerson + ", Mail items successfully added. If you would like to cancel your request, @tell me \"mailcancel " + A_1 + "\". This will remove all mail items to " + A_1 + " that you have added.");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void addTradeEvents()
        {
            base.Core.WorldFilter.ResetTrade += new EventHandler<ResetTradeEventArgs>(a);
            base.Core.WorldFilter.ReleaseObject += new EventHandler<ReleaseObjectEventArgs>(a);
            base.Core.WorldFilter.FailToCompleteTrade += new EventHandler(c);
            base.Core.WorldFilter.EnterTrade += new EventHandler<EnterTradeEventArgs>(a);
            base.Core.WorldFilter.EndTrade += new EventHandler<EndTradeEventArgs>(a);
            base.Core.WorldFilter.DeclineTrade += new EventHandler<DeclineTradeEventArgs>(a);
            base.Core.WorldFilter.CreateObject += new EventHandler<CreateObjectEventArgs>(a);
            base.Core.WorldFilter.ChangeObject += new EventHandler<ChangeObjectEventArgs>(a);
            base.Core.WorldFilter.AddTradeItem += new EventHandler<AddTradeItemEventArgs>(a);
            base.Core.WorldFilter.AcceptTrade += new EventHandler<AcceptTradeEventArgs>(a);
        }

        private void tellDoNotKnowRecipe(string A_0)
        {
            try
            {
                addToChatQueue("/tell " + _tellPerson + ", Sorry, I do not know the " + A_0 + " recipe. I am now resetting.");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void e()
        {
            try
            {
                if ((_cs != null) && (wObjTrade != null))
                {
                    foreach (string str in _cs)
                    {
                        foreach (WorldObject obj2 in wObjTrade)
                        {
                            if (obj2.Name.Contains(str))
                            {
                                actionQueue.Enqueue(new CAction(obj2.Id, "Use Beer"));
                                break;
                            }
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void e(string A_0)
        {
            try
            {
                addToChatQueue("/tell " + trader.Name + ", Sorry, but my owner has disabled all " + A_0 + " recipes. I am now closing the trade window.");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void f()
        {
            try
            {
                if (!this.loadBuffs(personalFolderPath + @"\spells.xml"))
                {
                    WriteToChat("Error: spells.xml could not be loaded. Please check " + personalFolderPath + @"\errorLog.txt for more information.");
                }
                if (!this.loadPortals(personalFolderPath + @"\spells.xml"))
                {
                    WriteToChat("Error: spells.xml could not be loaded. Please check " + personalFolderPath + @"\errorLog.txt for more information.");
                }
                if (!this.loadEquipment(personalFolderPath + @"\equipment.xml"))
                {
                    WriteToChat("Error: equipment.xml could not be loaded. Please check " + personalFolderPath + @"\errorLog.txt for more information.");
                }
                if (!this.loadRareCommands(personalFolderPath + @"\recipes.xml"))
                {
                    WriteToChat("Error: recipes.xml could not be loaded. Please check " + personalFolderPath + @"\errorLog.txt for more information.");
                }
                if (!this.loadAdTimer(personalFolderPath + @"\chat.xml"))
                {
                    WriteToChat("Error: chat.xml could not be loaded. Please check " + personalFolderPath + @"\errorLog.txt for more information.");
                }
                if (Settings.Default.equipItems)
                {
                    equipItems("No Craft");
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void f(string A_0)
        {
            try
            {
                addToChatQueue("I have no " + A_0 + " left! Please hand me some so that I can use it for tinkering.");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void f(object A_0, EventArgs A_1)
        {
            try
            {
                string str = string.Concat(new object[] { _cd, "&server=", base.Core.CharacterFilter.Server, "&charname=", base.Core.CharacterFilter.Name, "&version=", Assembly.GetExecutingAssembly().GetName().Version });
                //_WebReq.PostString(_cz + initActions(str, _cd + _c3));
                //webTimer.Start();
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void g()
        {
            try
            {
                foreach (string str in _RareList)
                {
                    foreach (WorldObject obj2 in wObjTrade)
                    {
                        if (obj2.Name.Equals(str))
                        {
                            actionQueue.Enqueue(new CAction(obj2.Id, "Use Rare"));
                            rareTimer.Enabled = true;
                            rareTimer.Start();
                            if (Settings.Default.rareBroadcastToAllegianceChan)
                            {
                                tellAllegianceUsedRare(obj2.Name);
                            }
                            if (Settings.Default.rareBroadcastToTradeChan)
                            {
                                tellCTUsedRare(obj2.Name);
                            }
                            return;
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void g(string A_0)
        {
            try
            {
                addToChatQueue("Eek! " + A_0 + " is scary to a crafter! I'm going to log off now.");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void WebRequestSuccessful(object A_0, EventArgs A_1)
        {
            try
            {
                if ((_WebReq.GetContent() != null) && !this._WebReq.GetContent().Equals(""))
                {
                    if (_WebReq.GetContent().Contains("successfully sent") || _WebReq.GetContent().Contains("CraftBot"))
                    {
                        WriteToChat(_WebReq.GetContent());
                    }
                    else
                    {
                        _currentLocation = _WebReq.GetContent();
                    }
                    webTimer.Stop();
                    _WebReq.SetContentToNull();
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellNotProcessingNewMail()
        {
            try
            {
                addToChatQueue("/tell " + _tellPerson + ", Sorry, but I am not currently processing new mail requests. Any existing mail items will be delivered, however.");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void h(string A_0)
        {
            try
            {
                addToChatQueue("/tell " + trader.Name + ", I cannot find valid items for the " + A_0 + " recipe. Aborting.");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellMustAddItemsBeforeCommand()
        {
            try
            {
                addToChatQueue("/tell " + _tellPerson + ", You must add items to the trade window before giving me this command!");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellCannotFindRecipeItem(string A_0, int i)
        {
            try
            {
                //addToChatQueue(A_0 + " " + i.ToString());

                if (trader != null)
                {
                    string textToSend = "/tell " + trader.Name + ", I cannot find the " + A_0 + " which is required to continue. Aborting. The recipe uses the following items: ";
                    foreach (string str2 in _recipeItems)
                    {
                        if (str2 != null)
                        {
                            textToSend = textToSend + str2 + ", ";
                        }
                    }
                    textToSend = textToSend.Substring(0, textToSend.Length - 2);
                    addToChatQueue(textToSend);
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellUnkownErrorOccured()
        {
            try
            {
                addToChatQueue("/tell " + _tellPerson + ", An unknown error occured. Please report this!");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void processToldCommand(string cmd)
        {
            try
            {
                if ((cmd.Equals("") || (cmd == null)) || cmd.Equals(" "))
                {
                    return;
                }

                if ((cmd.Length >= 9) && cmd.StartsWith("message"))
                {
                    writeMessage(personalFolderPath + @"\messages.xml", _tellPerson, cmd.Substring(8));
                    ListRow row = listMessages.Add();
                    row[0][0] = _tellPerson;
                    row[1][0] = cmd.Substring(8);
                    row[2][0] = DateTime.Now;
                    tellMessageResponse();
                    return;
                }

                if ((cmd.Length >= 12) && cmd.StartsWith("mailcancel"))
                {
                    clsMessageWriter.Write_Message(mailFile, "Got mail cancel command from " + _tellPerson + ". Target Player: " + cmd.Substring(11));
                    processMailCancel(cmd.Substring(11), _tellPerson);
                    return;
                }

                if ((Settings.Default.useMail && (cmd.Length >= 6)) && cmd.StartsWith("mail"))
                {
                    if (wObjTrade.Count > 0)
                    {
                        clsMessageWriter.Write_Message(mailFile, "Got mail command from " + _tellPerson + ". Target Player: " + cmd.Substring(5));
                        processMail(cmd.Substring(5), _tellPerson);
                    }
                    else
                    {
                        tellMustAddItemsBeforeCommand();
                    }
                    return;
                }

                if ((!Settings.Default.useMail && (cmd.Length >= 6)) && cmd.StartsWith("mail"))
                {
                    tellNotProcessingNewMail();
                    return;
                }

                if ((_WaitForRecipeName && (trader != null)) && _tellPerson.Equals(trader.Name))
                {
                    if (recipeExists(cmd, personalFolderPath + @"\recipes.xml"))
                    {
                        setSkill(cmd, personalFolderPath + @"\recipes.xml");
                        startCrafting();
                    }
                    else if ((int.Parse(cmd) <= _RecipeList.Count) && (int.Parse(cmd) >= 1))
                    {
                        if (recipeExists((string)_RecipeList[int.Parse(cmd) - 1], personalFolderPath + @"\recipes.xml"))
                        {
                            setSkill((string)_RecipeList[int.Parse(cmd) - 1], personalFolderPath + @"\recipes.xml");
                            startCrafting();
                        }
                        else
                        {
                            tellDoNotKnowRecipe(cmd);
                            resetCraftingState();
                        }
                    }
                    else
                    {
                        tellDoNotKnowRecipe(cmd);
                        resetCraftingState();
                    }
                    return;
                }

                if (cmd.Equals("help"))
                {
                    @tellHelp();
                    return;
                }

                if ((cmd.Equals("loc") || cmd.Equals("location")) || cmd.Equals("where"))
                {
                    tellCurrentLocation();
                    return;
                }

                if (cmd.Equals("reset"))
                {
                    tellResetCommandResponse();
                    resetCraftingState();
                    return;
                }

                if (cmd.Equals("whereto"))
                {
                    tellWhereTo();
                    return;
                }

                if (cmd.Equals("skills") || cmd.Equals("skill"))
                {
                    tellCurrentSkillLevels();
                    return;
                }

                if (cmd.Equals("firesickle") || cmd.Equals("firesickle"))
                {
                    foreach (Salvage wObj in sortedSalvage)
                    {
                        addToChatQueue("TradeData " + wObj.getSalvageType() + " Work: " + wObj.getWork());
                    }
                }

                if (!this.inTrade)
                {
                    if (inCraft)
                    {
                        if (cmd.Equals("go") && !this._ignoreGo)
                        {
                            _givenGo = true;
                            if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                            {
                                actionQueue.Dequeue();
                                _State = "Idle";
                                craftingDoWork();
                            }
                            else
                            {
                                _waitTimer = 0;
                                _State = "Idle";
                                craftingDoWork();
                            }
                        }
                        else if (cmd.Equals("primary"))
                        {
                            tellPortalFailure();
                        }
                        else if (cmd.Equals("secondary"))
                        {
                            tellPortalFailure();
                        }
                    }
                    else if (cmd.Equals("primary"))
                    {
                        if ((_primaryPortalSpellId > 0) && (_primaryPortalLocation != null))
                        {
                            if (_buffWand == 0)
                            {
                                WriteToChat("Error: No buff wand set!");
                            }
                            else if (base.Core.WorldFilter[_buffWand] == null)
                            {
                                WriteToChat("Error: Buff wand does not exist!");
                            }
                            else
                            {
                                if (base.Core.WorldFilter[_buffWand].Values(LongValueKey.EquippedSlots) != 0x1000000)
                                {
                                    actionQueue.Enqueue(new CAction(_buffWand, "Buff"));
                                }
                                actionQueue.Enqueue(new CAction(_faceHeading + 45.0, "Face Heading"));
                                actionQueue.Enqueue(new CAction(_primaryPortalSpellId, "Cast Spell"));
                                tellIamNowSummoningPrimary();
                                sayIamNowSummoningPrimary();
                            }
                        }
                        else
                        {
                            tellPortalConfigError();
                        }
                    }
                    else if (cmd.Equals("secondary"))
                    {
                        if ((_secondaryPortalSpellId > 0) && (_secondaryPortalLocation != null))
                        {
                            if (_buffWand == 0)
                            {
                                WriteToChat("Error: No buff wand set!");
                            }
                            else if (base.Core.WorldFilter[_buffWand] == null)
                            {
                                WriteToChat("Error: Buff wand does not exist!");
                            }
                            else
                            {
                                if (base.Core.WorldFilter[_buffWand].Values(LongValueKey.EquippedSlots) != 0x1000000)
                                {
                                    actionQueue.Enqueue(new CAction(_buffWand, "Buff"));
                                }
                                actionQueue.Enqueue(new CAction(_faceHeading - 45.0, "Face Heading"));
                                actionQueue.Enqueue(new CAction(_secondaryPortalSpellId, "Cast Spell"));
                                tellIamNowSummoningSecondary();
                                sayIamNowSummoningSecondary();
                            }
                        }
                        else
                        {
                            tellPortalConfigError();
                        }
                    }
                    return;
                }
                string key = cmd;
                if (key != null)
                {
                    int num3;
                    if (_dictionaryCmds == null)
                    {
                        Dictionary<string, int> dictionary1 = new Dictionary<string, int>(0x10);
                        dictionary1.Add("help", 0);
                        dictionary1.Add("y", 1);
                        dictionary1.Add("yes", 2);
                        dictionary1.Add("go", 3);
                        dictionary1.Add("t1", 4);
                        dictionary1.Add("t2", 5);
                        dictionary1.Add("t3", 6);
                        dictionary1.Add("t4", 7);
                        dictionary1.Add("t5", 8);
                        dictionary1.Add("t6", 9);
                        dictionary1.Add("t7", 10);
                        dictionary1.Add("t8", 11);
                        dictionary1.Add("t9", 12);
                        dictionary1.Add("t10", 13);
                        dictionary1.Add("primary", 14);
                        dictionary1.Add("secondary", 15);
                        _dictionaryCmds = dictionary1;
                    }
                    if (_dictionaryCmds.TryGetValue(key, out num3))
                    {
                        switch (num3)
                        {
                            case 0: //help
                                @tellHelp();
                                return;

                            case 1: //y
                                if (inCraft && !this._ignoreYes)
                                {
                                    tinkerStopAt = 10;
                                    craftingAccept();
                                }
                                return;

                            case 2: //yes
                                if (inCraft && !this._ignoreYes)
                                {
                                    tinkerStopAt = 10;
                                    craftingAccept();
                                }
                                return;

                            case 3: //go
                                if (!this._ignoreGo)
                                {
                                    _givenGo = true;
                                    if (((actionQueue.Count <= 0) || !this.actionQueue.Peek().getType().Equals("Wait")) || !this.inCraft)
                                    {
                                        goto Label_085B;
                                    }
                                    actionQueue.Dequeue();
                                    _waitTimer = 0;
                                    _State = "Idle";
                                    craftingDoWork();
                                }
                                return;

                            case 4: //t1
                                if (!this.inCraft)
                                {
                                    goto Label_08FD;
                                }
                                tinkerStopAt = 1;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_08B1;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 5: //t2
                                if (!this.inCraft)
                                {
                                    goto Label_0992;
                                }
                                tinkerStopAt = 2;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0946;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 6: //t3
                                if (!this.inCraft)
                                {
                                    goto Label_0A27;
                                }
                                tinkerStopAt = 3;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_09DB;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 7: //t4
                                if (!this.inCraft)
                                {
                                    goto Label_0ABC;
                                }
                                tinkerStopAt = 4;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0A70;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 8: //t5
                                if (!this.inCraft)
                                {
                                    goto Label_0B51;
                                }
                                tinkerStopAt = 5;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0B05;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 9: //t6
                                if (!this.inCraft)
                                {
                                    goto Label_0BE6;
                                }
                                tinkerStopAt = 6;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0B9A;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 10: //t7
                                if (!this.inCraft)
                                {
                                    goto Label_0C7B;
                                }
                                tinkerStopAt = 7;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0C2F;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 11: //t8
                                if (!this.inCraft)
                                {
                                    goto Label_0D10;
                                }
                                tinkerStopAt = 8;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0CC4;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 12: //t9
                                if (!this.inCraft)
                                {
                                    goto Label_0DA6;
                                }
                                tinkerStopAt = 9;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0D5A;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 13: //t10
                                if (!this.inCraft)
                                {
                                    goto Label_0E39;
                                }
                                tinkerStopAt = 10;
                                if (tinkerStopAt > tinkerCountCopy)
                                {
                                    goto Label_0DF0;
                                }
                                tellInvalidTinkerNum();
                                resetCraftingState();
                                return;

                            case 14: //primary
                                tellPortalFailure();
                                return;

                            case 15: //secondary
                                tellPortalFailure();
                                return;
                        }
                    }
                }
                goto Label_0E61;
            Label_085B:
                if (inCraft)
                {
                    _State = "Idle";
                    _waitTimer = 0;
                    craftingDoWork();
                }
                return;
            Label_08B1:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_08FD:
                clsMessageWriter.Write_Split_Message(debugFile, "T1 command received at invalid time.");
                debugOutput();
                return;
            Label_0946:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0992:
                clsMessageWriter.Write_Split_Message(debugFile, "T2 command received at invalid time.");
                debugOutput();
                return;
            Label_09DB:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0A27:
                clsMessageWriter.Write_Split_Message(debugFile, "T3 command received at invalid time.");
                debugOutput();
                return;
            Label_0A70:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0ABC:
                clsMessageWriter.Write_Split_Message(debugFile, "T4 command received at invalid time.");
                debugOutput();
                return;
            Label_0B05:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0B51:
                clsMessageWriter.Write_Split_Message(debugFile, "T5 command received at invalid time.");
                debugOutput();
                return;
            Label_0B9A:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0BE6:
                clsMessageWriter.Write_Split_Message(debugFile, "T6 command received at invalid time.");
                debugOutput();
                return;
            Label_0C2F:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0C7B:
                clsMessageWriter.Write_Split_Message(debugFile, "T7 command received at invalid time.");
                debugOutput();
                return;
            Label_0CC4:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0D10:
                clsMessageWriter.Write_Split_Message(debugFile, "T8 command received at invalid time.");
                debugOutput();
                return;
            Label_0D5A:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0DA6:
                clsMessageWriter.Write_Split_Message(debugFile, "T9 command received at invalid time.");
                debugOutput();
                return;
            Label_0DF0:
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Wait"))
                {
                    actionQueue.Dequeue();
                }
                _State = "Idle";
                craftingAccept();
                return;
            Label_0E39:
                clsMessageWriter.Write_Split_Message(debugFile, "T10 command received at invalid time.");
                debugOutput();
                return;
            Label_0E61:
                if (Settings.Default.useTier4Rares)
                {
                    if (!processRareCommand(cmd))
                    {
                        tellInvalidCommand();
                    }
                }
                else
                {
                    tellInvalidCommand();
                }
            }
            catch (Exception exception)
            {
                if (_WaitForRecipeName)
                {
                    tellDoNotKnowRecipe(cmd);
                    resetCraftingState();
                }
                else
                {
                    clsMessageWriter.Write_Error(errorLogFile, exception);
                    resetCraftingState();
                }
            }
        }

        private void tellCurrentLocation()
        {
            try
            {
                addToChatQueue("/tell " + _tellPerson + ", I am located at " + _currentLocation + ".");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellMessageResponse()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "msgresponse");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + _tellPerson + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void buffEvent(object A_0, EventArgs A_1)
        {
            try
            {
                buff();
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void m()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "tradeend");
                if (((list != null) && (trader != null)) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellCurrentSkillLevels()
        {
            try
            {
                string str = "";
                if (Settings.Default.useAlchemy)
                {
                    object str2 = str;
                    str = string.Concat(new object[] { str2, "Alchemy: ", base.Host.Actions.Skill[(Decal.Adapter.Wrappers.SkillType)0x26], " " });
                }
                if (Settings.Default.useArmorTinkering)
                {
                    object str2 = str;
                    str = string.Concat(new object[] { str2, "Armor Tinkering: ", base.Host.Actions.Skill[(Decal.Adapter.Wrappers.SkillType)0x1d], " " });
                }
                if (Settings.Default.useCooking)
                {
                    object str2 = str;
                    str = string.Concat(new object[] { str2, "Cooking: ", base.Host.Actions.Skill[(Decal.Adapter.Wrappers.SkillType)0x27], " " });
                }
                if (Settings.Default.useFletching)
                {
                    object str2 = str;
                    str = string.Concat(new object[] { str2, "Fletching: ", base.Host.Actions.Skill[(Decal.Adapter.Wrappers.SkillType)0x25], " " });
                }
                if (Settings.Default.useItemTinerking)
                {
                    object str2 = str;
                    str = string.Concat(new object[] { str2, "Item Tinkering: ", base.Host.Actions.Skill[(Decal.Adapter.Wrappers.SkillType)0x12], " " });
                }
                if (Settings.Default.useLockpick)
                {
                    object str2 = str;
                    str = string.Concat(new object[] { str2, "Lockpick: ", base.Host.Actions.Skill[(Decal.Adapter.Wrappers.SkillType)0x17], " " });
                }
                if (Settings.Default.useMagicItemTinkering)
                {
                    object str2 = str;
                    str = string.Concat(new object[] { str2, "Magic Item Tinkering: ", base.Host.Actions.Skill[(Decal.Adapter.Wrappers.SkillType)30], " " });
                }
                if (Settings.Default.useWeaponTinkering)
                {
                    object str2 = str;
                    str = string.Concat(new object[] { str2, "Weapon Tinkering: ", base.Host.Actions.Skill[(Decal.Adapter.Wrappers.SkillType)0x1c], " " });
                }
                if ((str == null) || (str == ""))
                {
                    str = str.Trim();
                }
                addToChatQueue("/tell " + _tellPerson + ", Current skill values: " + str);
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void o()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "lowmana");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue(str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void p()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "nothingtodo");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void q()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "stacksize");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void r()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "toomanytargets");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + trader.Name + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellFoundMultipleRecipes()
        {
            try
            {
                addToChatQueue("/tell " + trader.Name + ", I have found multiple recipes with that activation item. Please @tell me the EXACT recipe name OR number that you want me to use.");
                for (int i = 0; i < _RecipeList.Count; i++)
                {
                    addToChatQueue(string.Concat(new object[] { "/t ", trader.Name, ", Recipe ", i + 1, " - ", _RecipeList[i].ToString().Trim() }));
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellWhereTo()
        {
            try
            {
                if (_primaryPortalLocation != null)
                {
                    addToChatQueue("/t " + _tellPerson + ", Tell me \"primary\" to get a portal to " + _primaryPortalLocation.Trim());
                }
                if (_secondaryPortalLocation != null)
                {
                    addToChatQueue("/t " + _tellPerson + ", Tell me \"secondary\" to get a portal to " + _secondaryPortalLocation.Trim());
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellPortalConfigError()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "portalconfigerror");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + _tellPerson + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellPortalFailure()
        {
            try
            {
                ArrayList list = dynamicLoadChat(personalFolderPath + @"\chat.xml", "portalfailure");
                if ((list != null) && (list.Count > 0))
                {
                    foreach (string str in list)
                    {
                        addToChatQueue("/tell " + _tellPerson + ", " + str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void sayIamNowSummoningSecondary()
        {
            try
            {
                addToChatQueue("I am now summoning a portal to " + _secondaryPortalLocation.Trim() + " for " + _tellPerson + ".");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void sayIamNowSummoningPrimary()
        {
            try
            {
                addToChatQueue("I am now summoning a portal to " + _primaryPortalLocation.Trim() + " for " + _tellPerson + ".");
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellIamNowSummoningSecondary()
        {
            try
            {
                addToChatQueue("/tell " + _tellPerson + ", I am now summoning a portal to " + _secondaryPortalLocation.Trim());
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        private void tellIamNowSummoningPrimary()
        {
            try
            {
                addToChatQueue("/tell " + _tellPerson + ", I am now summoning a portal to " + _primaryPortalLocation.Trim());
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        #endregion

        #region PrivateVoids

        public void addToChatQueue(string textToSend)
        {
            try
            {
                chatQueue.Enqueue(textToSend + _b5);
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void addToChatQueueNoTag(string textToSend)
        {
            try
            {
                chatQueue.Enqueue(textToSend);
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void buff()
        {
            try
            {
                if (Settings.Default.useBuffBot)
                {
                    buffBot();
                }
                else if (inCraft || inTrade)
                {
                    _queBuff = true;
                }
                else
                {
                    base.Core.Filter<FileService>();
                    if (_buffWand == 0)
                    {
                        WriteToChat("Error: No buff wand set!");
                    }
                    else if (_buffList.Count <= 0)
                    {
                        WriteToChat("Error: No buffs defined!");
                    }
                    else
                    {
                        if (Settings.Default.equipItems)
                        {
                            equipItems("No Craft");
                        }
                        if (base.Core.WorldFilter[_buffWand] == null)
                        {
                            WriteToChat("Error: Buff wand does not exist!");
                        }
                        else
                        {
                            if (base.Core.WorldFilter[_buffWand].Values(LongValueKey.EquippedSlots) != 0x1000000)
                            {
                                actionQueue.Enqueue(new CAction(_buffWand, "Buff"));
                            }
                            foreach (string str in _buffList)
                            {
                                int firstIID = int.Parse(str);
                                actionQueue.Enqueue(new CAction(firstIID, "Cast Spell"));
                            }
                            actionQueue.Enqueue(new CAction("Peace Mode"));
                            _isBuffing = true;
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                _isBuffing = false;
            }
        }

        public void buffBot()
        {
            try
            {
                foreach (string str in dynamicLoadBuffBot(personalFolderPath + @"\spells.xml", "buffbot"))
                {
                    if ((str != null) && (str != ""))
                    {
                        addToChatQueueNoTag(str);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void buildRecipeList()
        {
            foreach (string sUseItem in _UseItems)
            {
                if (sUseItem == null)
                {
                    continue;
                }
                bool flag = true;
                foreach (string sResItem in _ResultItems)
                {
                    if (((sUseItem != null) && (sResItem != null)) && sResItem.Equals(sUseItem))
                    {
                        flag = false;
                        break;
                    }
                }
                if ((sUseItem != null) && flag)
                {
                    _recipeItems.Add(sUseItem);
                }
            }
            foreach (string str3 in _onItems)
            {
                if (str3 == null)
                {
                    continue;
                }
                bool flag2 = true;
                foreach (string str4 in _ResultItems)
                {
                    if (((str3 != null) && (str4 != null)) && str4.Equals(str3))
                    {
                        flag2 = false;
                        break;
                    }
                }
                if ((str3 != null) && flag2)
                {
                    _recipeItems.Add(str3);
                }
            }
        }

        public void checkVersion()
        {
            try
            {
                _WebReq.GetString(_versionCheckingPath + Assembly.GetExecutingAssembly().GetName().Version);
                webTimer.Start();
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void clearMessages(string filename)
        {
            try
            {
                XmlDocument document = new XmlDocument();
                document.Load(filename);
                XPathNavigator navigator = document.CreateNavigator();
                while (navigator.MoveToFirstChild())
                {
                    if (navigator.Name.Equals("message"))
                    {
                        navigator.DeleteSelf();
                    }
                }
                document.Save(filename);
                listMessages.Clear();
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void craftingAccept()
        {
            try
            {
                _ignoreYes = true;
                _ignoreGo = false;
                ignoreReset = true;
                base.Host.Actions.TradeAccept();
                inCraft = true;
                ignoreTrades = true;
                foreach (WorldObject obj2 in wObjTrade)
                {
                    writeReturnItem(riFile, new ReturnObject(obj2.Id, trader.Name));
                }
                if ((tinkeringTarget == null) && (trader != null))
                {
                    clsMessageWriter.Write_Split_Message(debugFile, "Crafting " + RecipeName + " for " + trader.Name + ".");
                }
                else if (trader != null)
                {
                    clsMessageWriter.Write_Split_Message(debugFile, "Crafting " + RecipeName + " for " + trader.Name + ". Target: " + tinkeringTarget.Name);
                }
                base.Host.Actions.TradeEnd();
                if (((curSkill != null) && curSkill.Equals("Rare Tier 4")) && Settings.Default.equipItems)
                {
                    equipItems("No Craft");
                }
                else if ((curSkill != null) && Settings.Default.equipItems)
                {
                    equipItems(curSkill);
                }
                else if (Settings.Default.equipItems)
                {
                    equipItems("No Craft");
                }
                actionQueue.Enqueue(new CAction(BRILLIANCE_DELAY, "Wait"));
                an();
                _byPassCheck = true;
                waitForBrill = true;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void craftingDoWork()
        {
            try
            {
                _ignoreGo = true;
                _ignoreYes = true;
                ignoreReset = true;
                ignoreTrades = true;
                if (Settings.Default.useBeers)
                {
                    e();
                }
                if (_lookForRares && Settings.Default.useBuffRares)
                {
                    g();
                }
                if (curSkill == null)
                {
                    actionQueue.Enqueue(new CAction("Return Items"));
                }
                else if ((curSkill.Equals("Armor Tinkering") || curSkill.Equals("Item Tinkering")) || (curSkill.Equals("Magic Item Tinkering") || curSkill.Equals("Weapon Tinkering")))
                {
                    int newtinkerCountCopy = tinkerCountCopy;
                    ArrayList list = new ArrayList();
                    foreach (Salvage salvage in sortedSalvage)
                    {
                        if (((salvage != null) && (salvage.getName() != null)) && (salvage.getIID() != 0))
                        {
                            if (newtinkerCountCopy >= tinkerStopAt)
                            {
                                actionQueue.Enqueue(new CAction("Return Items"));
                                return;
                            }
                            if (tinkeringTarget == null)
                            {
                                ah();
                                actionQueue.Clear();
                                actionQueue.Enqueue(new CAction("Return Items"));
                                return;
                            }
                            if ((!list.Contains(salvage.getIID()) && (tinkerIgnoreIIDs != null)) && !this.tinkerIgnoreIIDs.Contains(salvage.getIID()))
                            {
                                tinkerIgnoreIIDs.Add(salvage.getIID());
                                list.Add(salvage.getIID());
                                itemsQueued = true;
                                actionQueue.Enqueue(new CAction(salvage.getIID(), tinkeringTarget.Id, "Apply Item"));
                                newtinkerCountCopy++;
                            }
                        }
                    }
                }
                else if (craftStepNum > 0)
                {
                    resetCraftingState();
                }
                else
                {
                    craftStepNum = 1;
                    doCraftStep(1);
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void deleteReturnItem(string filename, ReturnObject ro)
        {
            try
            {
                XmlDocument document = new XmlDocument();
                try
                {
                    document.Load(filename);
                }
                catch (FileNotFoundException)
                {
                    XmlDeclaration newChild = document.CreateXmlDeclaration("1.0", "utf-8", null);
                    XmlElement element = document.CreateElement("items");
                    document.InsertBefore(newChild, document.DocumentElement);
                    document.AppendChild(element);
                }
                XmlElement documentElement = document.DocumentElement;
                foreach (XmlNode node in documentElement.ChildNodes)
                {
                    if (int.Parse(node.Attributes["iid"].Value) == ro.getID())
                    {
                        documentElement.RemoveChild(node);
                        document.Save(filename);
                        _returnObjects.Remove(ro);
                        for (int i = 0; i < listReturn.RowCount; i++)
                        {
                            if ((base.Core.WorldFilter[ro.getID()] != null) && listReturn[i][1][0].ToString().Equals(base.Core.WorldFilter[ro.getID()].Name))
                            {
                                listReturn.Delete(i);
                                listReturn.ScrollPosition = 0;
                                return;
                            }
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void doCraftStep(int num)
        {
            try
            {
                _ignoreGo = true;
                _craftIncremented = false;
                _bt = true;
                int itemsIndex = 0;
                int num3 = 0;
                bool flag = false;
                IEnumerator enumerator = _UseItems.GetEnumerator();
                while (enumerator.MoveNext())
                {
                    if (((((string)enumerator.Current) != null) && (_onItems[itemsIndex] != null)) && (_ResultItems[itemsIndex] != null))
                    {
                        flag = true;
                    }
                }
                enumerator = null;
                if (!flag)
                {
                    p();
                    actionQueue.Enqueue(new CAction("Return Items"));
                }
                else
                {
                    foreach (string sUseItem in _UseItems)
                    {
                        if (((sUseItem == null) || (_onItems[itemsIndex] == null)) || (_ResultItems[itemsIndex] == null))
                        {
                            itemsIndex++;
                            continue;
                        }
                        num3++;

                        if (num3 < craftStepNum)
                        {
                            itemsIndex++;
                            continue;
                        }
                        
                        WorldObject itemToUse = null;
                        foreach (WorldObject tradeObj in wObjTrade)
                        {
                            if (tradeObj.Name.Equals(sUseItem))
                            {
                                itemToUse = tradeObj;
                            }
                        }
                        if ((itemToUse == null) && (_createdItems.Count > 0))
                        {
                            foreach (WorldObject obj4 in _createdItems)
                            {
                                if ((obj4 != null) && obj4.Name.Equals(sUseItem))
                                {
                                    itemToUse = obj4;
                                }
                            }
                        }
                        if (itemToUse == null)
                        {
                            foreach (WorldObject obj5 in base.Core.WorldFilter.GetInventory())
                            {
                                if (obj5.Name.Equals(sUseItem))
                                {
                                    itemToUse = obj5;
                                }
                            }
                        }
                        if (itemToUse == null)
                        {
                            tellCannotFindRecipeItem(sUseItem, 1);
                            actionQueue.Clear();
                            actionQueue.Enqueue(new CAction("Return Items"));
                            return;
                        }
                        WorldObject obj6 = null;
                        if (_onItems[itemsIndex].ToString().Equals("LOOT_ITEM"))
                        {
                            foreach (WorldObject obj7 in wObjTrade)
                            {
                                if ((RecipeName.Contains("Dye Armor") && (obj7 != null)) && (obj7.ObjectClass.Equals((ObjectClass)2) || obj7.ObjectClass.Equals((ObjectClass)3)))
                                {
                                    obj6 = obj7;
                                    finalResult = obj7.Name;
                                }
                            }
                            if (obj6 == null)
                            {
                                tellCannotFindRecipeItem(_onItems[itemsIndex].ToString(), 2);
                                actionQueue.Clear();
                                actionQueue.Enqueue(new CAction("Return Items"));
                                return;
                            }
                        }
                        else
                        {
                            foreach (WorldObject obj8 in wObjTrade)
                            {
                                if (((obj8 != null) && obj8.Name.Equals(_onItems[itemsIndex].ToString())) && (itemToUse != obj8))
                                {
                                    obj6 = obj8;
                                }
                            }
                            if ((obj6 == null) && (_createdItems.Count > 0))
                            {
                                foreach (WorldObject obj9 in _createdItems)
                                {
                                    if (((obj9 != null) && obj9.Name.Equals(_onItems[itemsIndex].ToString())) && (itemToUse != obj9))
                                    {
                                        obj6 = obj9;
                                    }
                                }
                            }
                            if (obj6 == null)
                            {
                                foreach (WorldObject obj10 in base.Core.WorldFilter.GetInventory())
                                {
                                    if (((obj10 != null) && obj10.Name.Equals(_onItems[itemsIndex].ToString())) && (itemToUse != obj10))
                                    {
                                        obj6 = obj10;
                                    }
                                }
                            }
                            if (obj6 == null)
                            {
                                tellCannotFindRecipeItem(_onItems[itemsIndex].ToString(), 3);
                                actionQueue.Clear();
                                actionQueue.Enqueue(new CAction("Return Items"));
                                return;
                            }
                        }
                        actionQueue.Enqueue(new CAction(itemToUse.Id, obj6.Id, "Apply Item"));
                        if (!this._ResultItems[itemsIndex].ToString().Equals("LOOT_ITEM"))
                        {
                            finalResult = _ResultItems[itemsIndex].ToString();
                        }
                        itemsIndex++;
                        break;
                    }
                    if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Check Craft Step"))
                    {
                        actionQueue.Dequeue();
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void equipItems(string equipType)
        {
            try
            {
                int num = l(equipType);
                if (num >= 0)
                {
                    if ((curEquip != null) && curEquip.Equals(equipType))
                    {
                        int num2 = l(curEquip);
                        for (int i = 0; i < EQUIP_MAX_COLS; i++)
                        {
                            if (((equipList[num2, i] != null) && (base.Core.WorldFilter[int.Parse(equipList[num2, i])] != null)) && (base.Core.WorldFilter[int.Parse(equipList[num2, i])].Values(LongValueKey.EquippedSlots) <= 0))
                            {
                                actionQueue.Enqueue(new CAction(int.Parse(equipList[num2, i]), "Equip"));
                            }
                        }
                    }
                    else
                    {
                        if ((curEquip != null) && !this.curEquip.Equals(equipType))
                        {
                            int num4 = l(curEquip);
                            for (int k = 0; k < EQUIP_MAX_COLS; k++)
                            {
                                if (((equipList[num4, k] != null) && (base.Core.WorldFilter[int.Parse(equipList[num4, k])] != null)) && (base.Core.WorldFilter[int.Parse(equipList[num4, k])].Values(LongValueKey.EquippedSlots) > 0))
                                {
                                    actionQueue.Enqueue(new CAction(int.Parse(equipList[num4, k]), "Equip"));
                                }
                            }
                        }
                        else if (curEquip == null)
                        {
                            foreach (WorldObject wObj in base.Core.WorldFilter.GetInventory())
                            {
                                if (wObj.Values(LongValueKey.EquippedSlots) > 0)
                                {
                                    actionQueue.Enqueue(new CAction(wObj.Id, "Equip"));
                                }
                            }
                        }
                        for (int j = 0; j < EQUIP_MAX_COLS; j++)
                        {
                            if (equipList[num, j] != null)
                            {
                                actionQueue.Enqueue(new CAction(int.Parse(equipList[num, j]), "Equip"));
                            }
                        }
                        curEquip = equipType;
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void findSteps(string recipeName, string activateItem, string filename)
        {
            try
            {
                bool flag = false;
                XmlTextReader reader = new XmlTextReader(filename);
                while (reader.Read())
                {
                    if (reader.HasAttributes)
                    {
                        if (reader.Name.Equals("recipe"))
                        {
                            if ((reader["name"].Equals(RecipeName) && (reader["activateitem"] != null)) && ((_activateItem != null) && reader["activateitem"].Equals(_activateItem)))
                            {
                                flag = true;
                                continue;
                            }
                            if (!flag)
                            {
                                continue;
                            }
                            flag = false;
                            return;
                        }
                        if (flag && reader.Name.Equals("step"))
                        {
                            if (((reader["use"] != null) && (reader["on"] != null)) && (reader["result"] != null))
                            {
                                string skillOverride;
                                _UseItems.Add(reader["use"]);
                                _onItems.Add(reader["on"]);
                                _ResultItems.Add(reader["result"]);
                                if ((curSkill == null) || curSkill.Equals("none"))
                                {
                                    setSkill(recipeName, personalFolderPath + @"\recipes.xml");
                                }
                                if (reader["skilloverride"] != null)
                                {
                                    skillOverride = reader["skilloverride"];
                                }
                                else
                                {
                                    skillOverride = curSkill.ToString();
                                }
                                if (reader["skillcheck"] != null)
                                {
                                    _SkillChecks.Add(reader["skillcheck"] + "-" + curSkill);
                                }
                                else
                                {
                                    _SkillChecks.Add("-1-" + curSkill);
                                }
                                _craftStepCount++;
                            }
                        }
                        else if (reader.Name.Equals("recipe"))
                        {
                            curSkill.Equals("Rare Tier 4");
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void findStepsRare(string command, string filename)
        {
            try
            {
                bool flag = false;
                XmlTextReader reader = new XmlTextReader(filename);
                while (reader.Read())
                {
                    if (reader.HasAttributes)
                    {
                        if ((reader.Name.Equals("recipe") && (reader["command"] != null)) && (reader["name"] != null))
                        {
                            if (reader["command"].Equals(command))
                            {
                                RecipeName = reader["name"];
                                flag = true;
                                continue;
                            }
                            if (!flag)
                            {
                                continue;
                            }
                            flag = false;
                            return;
                        }
                        if (((flag && reader.Name.Equals("step")) && ((reader["use"] != null) && (reader["on"] != null))) && (reader["result"] != null))
                        {
                            _UseItems.Add(reader["use"]);
                            _onItems.Add(reader["on"]);
                            _ResultItems.Add(reader["result"]);
                            if (reader["skillcheck"] != null)
                            {
                                _SkillChecks.Add(reader["skillcheck"]);
                            }
                            else
                            {
                                _SkillChecks.Add("-1");
                            }
                            _craftStepCount++;
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void getLandblockInfo()
        {
            try
            {
                //_WebReq.PostString(_c2 + "lb=" + base.Host.Actions.Landcell.ToString("X") + "&loc=" + base.Core.WorldFilter[base.Core.CharacterFilter.Id].Coordinates().ToString());
                //webTimer.Start();
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void initRareUse(string command)
        {
            _isRareCraft = true;
            ignoreReset = true;
            _byPassCheck = true;
            if ((wObjTrade != null) && (wObjTrade.Count > 0))
            {
                tellAcceptTrade();
                base.Host.Actions.TradeAccept();
                _waitForAccept = true;
                _b0 = command;
            }
            else
            {
                base.Host.Actions.TradeEnd();
                rareUse(command);
            }
        }

        public void initReturnRemainingItems()
        {
            try
            {
                ignoreTrades = false;
                ignoreReset = true;
                if (Settings.Default.equipItems)
                {
                    equipItems("No Craft");
                }
                if (wObjTrade != null)
                {
                    foreach (WorldObject obj2 in wObjTrade)
                    {
                        if (((((obj2 != null) && (obj2.Name != null)) && ((base.Core.WorldFilter[obj2.Id] != null) && !obj2.Name.Equals("Cooking Pot"))) && (((finalResult == null) || !obj2.Name.Equals(finalResult)) || (obj2 == tinkeringTarget))) && (!this._cp.Contains(obj2) || (obj2 == tinkeringTarget)))
                        {
                            ReturnObject item = new ReturnObject(obj2.Id, trader.Name);
                            if (!this._returnObjects.Contains(item))
                            {
                                writeReturnItem(riFile, item);
                            }
                        }
                    }
                }
                if (finalResult != null)
                {
                    WorldObjectCollection inventory = base.Core.WorldFilter.GetInventory();
                    int num = 0;
                    foreach (WorldObject obj4 in inventory)
                    {
                        if (((obj4 != null) && obj4.Name.Equals(finalResult)) && !obj4.Name.Equals("Cooking Pot"))
                        {
                            if (!this._cp.Contains(obj4) || (obj4 == tinkeringTarget))
                            {
                                ReturnObject obj5 = new ReturnObject(obj4.Id, trader.Name);
                                if (!this._returnObjects.Contains(obj5))
                                {
                                    writeReturnItem(riFile, obj5);
                                    num++;
                                    if ((_nonTinkRepeatTimes <= 0) || (num >= _nonTinkRepeatTimes))
                                    {
                                        break;
                                    }
                                }
                            }
                        }
                        else if ((((obj4 != null) && !obj4.Name.Equals("Cooking Pot")) && (!this._cp.Contains(obj4) || (obj4 == tinkeringTarget))) && ((num < _nonTinkRepeatTimes) && obj4.Name.Equals(finalResult)))
                        {
                            ReturnObject obj6 = new ReturnObject(obj4.Id, trader.Name);
                            if (!this._returnObjects.Contains(obj6))
                            {
                                writeReturnItem(riFile, obj6);
                                num++;
                                if ((_nonTinkRepeatTimes <= 0) || (num >= _nonTinkRepeatTimes))
                                {
                                    break;
                                }
                            }
                        }
                    }
                }
                if (wObjResult != null)
                {
                    foreach (WorldObject obj7 in wObjResult)
                    {
                        if (((((obj7 != null) && (obj7.Name != null)) && ((base.Core.WorldFilter[obj7.Id] != null) && !obj7.Name.Equals("Cooking Pot"))) && (((finalResult == null) || !obj7.Name.Equals(finalResult)) || (obj7 == tinkeringTarget))) && (!this._cp.Contains(obj7) || (obj7 == tinkeringTarget)))
                        {
                            ReturnObject obj8 = new ReturnObject(obj7.Id, trader.Name);
                            if (!this._returnObjects.Contains(obj8))
                            {
                                writeReturnItem(riFile, obj8);
                            }
                        }
                    }
                }
                if ((_createdItems != null) && (_createdItems.Count > 0))
                {
                    foreach (WorldObject obj9 in _createdItems)
                    {
                        if ((obj9 != null) && (obj9.Container == base.Core.CharacterFilter.Id))
                        {
                            ReturnObject obj10 = new ReturnObject(obj9.Id, trader.Name);
                            if (!_returnObjects.Contains(obj10))
                            {
                                writeReturnItem(riFile, obj10);
                            }
                        }
                    }
                }
                ignoreTrades = true;
                base.Host.Actions.TradeEnd();
                ignoreTrades = false;
                returnItems = true;
                am();
                inCraft = false;
                inTrade = false;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void initTimers()
        {
            try
            {
                buffTimer.Interval = ((Settings.Default.buffTime * 60) * 0x3e8) - 0x493e0;
                buffTimer.Tick += new EventHandler(buffEvent);
                if (Settings.Default.useBuffs)
                {
                    buffTimer.Enabled = true;
                    buffTimer.Start();
                }
                else
                {
                    buffTimer.Stop();
                }
                rareTimer.Interval = (Settings.Default.rareTime * 60) * 0x3e8;
                rareTimer.Tick += new EventHandler(k);
                rareTimer.Stop();
                rareTimer.Enabled = false;
                actionTimer.Interval = 0x3e8;
                actionTimer.Enabled = true;
                actionTimer.Tick += new EventHandler(actionTimer_Handler);
                actionTimer.Start();
                chatTimer.Interval = 0x9c4;
                chatTimer.Enabled = true;
                chatTimer.Tick += new EventHandler(e);
                chatTimer.Start();
                idleTimer.Interval = 0x493e0;
                idleTimer.Tick += new EventHandler(j);
                idleTimer.Stop();
                idleTimer.Enabled = false;
                if (Settings.Default.useWeb)
                {
                    webTimer.Enabled = true;
                    webTimer.Start();
                }
                else
                {
                    webTimer.Stop();
                    webTimer.Enabled = false;
                }
                heartbeat.Interval = 0x493e0;
                heartbeat.Tick += new EventHandler(f);
                if (Settings.Default.useWeb)
                {
                    heartbeat.Enabled = true;
                    heartbeat.Start();
                }
                else
                {
                    heartbeat.Stop();
                    heartbeat.Enabled = false;
                }
                if (_bf >= 5)
                {
                    spamTimer.Interval = (_bf * 60) * 0x3e8;
                }
                else
                {
                    spamTimer.Interval = 0x493e0;
                }
                spamTimer.Enabled = true;
                spamTimer.Tick += new EventHandler(i);
                spamTimer.Start();
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void itemDoesNotExist(string item)
        {
            tellCannotFindRecipeItem(item, 4);
            resetCraftingState();
        }

        public void loadMessages(string filename)
        {
            try
            {
                XmlTextReader reader = new XmlTextReader(filename);
                if (reader != null)
                {
                    goto Label_00AD;
                }
                return;
            Label_0012:
                if ((((reader.NodeType == XmlNodeType.Element) && reader.Name.Equals("message")) && ((reader["player"] != null) && (reader["message"] != null))) && (reader["time"] != null))
                {
                    ListRow row = listMessages.Add();
                    row[0][0] = reader["player"];
                    row[1][0] = reader["message"];
                    row[2][0] = reader["time"];
                }
            Label_00AD:
                if (reader.Read())
                {
                    goto Label_0012;
                }
                reader.Close();
                listMessages.ScrollPosition = 0;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void loadReturnItems(string filename)
        {
            try
            {
                XmlTextReader reader = new XmlTextReader(filename);
                if (reader != null)
                {
                    goto Label_0166;
                }
                return;
            Label_0012:
                if (((reader.NodeType == XmlNodeType.Element) && reader.Name.Equals("item")) && ((reader["player"] != null) && (reader["iid"] != null)))
                {
                    ListRow row = listReturn.Add();
                    if (base.Core.WorldFilter[int.Parse(reader["iid"])] != null)
                    {
                        _returnObjects.Add(new ReturnObject(int.Parse(reader["iid"].Trim()), reader["player"].Trim()));
                        row[0][0] = reader["player"];
                        row[1][0] = base.Core.WorldFilter[int.Parse(reader["iid"])].Name;
                        row[2][0] = reader["time"];
                    }
                    else
                    {
                        listReturn.Delete(listReturn.RowCount - 1);
                        _ck.Add(new ReturnObject(int.Parse(reader["iid"]), reader["player"]));
                    }
                }
            Label_0166:
                if (reader.Read())
                {
                    goto Label_0012;
                }
                reader.Close();
                foreach (ReturnObject obj2 in _ck)
                {
                    deleteReturnItem(riFile, obj2);
                }
                _ck = new ArrayList();
                listReturn.ScrollPosition = 0;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void parseBuffData()
        {
            try
            {
                XmlAttributeCollection attributes = _XmlDoc.GetElementsByTagName("bufftime")[0].Attributes;
                Settings.Default.buffTime = int.Parse(attributes["value"].Value);
                attributes = _XmlDoc.GetElementsByTagName("beertime")[0].Attributes;
                Settings.Default.beerTime = int.Parse(attributes["value"].Value);
                attributes = _XmlDoc.GetElementsByTagName("raretime")[0].Attributes;
                Settings.Default.rareTime = int.Parse(attributes["value"].Value);
                attributes = _XmlDoc.GetElementsByTagName("buffwand")[0].Attributes;
                _buffWand = int.Parse(attributes["value"].Value);
                attributes = _XmlDoc.GetElementsByTagName("restam")[0].Attributes;
                Settings.Default.restamSpell = int.Parse(attributes["id"].Value);
                attributes = _XmlDoc.GetElementsByTagName("manaspell")[0].Attributes;
                Settings.Default.s2mSpell = int.Parse(attributes["id"].Value);
                attributes = _XmlDoc.GetElementsByTagName("minstam")[0].Attributes;
                Settings.Default.staminaThreshold = int.Parse(attributes["val"].Value);
                attributes = _XmlDoc.GetElementsByTagName("minmana")[0].Attributes;
                Settings.Default.manaThreshold = int.Parse(attributes["val"].Value);
                for (int i = 0; i < _bi.Count; i++)
                {
                    attributes = _bi[i].Attributes;
                    _buffList.Add(attributes["id"].Value);
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void parseEquipData(string filename)
        {
            string str = "none";
            int num = 0;
            try
            {
                XmlTextReader reader = new XmlTextReader(filename);
                while (reader.Read())
                {
                    if ((reader.NodeType != XmlNodeType.Element) || !reader.HasAttributes)
                    {
                        continue;
                    }
                    if (reader.Name.Equals("skill"))
                    {
                        str = reader["id"];
                        num = 0;
                        continue;
                    }
                    if (reader.Name.Equals("item"))
                    {
                        int num2 = -1;
                        string key = str;
                        if (key != null)
                        {
                            int num3;
                            if (_dictionaryCmds2 == null)
                            {
                                Dictionary<string, int> dictionary1 = new Dictionary<string, int>(9);
                                dictionary1.Add("Alchemy", 0);
                                dictionary1.Add("Cooking", 1);
                                dictionary1.Add("Fletching", 2);
                                dictionary1.Add("Lockpick", 3);
                                dictionary1.Add("Armor Tinkering", 4);
                                dictionary1.Add("Item Tinkering", 5);
                                dictionary1.Add("Magic Item Tinkering", 6);
                                dictionary1.Add("Weapon Tinkering", 7);
                                dictionary1.Add("No Craft", 8);
                                _dictionaryCmds2 = dictionary1;
                            }
                            if (_dictionaryCmds2.TryGetValue(key, out num3))
                            {
                                switch (num3)
                                {
                                    case 0:
                                        num2 = 0;
                                        break;

                                    case 1:
                                        num2 = 1;
                                        break;

                                    case 2:
                                        num2 = 2;
                                        break;

                                    case 3:
                                        num2 = 3;
                                        break;

                                    case 4:
                                        num2 = 4;
                                        break;

                                    case 5:
                                        num2 = 5;
                                        break;

                                    case 6:
                                        num2 = 6;
                                        break;

                                    case 7:
                                        num2 = 7;
                                        break;

                                    case 8:
                                        num2 = 8;
                                        break;
                                }
                            }
                        }
                        if (num2 >= 0)
                        {
                            equipList[num2, num] = reader["id"];
                            num++;
                        }
                        continue;
                    }
                    if (reader.Name.Equals("idleweapon"))
                    {
                        idleWeapon = int.Parse(reader["id"]);
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void printSpellTable()
        {
            try
            {
                FileService service = base.Core.Filter<FileService>();
                int num = 0;
                for (int i = 1; i < service.SpellTable.Length; i++)
                {
                    try
                    {
                        num++;
                        Spell byId = service.SpellTable.GetById(num);
                        if (byId == null)
                        {
                            i--;
                        }
                        else
                        {
                            string str = string.Concat(new object[] { byId.Id, ": ", byId.Name, " -- ", byId.Description });
                            clsMessageWriter.Write_Message(personalFolderPath + @"\spells.txt", str);
                        }
                    }
                    catch (Exception exception)
                    {
                        clsMessageWriter.Write_Error(errorLogFile, exception);
                        i--;
                    }
                }
            }
            catch (Exception exception2)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception2);
            }
        }

        public void processMail(string returnTo, string playerFrom)
        {
            try
            {
                int num = 0;
                foreach (WorldObject obj2 in base.Core.WorldFilter.GetByContainer(base.Core.CharacterFilter.Id))
                {
                    if ((!obj2.ObjectClass.Equals((ObjectClass)10) && !obj2.ObjectClass.Equals((ObjectClass)0x26)) && (obj2.Values(LongValueKey.EquippedSlots) <= 0))
                    {
                        num++;
                    }
                }
                if ((num + wObjTrade.Count) <= 90)
                {
                    _isSendingMail = true;
                    _mailReturnPlayer = returnTo;
                    _mailFromPlayer = playerFrom;
                    tellAcceptTrade();
                }
                else
                {
                    a((int)(90 - num));
                    resetCraftingState();
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void processMailCancel(string returnTo, string playerFrom)
        {
            try
            {
                _mailReturnPlayer = returnTo;
                _mailFromPlayer = playerFrom;
                _c8 = deleteMailLogXML(mailFileXML, playerFrom, returnTo, "65535", true);
                if (_c8.Count > 0)
                {
                    tellMailItemsSuccessfullyRemoved(playerFrom, returnTo);
                }
                else if (_c8.Count == -1)
                {
                    tellUnkownErrorOccured();
                }
                else
                {
                    tellMailItemsNotFound(playerFrom, returnTo);
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void rareUse(string command)
        {
            inCraft = true;
            ignoreReset = true;
            findStepsRare(command, personalFolderPath + @"\recipes.xml");
            buildRecipeList();
            if (!this.checkCraftSteps())
            {
                resetCraftingState();
            }
            else if (craftStepNum > 0)
            {
                resetCraftingState();
            }
            else
            {
                craftStepNum = 1;
                if (_nonTinkRepeatTimes > 0)
                {
                    for (int i = 1; i <= _nonTinkRepeatTimes; i++)
                    {
                        doCraftStep(1);
                    }
                }
                else
                {
                    doCraftStep(1);
                }
            }
        }

        public void readdItemsMail()
        {
            try
            {
                foreach (ReturnObject obj2 in _c8)
                {
                    if (obj2 != null)
                    {
                        ReturnObject ro = new ReturnObject(obj2.getID(), obj2.getFrom(), obj2.getReturnTo());
                        writeReturnItem(riFile, ro);
                        writeMailLogXML(mailFileXML, obj2.getReturnTo(), obj2.getFrom(), obj2.getID().ToString());
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void resetCraftingState()
        {
            try
            {
                if ((actionQueue.Count > 0) && actionQueue.Peek().getType().Equals("Equip"))
                {
                    curEquip = null;
                }
                if (((actionQueue.Count <= 0) || !this.actionQueue.Peek().getType().Equals("Return Items")) && !this.actionQueue.Contains(new CAction("Return Items")))
                {
                    actionQueue.Clear();
                }
                ignoreTrades = true;
                base.Host.Actions.TradeEnd();
                _UseItems = new ArrayList();
                _onItems = new ArrayList();
                _ResultItems = new ArrayList();
                _SkillChecks = new ArrayList();
                _RecipeList = new ArrayList();
                sortedSalvage = new List<Salvage>();
                wObjTrade = new ArrayList();
                _createdItems = new ArrayList();
                tinkerIgnoreIIDs = new ArrayList();
                _ck = new ArrayList();
                wObjResult = null;
                RecipeName = null;
                curSkill = null;
                inCraft = false;
                inTrade = false;
                _isBuffing = false;
                trader = null;
                returnItems = false;
                _waitFor = "";
                ignoreReset = true;
                _tellPerson = null;
                tinkerCount = 0;
                tinkerCountCopy = 0;
                tinkerStopAt = 0;
                _waitTimer = 0;
                tinkeringTarget = null;
                waitForBrill = false;
                ignoreTrades = false;
                _lookForCharge = false;
                _lookForRares = false;
                _State = "Idle";
                craftStepNum = 0;
                finalResult = null;
                _byPassCheck = false;
                _craftStepCount = 0;
                _ignoreApply = false;
                _bt = false;
                _cc = false;
                _isRareCraft = false;
                _waitForAccept = false;
                _b0 = null;
                _lowCompsMessageSent = false;
                _lowCompsMessageSentUntargeted = false;
                _lowManaSent = false;
                _noManaChargeSent = false;
                _WaitForRecipeName = false;
                _activateItem = null;
                _craftIncremented = false;
                _ignoreGo = false;
                _ignoreYes = false;
                _givenGo = false;
                _nonTinkRepeatTimes = 0;
                itemsQueued = false;
                _bc = 0;
                _mailFromPlayer = null;
                _mailReturnPlayer = null;
                _isSendingMail = false;
                _b2 = 0;
                idleTimer.Stop();
                idleTimer.Enabled = false;
                _cp.Clear();
                foreach (WorldObject obj2 in base.Core.WorldFilter.GetInventory())
                {
                    _cp.Add(obj2);
                }
                if (Settings.Default.equipItems)
                {
                    equipItems("No Craft");
                }
                actionQueue.Enqueue(new CAction("Face Heading Reset"));
                int num = 0;
                foreach (WorldObject obj3 in base.Core.WorldFilter.GetByContainer(base.Core.CharacterFilter.Id))
                {
                    if ((!obj3.ObjectClass.Equals((ObjectClass)10) && !obj3.ObjectClass.Equals((ObjectClass)0x26)) && (obj3.Values(LongValueKey.EquippedSlots) <= 0))
                    {
                        num++;
                    }
                }
                if ((num >= 90) && Settings.Default.useMail)
                {
                    clsMessageWriter.Write_Split_Message(debugFile, "Only 12 pack slots left! Disabling mail...");
                    WriteToChat("Low on pack space! Disabling mail.");
                    Settings.Default.useMail = false;
                    chkEnableMail.Checked = false;
                    Settings.Default.recoverMail = true;
                    Settings.Default.Save();
                }
                else if ((num < 90) && Settings.Default.recoverMail)
                {
                    WriteToChat("Mail was previously enabled and there are more than 12 slots in the main pack free! Enabling mail...");
                    clsMessageWriter.Write_Split_Message(debugFile, "Re-enabling mail due to free pack space.");
                    Settings.Default.useMail = true;
                    chkEnableMail.Checked = true;
                    Settings.Default.recoverMail = false;
                    Settings.Default.Save();
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void writeMailLogXML(string filename, string playerFrom, string playerTo, string item)
        {
            try
            {
                XmlDocument document = new XmlDocument();
                try
                {
                    document.Load(filename);
                }
                catch (FileNotFoundException)
                {
                    XmlDeclaration declaration = document.CreateXmlDeclaration("1.0", "utf-8", null);
                    XmlElement element = document.CreateElement("mail");
                    document.InsertBefore(declaration, document.DocumentElement);
                    document.AppendChild(element);
                }
                XmlElement newChild = document.CreateElement("item");
                newChild.SetAttribute("from", playerFrom.ToLower());
                newChild.SetAttribute("to", playerTo.ToLower());
                newChild.SetAttribute("iid", item);
                newChild.SetAttribute("time", DateTime.Now.ToString());
                document.DocumentElement.PrependChild(newChild);
                document.Save(filename);
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void writeMessage(string filename, string player, string message)
        {
            try
            {
                XmlDocument document = new XmlDocument();
                try
                {
                    document.Load(filename);
                }
                catch (FileNotFoundException)
                {
                    XmlDeclaration declaration = document.CreateXmlDeclaration("1.0", "utf-8", null);
                    XmlElement element = document.CreateElement("messages");
                    document.InsertBefore(declaration, document.DocumentElement);
                    document.AppendChild(element);
                }
                XmlElement newChild = document.CreateElement("message");
                newChild.SetAttribute("player", player);
                newChild.SetAttribute("message", message);
                newChild.SetAttribute("time", DateTime.Now.ToString());
                document.DocumentElement.PrependChild(newChild);
                document.Save(filename);
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void writeReturnItem(string filename, ReturnObject ro)
        {
            try
            {
                XmlDocument document = new XmlDocument();
                try
                {
                    document.Load(filename);
                }
                catch (FileNotFoundException)
                {
                    XmlDeclaration declaration = document.CreateXmlDeclaration("1.0", "utf-8", null);
                    XmlElement element = document.CreateElement("items");
                    document.InsertBefore(declaration, document.DocumentElement);
                    document.AppendChild(element);
                }
                string str = DateTime.Now.ToString();
                XmlElement newChild = document.CreateElement("item");
                newChild.SetAttribute("player", ro.getReturnTo());
                newChild.SetAttribute("iid", ro.getID().ToString());
                newChild.SetAttribute("time", str);
                document.DocumentElement.PrependChild(newChild);
                document.Save(filename);
                _returnObjects.Add(ro);
                ListRow row = listReturn.Add();
                row[0][0] = ro.getReturnTo();
                if (base.Core.WorldFilter[ro.getID()] != null)
                {
                    row[1][0] = base.Core.WorldFilter[ro.getID()].Name;
                }
                else
                {
                    row[1][0] = "Invalid Item";
                }
                row[2][0] = str;
                listReturn.ScrollPosition = 0;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                _returnObjects.Add(ro);
            }
        }

        public void WriteToChat(string message)
        {
            try
            {
                base.Host.Actions.AddChatText(_b4 + " " + message, _b3);
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void sendBotInfo()
        {
            try
            {
                int num = 0;
                ArrayList list = new ArrayList();
                string str = null;
                bool flag = false;
                bool flag2 = false;
                foreach (string str2 in activationList)
                {
                    if (str2.StartsWith("Salvaged"))
                    {
                        if (!flag)
                        {
                            flag = true;
                        }
                        list.Add(num);
                        num++;
                    }
                    else if (str2.Contains("Plant") || str2.Contains("Dye"))
                    {
                        if (!flag2)
                        {
                            flag2 = true;
                        }
                        list.Add(num);
                        num++;
                    }
                    else
                    {
                        str = str + str2 + "|;";
                        num++;
                    }
                }
                if (str != null)
                {
                    str = str.Substring(0, str.Length - 2);
                }
                else
                {
                    str = "None";
                }
                num = 0;
                string str3 = null;
                foreach (string str4 in recipeList)
                {
                    if (str4 == null)
                    {
                        num++;
                    }
                    else if (str4.Contains("Dye Armor"))
                    {
                        list.Add(num);
                        num++;
                    }
                    else if (list.Contains(num))
                    {
                        num++;
                    }
                    else
                    {
                        str3 = str3 + str4 + "|;";
                        num++;
                    }
                }
                if (flag)
                {
                    str3 = str3 + "Tinkering Capable|;";
                }
                if (flag2)
                {
                    str3 = str3 + "Dye Capable|;";
                }
                if (str3 != null)
                {
                    str3 = str3.Substring(0, str3.Length - 2);
                }
                else
                {
                    str3 = "None.";
                }
                string str5 = null;
                foreach (string str6 in rareRecipeList)
                {
                    if (str6 != null)
                    {
                        str5 = str5 + str6 + "|;";
                    }
                }
                if (str5 != null)
                {
                    str5 = str5.Substring(0, str5.Length - 2);
                }
                else
                {
                    str5 = "None.";
                }
                string str7 = null;
                foreach (string str8 in rareDesc)
                {
                    if (str8 != null)
                    {
                        str7 = str7 + str8 + "|;";
                    }
                }
                if (str7 != null)
                {
                    str7 = str7.Substring(0, str7.Length - 2);
                }
                else
                {
                    str7 = "None.";
                }
                string str9 = null;
                foreach (string str10 in rareCommands)
                {
                    if (str10 != null)
                    {
                        str9 = str9 + str10 + "|;";
                    }
                }
                if (str9 != null)
                {
                    str9 = str9.Substring(0, str9.Length - 2);
                }
                else
                {
                    str9 = "None.";
                }
                if (Settings.Default.useWeb)
                {
                    //webTimer.Start();
                    string str11 = "None";
                    if (base.Core.CharacterFilter.Monarch != null)
                    {
                        str11 = base.Core.CharacterFilter.Monarch.Name;
                    }
                    string str12 = string.Concat(new object[] { 
                        _cd, "&server=", base.Core.CharacterFilter.Server, "&charname=", base.Core.CharacterFilter.Name, "&level=", base.Core.CharacterFilter.Level, "&monarch=", str11, "&loc=", base.Core.WorldFilter[base.Core.CharacterFilter.Id].Coordinates().ToString(), "&lb=", base.Host.Actions.Landcell.ToString("X"), "&at=", base.Core.CharacterFilter.EffectiveSkill[(CharFilterSkillType) 0x1d], "&it=", 
                        base.Core.CharacterFilter.EffectiveSkill[(CharFilterSkillType) 0x12], "&mit=", base.Core.CharacterFilter.EffectiveSkill[(CharFilterSkillType) 30], "&wt=", base.Core.CharacterFilter.EffectiveSkill[(CharFilterSkillType) 0x1c], "&al=", base.Core.CharacterFilter.EffectiveSkill[(CharFilterSkillType) 0x26], "&ck=", base.Core.CharacterFilter.EffectiveSkill[(CharFilterSkillType) 0x27], "&fl=", base.Core.CharacterFilter.EffectiveSkill[(CharFilterSkillType) 0x25], "&lp=", base.Core.CharacterFilter.EffectiveSkill[(CharFilterSkillType) 0x17], "&recipes=", str3, "&activate=", 
                        str, "&rarerecipes=", str5, "&raredesc=", str7, "&rarecmd=", str9, "&version=", Assembly.GetExecutingAssembly().GetName().Version
                     });
                    //_WebReq.PostString(_c0 + initActions(str12, _cd + _c3));
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                webTimer.Stop();
            }
        }

        public void setSkill(string recipeName, string filename)
        {
            try
            {
                XmlTextReader reader = new XmlTextReader(filename);
                while (reader.Read())
                {
                    if (reader.HasAttributes && reader.HasAttributes)
                    {
                        if (reader.Name.Equals("skill"))
                        {
                            curSkill = reader["id"];
                        }
                        else if ((reader.Name.Equals("recipe") && !this.curSkill.Equals("Rare Tier 4")) && ((recipeName != null) && recipeName.Equals(reader["name"])))
                        {
                            return;
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        public void startCrafting()
        {
            try
            {
                if (((RecipeName == null) || (wObjTrade == null)) || (_activateItem == null))
                {
                    resetCraftingState();
                }
                else
                {
                    inCraft = true;
                    _WaitForRecipeName = false;
                    if (_bj)
                    {
                        WriteToChat("Crafting::startCrafting() - Finding steps for recipe: " + RecipeName);
                    }
                    findSteps(RecipeName, _activateItem, personalFolderPath + @"\recipes.xml");
                    buildRecipeList();
                    if (!this.checkCraftSteps())
                    {
                        resetCraftingState();
                    }
                    else
                    {
                        if (_bj)
                        {
                            WriteToChat("Crafting::startCrafting() - Checking validity of recipe: " + RecipeName);
                        }
                        if (!this.validInteraction())
                        {
                            if (_bj)
                            {
                                WriteToChat("Crafting::startCrafting() - Items not valid.");
                            }
                            h(RecipeName);
                            resetCraftingState();
                        }
                        else
                        {
                            if (_bj)
                            {
                                WriteToChat("Crafting::startCrafting() - Items valid.");
                            }
                            if (curSkill == null)
                            {
                                resetCraftingState();
                            }
                            if (curSkill.Equals("Armor Tinkering") && !Settings.Default.useArmorTinkering)
                            {
                                e(curSkill);
                                resetCraftingState();
                            }
                            else if (curSkill.Equals("Item Tinkering") && !Settings.Default.useItemTinerking)
                            {
                                e(curSkill);
                                resetCraftingState();
                            }
                            else if (curSkill.Equals("Magic Item Tinkering") && !Settings.Default.useMagicItemTinkering)
                            {
                                e(curSkill);
                                resetCraftingState();
                            }
                            else if (curSkill.Equals("Weapon Tinkering") && !Settings.Default.useWeaponTinkering)
                            {
                                e(curSkill);
                                resetCraftingState();
                            }
                            else if (curSkill.Equals("Alchemy") && !Settings.Default.useAlchemy)
                            {
                                e(curSkill);
                                resetCraftingState();
                            }
                            else if (curSkill.Equals("Cooking") && !Settings.Default.useCooking)
                            {
                                e(curSkill);
                                resetCraftingState();
                            }
                            else if (curSkill.Equals("Fletching") && !Settings.Default.useFletching)
                            {
                                e(curSkill);
                                resetCraftingState();
                            }
                            else if (curSkill.Equals("Lockpick") && !Settings.Default.useLockpick)
                            {
                                e(curSkill);
                                resetCraftingState();
                            }
                            else if (curSkill.Equals("Rare Tier 4") && !Settings.Default.useTier4Rares)
                            {
                                e(curSkill);
                                resetCraftingState();
                            }
                            if ((curSkill.Equals("Armor Tinkering") || curSkill.Equals("Item Tinkering")) || (curSkill.Equals("Magic Item Tinkering") || curSkill.Equals("Weapon Tinkering")))
                            {
                                if ((tinkeringTarget == null) || (sortedSalvage == null))
                                {
                                    resetCraftingState();
                                }
                                else
                                {
                                    foreach (WorldObject wObj in wObjTrade)
                                    {
                                        if ((wObj != null) && wObj.ObjectClass.Equals(ObjectClass.Salvage))
                                        {
                                            sortedSalvage.Add(new Salvage(wObj.Name, wObj.Id, Math.Round((double)wObj.Values(LongValueKey.Workmanship) / (double)wObj.Values(LongValueKey.NumberItemsSalvagedFrom), 2), wObj.Values(LongValueKey.Material)));
                                        }
                                    }
                                    sortedSalvage.Sort();
                                    if ((tinkeringTarget != null) && tinkeringTarget.HasIdData)
                                    {
                                        tinkerCount = tinkeringTarget.Values(LongValueKey.NumberTimesTinkered);
                                        tinkerCountCopy = tinkeringTarget.Values(LongValueKey.NumberTimesTinkered);
                                    }
                                    else
                                    {
                                        resetCraftingState();
                                        return;
                                    }
                                    int newTinkerCount = tinkerCount;
                                    int i = 0;
                                    foreach (Salvage salvage in sortedSalvage)
                                    {
                                        if (salvage != null)
                                        {
                                            newTinkerCount++;
                                            if (newTinkerCount > 10)
                                            {
                                                ap();
                                                resetCraftingState();
                                                return;
                                            }
                                            double chanceOfSuccess = getChanceOfSuccess(i);
                                            salvage.setChanceOfSuccess(chanceOfSuccess);
                                            i++;
                                        }
                                    }
                                    ao();
                                    ignoreReset = false;
                                    _ignoreGo = true;
                                }
                            }
                            else
                            {
                                b((int)getChanceOfSuccess(0));
                                ignoreReset = false;
                                _ignoreGo = true;
                            }
                        }
                    }
                }
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
            }
        }

        #endregion

        #region PrivateFunc

        private bool processRareCommand(string A_0)
        {
            foreach (string str in rareCommands)
            {
                if ((str != null) && A_0.StartsWith(str))
                {
                    if (A_0.Contains(","))
                    {
                        _nonTinkRepeatTimes = int.Parse(A_0.Substring(A_0.LastIndexOf(',') + 1));
                        if (_nonTinkRepeatTimes > 10)
                        {
                            _nonTinkRepeatTimes = 10;
                        }
                        A_0 = A_0.Substring(0, A_0.IndexOf(','));
                    }
                    initRareUse(A_0);
                    return true;
                }
            }
            return false;
        }

        private int l(string A_0)
        {
            string key = A_0;
            if (key != null)
            {
                int num;
                if (_dictionaryCmds3 == null)
                {
                    Dictionary<string, int> dictionary1 = new Dictionary<string, int>(9);
                    dictionary1.Add("Alchemy", 0);
                    dictionary1.Add("Cooking", 1);
                    dictionary1.Add("Fletching", 2);
                    dictionary1.Add("Lockpick", 3);
                    dictionary1.Add("Armor Tinkering", 4);
                    dictionary1.Add("Item Tinkering", 5);
                    dictionary1.Add("Magic Item Tinkering", 6);
                    dictionary1.Add("Weapon Tinkering", 7);
                    dictionary1.Add("No Craft", 8);
                    _dictionaryCmds3 = dictionary1;
                }
                if (_dictionaryCmds3.TryGetValue(key, out num))
                {
                    switch (num)
                    {
                        case 0:
                            return 0;

                        case 1:
                            return 1;

                        case 2:
                            return 2;

                        case 3:
                            return 3;

                        case 4:
                            return 4;

                        case 5:
                            return 5;

                        case 6:
                            return 6;

                        case 7:
                            return 7;

                        case 8:
                            return 8;
                    }
                }
            }
            clsMessageWriter.Write_Split_Message(debugFile, "Error: Invalid equip type!");
            return -1;
        }

        #endregion 

        #region PublicFunc

        public ArrayList deleteMailLogXML(string filename, string playerFrom, string playerTo, string item, bool addReverseReturn)
        {
            try
            {
                ArrayList list = new ArrayList();
                XmlDocument document = new XmlDocument();
                try
                {
                    document.Load(filename);
                }
                catch (FileNotFoundException)
                {
                    XmlDeclaration newChild = document.CreateXmlDeclaration("1.0", "utf-8", null);
                    XmlElement element = document.CreateElement("mail");
                    document.InsertBefore(newChild, document.DocumentElement);
                    document.AppendChild(element);
                }
                XmlElement documentElement = document.DocumentElement;
                XmlNodeList childNodes = documentElement.ChildNodes;
                int count = childNodes.Count;
                for (int i = 0; i <= count; i++)
                {
                    bool flag = false;
                    foreach (XmlNode node in childNodes)
                    {
                        if (int.Parse(node.Attributes["iid"].Value).Equals(int.Parse(item)) || (node.Attributes["from"].Value.ToLower().Equals(playerFrom.ToLower()) && node.Attributes["to"].Value.ToLower().Equals(playerTo.ToLower())))
                        {
                            flag = true;
                            documentElement.RemoveChild(node);
                            deleteReturnItem(riFile, new ReturnObject(int.Parse(node.Attributes["iid"].Value), playerTo.ToLower()));
                            if (addReverseReturn)
                            {
                                writeReturnItem(riFile, new ReturnObject(int.Parse(node.Attributes["iid"].Value), playerFrom.ToLower()));
                            }
                            if (!list.Contains(new ReturnObject(int.Parse(node.Attributes["iid"].Value), playerTo.ToLower(), playerFrom.ToLower())))
                            {
                                list.Add(new ReturnObject(int.Parse(node.Attributes["iid"].Value), playerTo.ToLower(), playerFrom.ToLower()));
                            }
                        }
                    }
                    if (!flag)
                    {
                        break;
                    }
                }
                document.Save(filename);
                return list;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return null;
            }
        }

        public ArrayList dynamicLoadBuffBot(string filename, string node)
        {
            try
            {
                XmlTextReader reader = new XmlTextReader(filename);
                string name = "";
                ArrayList list = new ArrayList();
                while (reader.Read())
                {
                    if (reader.NodeType == XmlNodeType.Element)
                    {
                        if (reader.Name.Equals(node))
                        {
                            name = reader.Name;
                        }
                        else if (!reader.Name.Equals("command") && name.Equals(node))
                        {
                            return list;
                        }
                        if ((((name != null) && name.Equals(node)) && (reader.Name.Equals("command") && (reader["botname"] != null))) && (reader["profile"] != null))
                        {
                            list.Add("/tell " + reader["botname"].Trim() + ", " + reader["profile"].Trim());
                        }
                    }
                }
                return list;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return null;
            }
        }

        public ArrayList dynamicLoadChat(string filename, string node)
        {
            try
            {
                XmlTextReader reader = new XmlTextReader(filename);
                string name = "";
                ArrayList list = new ArrayList();
                while (reader.Read())
                {
                    if (reader.NodeType == XmlNodeType.Element)
                    {
                        if (reader.Name.Equals(node))
                        {
                            name = reader.Name;
                        }
                        else if (!reader.Name.Equals("entry") && name.Equals(node))
                        {
                            return list;
                        }
                        if ((name.Equals(node) && reader.Name.Equals("entry")) && (reader["text"] != null))
                        {
                            string str2 = reader["text"];
                            if (str2.StartsWith("/") || str2.StartsWith("@"))
                            {
                                str2 = str2.Substring(1);
                            }
                            list.Add(str2.Trim());
                        }
                    }
                }
                return list;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return null;
            }
        }

        public ArrayList spamFindOutstandingMail(string filename)
        {
            try
            {
                XmlDocument document = new XmlDocument();
                ArrayList list = new ArrayList();
                try
                {
                    document.Load(filename);
                }
                catch (FileNotFoundException)
                {
                    XmlDeclaration newChild = document.CreateXmlDeclaration("1.0", "utf-8", null);
                    XmlElement element = document.CreateElement("mail");
                    document.InsertBefore(newChild, document.DocumentElement);
                    document.AppendChild(element);
                }
                foreach (XmlNode node in document.DocumentElement.ChildNodes)
                {
                    if (((((node.Attributes["to"].Value.Length <= 0x4b) && !node.Attributes["to"].Value.Contains("fuck")) && (!node.Attributes["to"].Value.Contains("shit") && !node.Attributes["to"].Value.Contains("gay"))) && ((!node.Attributes["to"].Value.Contains("bitch") && !node.Attributes["to"].Value.Contains("pussy")) && (!node.Attributes["to"].Value.Contains("is a fag") && !node.Attributes["to"].Value.Contains("is a whore")))) && ((!node.Attributes["to"].Value.Contains("in the ass") && !node.Attributes["to"].Value.Contains("turbine")) && (!node.Attributes["to"].Value.Contains("s whore") && !list.Contains(node.Attributes["to"].Value))))
                    {
                        list.Add(node.Attributes["to"].Value);
                    }
                }
                return list;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return null;
            }
        }

        public ArrayList spamFindOutstandingMail(string filename, string playerFrom, string curPlayer)
        {
            try
            {
                XmlDocument document = new XmlDocument();
                ArrayList list = new ArrayList();
                try
                {
                    document.Load(filename);
                }
                catch (FileNotFoundException)
                {
                    XmlDeclaration newChild = document.CreateXmlDeclaration("1.0", "utf-8", null);
                    XmlElement element = document.CreateElement("mail");
                    document.InsertBefore(newChild, document.DocumentElement);
                    document.AppendChild(element);
                }
                foreach (XmlNode node in document.DocumentElement.ChildNodes)
                {
                    if ((node.Attributes["from"].Value.ToLower().Equals(curPlayer.ToLower()) && (node.Attributes["from"].Value.Length <= 0x4b)) && !list.Contains(node.Attributes["to"].Value))
                    {
                        list.Add(node.Attributes["to"].Value);
                    }
                }
                return list;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return null;
            }
        }

        public bool findRecipe(string activationItem, string filename)
        {
            try
            {
                XmlTextReader reader = new XmlTextReader(filename);
                while (reader.Read())
                {
                    if ((reader.NodeType == XmlNodeType.Element) && reader.HasAttributes)
                    {
                        if (reader.Name.Equals("skill"))
                        {
                            curSkill = reader["id"];
                        }
                        else if ((reader.Name.Equals("recipe") && !this.curSkill.Equals("Rare Tier 4")) && ((activationItem != null) && activationItem.Equals(reader["activateitem"])))
                        {
                            RecipeName = reader["name"];
                            _activateItem = reader["activateitem"];
                            _RecipeList.Add(reader["name"]);
                        }
                    }
                }
                return ((_RecipeList.Count > 0) || (RecipeName != null));
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return false;
            }
        }

        public bool checkCraftSteps()
        {
            foreach (string sUseItem in _UseItems)
            {
                if (sUseItem == null)
                {
                    continue;
                }

                bool flag = true;
                foreach (string sResItem in _ResultItems)
                {
                    if (((sUseItem != null) && (sResItem != null)) && sResItem.Equals(sUseItem))
                    {
                        flag = false;
                        break;
                    }
                }
                if (((sUseItem != null) && flag) && !this.checkIfExists(sUseItem))
                {
                    itemDoesNotExist(sUseItem);
                    return false;
                }
            }
            foreach(string sOnItem in _onItems)
            {
                if (sOnItem == null)
                {
                    continue;
                }
                bool flag2 = true;
                foreach (string sResItem in _ResultItems)
                {
                    if (((sOnItem != null) && (sResItem != null)) && sResItem.Equals(sOnItem))
                    {
                        flag2 = false;
                        break;
                    }
                }
                if (((sOnItem != null) && flag2) && !this.checkIfExists(sOnItem))
                {
                    itemDoesNotExist(sOnItem);
                    return false;
                }
            }
            return true;
        }

        public bool checkIfExists(string item)
        {
            if (item.IndexOf("salvage,") >= 0)
            {
                int salvageType = -1;
                salvageType = int.Parse(item.Substring(8, item.Length - 8));
                //addToChatQueue(item + ", " + salvageType);

                foreach (WorldObject obj2 in wObjTrade)
                {
                    if ((obj2 != null) && (obj2.ObjectClass == ObjectClass.Salvage && obj2.Values(LongValueKey.Material) == salvageType))
                    {
                        //addToChatQueue("Found " + item + " in wObjTrade");
                        return true;
                    }
                }
                foreach (WorldObject obj3 in base.Core.WorldFilter.GetInventory())
                {
                    if ((obj3.ObjectClass == ObjectClass.Salvage && obj3.Values(LongValueKey.Material) == salvageType))
                    {
                        //addToChatQueue("Found " + item + " in base.Core.WorldFilter.GetInventory()");
                        return true;
                    }
                }
            }
            else
            {
                foreach (WorldObject obj2 in wObjTrade)
                {
                    if ((obj2 != null) && obj2.Name.Equals(item))
                    {
                        return true;
                    }
                }
                foreach (WorldObject obj3 in base.Core.WorldFilter.GetInventory())
                {
                    if (item.Equals(obj3.Name))
                    {
                        return true;
                    }
                }
            }
            return false;
        }

        public bool checkMessages(string filename)
        {
            try
            {
                XmlDocument document = new XmlDocument();
                try
                {
                    document.Load(filename);
                }
                catch (FileNotFoundException)
                {
                    WriteToChat("Could not find message file.");
                    return false;
                }
                return (document.GetElementsByTagName("message").Count > 0);
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return false;
            }
        }

        public bool isImbue(string recipeName)
        {
            if (((((!recipeName.Equals("Peridot") && !recipeName.Equals("Yellow Topaz")) && (!recipeName.Equals("Zircon") && !recipeName.Equals("Aquamarine"))) && ((!recipeName.Equals("Black Garnet") && !recipeName.Equals("Emerald")) && (!recipeName.Equals("Imperial Topaz") && !recipeName.Equals("Jet")))) && (((!recipeName.Equals("Red Garnet") && !recipeName.Equals("White Sapphire")) && (!recipeName.Equals("Agate") && !recipeName.Equals("Azurite"))) && ((!recipeName.Equals("Black Opal") && !recipeName.Equals("Bloodstone")) && (!recipeName.Equals("Carnelian") && !recipeName.Equals("Citrine"))))) && (((!recipeName.Equals("Fire Opal") && !recipeName.Equals("Hematite")) && (!recipeName.Equals("Lapis Lazuli") && !recipeName.Equals("Lavender Jade"))) && ((!recipeName.Equals("Malachite") && !recipeName.Equals("Red Jade")) && ((!recipeName.Equals("Rose Quartz") && !recipeName.Equals("Smoky Quartz")) && !recipeName.Equals("Sunstone")))))
            {
                return false;
            }
            return true;
        }

        public bool loadAdTimer(string filename)
        {
            try
            {
                XmlTextReader reader = new XmlTextReader(filename);
                while (reader.Read())
                {
                    if (((reader.NodeType == XmlNodeType.Element) && reader.Name.Equals("adtimer")) && (reader["val"] != null))
                    {
                        _bf = int.Parse(reader["val"]);
                        return true;
                    }
                }
                return true;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return false;
            }
        }

        public bool loadBuffs(string filename)
        {
            try
            {
                _XmlDoc = new XmlDocument();
                _XmlDoc.Load(filename);
                _bi = _XmlDoc.GetElementsByTagName("spell");
                parseBuffData();
                return true;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return false;
            }
        }

        public bool loadEquipment(string filename)
        {
            try
            {
                parseEquipData(filename);
                return true;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return false;
            }
        }

        public bool loadPortals(string filename)
        {
            try
            {
                _XmlDoc = new XmlDocument();
                _XmlDoc.Load(filename);
                XmlAttributeCollection attributes = _XmlDoc.GetElementsByTagName("primaryportal")[0].Attributes;
                if (attributes != null)
                {
                    _primaryPortalSpellId = int.Parse(attributes["spellid"].Value);
                    _primaryPortalLocation = attributes["destination"].Value;
                }
                attributes = _XmlDoc.GetElementsByTagName("secondaryportal")[0].Attributes;
                if (attributes != null)
                {
                    _secondaryPortalSpellId = int.Parse(attributes["spellid"].Value);
                    _secondaryPortalLocation = attributes["destination"].Value;
                }
                return true;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return false;
            }
        }

        public bool loadRareCommands(string filename)
        {
            try
            {
                XmlTextReader reader = new XmlTextReader(filename);
                string str = "";
                while (reader.Read())
                {
                    if ((reader.NodeType == XmlNodeType.Element) && reader.HasAttributes)
                    {
                        if (reader.Name.Equals("skill"))
                        {
                            str = reader["id"];
                        }
                        else if (((reader.Name.Equals("recipe") && str.Equals("Rare Tier 4")) && ((reader["command"] != null) && (reader["name"] != null))) && (reader["desc"] != null))
                        {
                            rareCommands.Add(reader["command"]);
                            rareDesc.Add(reader["desc"]);
                            rareRecipeList.Add(reader["name"]);
                            _cn = true;
                        }
                    }
                }
                return true;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return false;
            }
        }

        public bool loadRecipes(string filename)
        {
            try
            {
                XmlTextReader reader = new XmlTextReader(filename);
                string str = "";
                while (reader.Read())
                {
                    if ((reader.NodeType == XmlNodeType.Element) && reader.HasAttributes)
                    {
                        if (reader.Name.Equals("skill"))
                        {
                            str = reader["id"];
                        }
                        else if ((reader.Name.Equals("recipe") && !str.Equals("Rare Tier 4")) && ((reader["name"] != null) && (reader["activateitem"] != null)))
                        {
                            recipeList.Add(reader["name"]);
                            activationList.Add(reader["activateitem"]);
                        }
                    }
                }
                return true;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return false;
            }
        }
        
        public bool recipeExists(string recipeName, string filename)
        {
            try
            {
                XmlTextReader reader = new XmlTextReader(filename);
                while (reader.Read())
                {
                    if ((reader.NodeType == XmlNodeType.Element) && reader.HasAttributes)
                    {
                        if (reader.Name.Equals("skill"))
                        {
                            curSkill = reader["id"];
                        }
                        else if ((reader.Name.Equals("recipe") && !this.curSkill.Equals("Rare Tier 4")) && ((recipeName != null) && recipeName.Equals(reader["name"])))
                        {
                            RecipeName = reader["name"];
                            return true;
                        }
                    }
                }
                return false;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return false;
            }
        }

        public bool validInteraction()
        {
            try
            {
                bool flag = false;
                if (curSkill.Equals("Weapon Tinkering"))
                {
                    if (_sayDebugMessages)
                    {
                        WriteToChat("Crafting::validInteraction() - Entering Weapon Tinkering checks.");
                    }
                    foreach (WorldObject obj2 in wObjTrade)
                    {
                        if (_sayDebugMessages)
                        {
                            WriteToChat("Crafting::validInteraction() - Testing item: " + obj2.Name);
                        }
                        if (obj2.ObjectClass.Equals(ObjectClass.MeleeWeapon))
                        {
                            if (!this.RecipeName.Equals("Mahogany"))
                            {
                                if (obj2.Values(LongValueKey.NumberTimesTinkered) >= 10)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at numTimesTikered check: " + obj2.Values(LongValueKey.NumberTimesTinkered));
                                    }
                                    return false;
                                }
                                if ((obj2.Values(LongValueKey.Imbued) > 0) && isImbue(RecipeName))
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at imbued check: " + obj2.Values(LongValueKey.Imbued));
                                    }
                                    return false;
                                }
                                if (obj2.Values(LongValueKey.Workmanship) <= 0)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at workmanship check: " + obj2.Values(LongValueKey.Workmanship));
                                    }
                                    return false;
                                }
                                if (_sayDebugMessages)
                                {
                                    WriteToChat("Crafting::validInteraction() - Passed initial Weapon Tinkering - Melee checks.");
                                }
                                tinkeringTarget = obj2;
                                return true;
                            }
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Failed at Weapon Tinkering - Melee recipe check: " + RecipeName);
                            }
                            flag = false;
                        }
                        else if (obj2.ObjectClass.Equals(ObjectClass.MissileWeapon))
                        {
                            if (!this.RecipeName.Equals("Iron") && !this.RecipeName.Equals("Granite"))
                            {
                                if (obj2.Values(LongValueKey.NumberTimesTinkered) >= 10)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at numTimesTikered check: " + obj2.Values(LongValueKey.NumberTimesTinkered));
                                    }
                                    return false;
                                }
                                if ((obj2.Values(LongValueKey.Imbued) > 0) && isImbue(RecipeName))
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at imbued check: " + obj2.Values(LongValueKey.Imbued));
                                    }
                                    return false;
                                }
                                if (obj2.Values(LongValueKey.Workmanship) <= 0)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at workmanship check: " + obj2.Values(LongValueKey.Workmanship));
                                    }
                                    return false;
                                }
                                if (_sayDebugMessages)
                                {
                                    WriteToChat("Crafting::validInteraction() - Passed initial Weapon Tinkering - Missile checks.");
                                }
                                tinkeringTarget = obj2;
                                return true;
                            }
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Failed at Weapon Tinkering - Missile recipe check: " + RecipeName);
                            }
                            flag = false;
                        }
                        else if (obj2.ObjectClass.Equals((ObjectClass)0x1f))
                        {
                            if ((!this.RecipeName.Equals("Iron") && !this.RecipeName.Equals("Granite")) && ((!this.RecipeName.Equals("Mahogany") && !this.RecipeName.Equals("Sunstone")) && !this.RecipeName.Equals("Velvet")))
                            {
                                if (obj2.Values(LongValueKey.NumberTimesTinkered) >= 10)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at numTimesTikered check: " + obj2.Values(LongValueKey.NumberTimesTinkered));
                                    }
                                    return false;
                                }
                                if ((obj2.Values(LongValueKey.Imbued) > 0) && isImbue(RecipeName))
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at imbued check: " + obj2.Values(LongValueKey.Imbued));
                                    }
                                    return false;
                                }
                                if (obj2.Values(LongValueKey.Workmanship) <= 0)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at workmanship check: " + obj2.Values(LongValueKey.Workmanship));
                                    }
                                    return false;
                                }
                                if (_sayDebugMessages)
                                {
                                    WriteToChat("Crafting::validInteraction() - Passed initial Weapon Tinkering - Magic checks.");
                                }
                                tinkeringTarget = obj2;
                                return true;
                            }
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Failed at Weaponing Tinkering - Magic recipe check: " + RecipeName);
                            }
                            flag = false;
                        }
                        else
                        {
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Failed at Weapon Tinkering - else check.");
                            }
                            flag = false;
                        }
                    }
                    return flag;
                }
                if (curSkill.Equals("Magic Item Tinkering"))
                {
                    if (_sayDebugMessages)
                    {
                        WriteToChat("Crafting::validInteraction() - Entering Magic Item Tinkering checks.");
                    }
                    foreach (WorldObject obj3 in wObjTrade)
                    {
                        if (_sayDebugMessages)
                        {
                            WriteToChat("Crafting::validInteraction() - Testing item: " + obj3.Name);
                        }
                        if (obj3.ObjectClass.Equals((ObjectClass)1))
                        {
                            if ((((!this.RecipeName.Equals("Agate") && !this.RecipeName.Equals("Azurite")) && (!this.RecipeName.Equals("Bloodstone") && !this.RecipeName.Equals("Carnelian"))) && ((!this.RecipeName.Equals("Citrine") && !this.RecipeName.Equals("Hematite")) && (!this.RecipeName.Equals("Lapis Lazuli") && !this.RecipeName.Equals("Lavender Jade")))) && (((!this.RecipeName.Equals("Malachite") && !this.RecipeName.Equals("Red Jade")) && (!this.RecipeName.Equals("Rose Quartz") && !this.RecipeName.Equals("Smoky Quartz"))) && (!this.RecipeName.Equals("Opal") && !this.RecipeName.Equals("Green Garnet"))))
                            {
                                if (obj3.Values(LongValueKey.NumberTimesTinkered ) >= 10)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at numTimesTikered check: " + obj3.Values(LongValueKey.NumberTimesTinkered));
                                    }
                                    return false;
                                }
                                if ((obj3.Values(LongValueKey.Imbued) > 0) && isImbue(RecipeName))
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at imbued check: " + obj3.Values(LongValueKey.Imbued));
                                    }
                                    return false;
                                }
                                if (obj3.Values(LongValueKey.Workmanship) <= 0)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at workmanship check: " + obj3.Values(LongValueKey.Workmanship));
                                    }
                                    return false;
                                }
                                if (_sayDebugMessages)
                                {
                                    WriteToChat("Crafting::validInteraction() - Passed initial Magic Item Tinkering Tinkering - Melee checks.");
                                }
                                tinkeringTarget = obj3;
                                return true;
                            }
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Failed at Magic Item Tikering - Melee recipe check: " + RecipeName);
                            }
                            flag = false;
                        }
                        else if (obj3.ObjectClass.Equals((ObjectClass)9))
                        {
                            if ((((!this.RecipeName.Equals("Agate") && !this.RecipeName.Equals("Azurite")) && (!this.RecipeName.Equals("Bloodstone") && !this.RecipeName.Equals("Carnelian"))) && ((!this.RecipeName.Equals("Citrine") && !this.RecipeName.Equals("Hematite")) && (!this.RecipeName.Equals("Lapis Lazuli") && !this.RecipeName.Equals("Lavender Jade")))) && (((!this.RecipeName.Equals("Malachite") && !this.RecipeName.Equals("Red Jade")) && (!this.RecipeName.Equals("Rose Quartz") && !this.RecipeName.Equals("Smoky Quartz"))) && (!this.RecipeName.Equals("Opal") && !this.RecipeName.Equals("Green Garnet"))))
                            {
                                if (obj3.Values(LongValueKey.NumberTimesTinkered) >= 10)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at numTimesTikered check: " + obj3.Values(LongValueKey.NumberTimesTinkered));
                                    }
                                    return false;
                                }
                                if ((obj3.Values(LongValueKey.Imbued) > 0) && isImbue(RecipeName))
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at imbued check: " + obj3.Values(LongValueKey.Imbued));
                                    }
                                    return false;
                                }
                                if (obj3.Values(LongValueKey.Workmanship) <= 0)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at workmanship check: " + obj3.Values(LongValueKey.Workmanship));
                                    }
                                    return false;
                                }
                                if (_sayDebugMessages)
                                {
                                    WriteToChat("Crafting::validInteraction() - Passed initial Magic Item Tinkering Tinkering - Missile checks.");
                                }
                                tinkeringTarget = obj3;
                                return true;
                            }
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Failed at Magic Item Tinkering - Missile check: " + RecipeName);
                            }
                            flag = false;
                        }
                        else if (obj3.ObjectClass.Equals((ObjectClass)0x1f))
                        {
                            if ((((!this.RecipeName.Equals("Agate") && !this.RecipeName.Equals("Azurite")) && (!this.RecipeName.Equals("Bloodstone") && !this.RecipeName.Equals("Carnelian"))) && ((!this.RecipeName.Equals("Citrine") && !this.RecipeName.Equals("Hematite")) && (!this.RecipeName.Equals("Lapis Lazuli") && !this.RecipeName.Equals("Lavender Jade")))) && ((!this.RecipeName.Equals("Malachite") && !this.RecipeName.Equals("Red Jade")) && (!this.RecipeName.Equals("Rose Quartz") && !this.RecipeName.Equals("Smoky Quartz"))))
                            {
                                if (obj3.Values(LongValueKey.NumberTimesTinkered) >= 10)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at numTimesTikered check: " + obj3.Values(LongValueKey.NumberTimesTinkered));
                                    }
                                    return false;
                                }
                                if ((obj3.Values(LongValueKey.Imbued) > 0) && isImbue(RecipeName))
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at imbued check: " + obj3.Values(LongValueKey.Imbued));
                                    }
                                    return false;
                                }
                                if (obj3.Values(LongValueKey.Workmanship) <= 0)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at workmanship check: " + obj3.Values(LongValueKey.Workmanship));
                                    }
                                    return false;
                                }
                                if (_sayDebugMessages)
                                {
                                    WriteToChat("Crafting::validInteraction() - Passed initial Magic Item Tinkering Tinkering - Magic checks.");
                                }
                                tinkeringTarget = obj3;
                                return true;
                            }
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Failed at Magic Item Tinkering - Magic recipe check: " + RecipeName);
                            }
                            flag = false;
                        }
                        else if (obj3.ObjectClass.Equals((ObjectClass)4))
                        {
                            if ((!this.RecipeName.Equals("Black Opal") && !this.RecipeName.Equals("Fire Opal")) && ((!this.RecipeName.Equals("Sunstone") && !this.RecipeName.Equals("Opal")) && !this.RecipeName.Equals("Green Garnet")))
                            {
                                if (obj3.Values(LongValueKey.NumberTimesTinkered) >= 10)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at numTimesTikered check: " + obj3.Values(LongValueKey.NumberTimesTinkered));
                                    }
                                    return false;
                                }
                                if ((obj3.Values(LongValueKey.Imbued) > 0) && isImbue(RecipeName))
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at imbued check: " + obj3.Values(LongValueKey.Imbued));
                                    }
                                    return false;
                                }
                                if (obj3.Values(LongValueKey.Workmanship) <= 0)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at workmanship check: " + obj3.Values(LongValueKey.Workmanship));
                                    }
                                    return false;
                                }
                                if (_sayDebugMessages)
                                {
                                    WriteToChat("Crafting::validInteraction() - Passed initial Magic Item Tinkering Tinkering - Jewelry checks.");
                                }
                                tinkeringTarget = obj3;
                                return true;
                            }
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Failed at Magic Item Tinkering - Jewelry recipe check: " + RecipeName);
                            }
                            flag = false;
                        }
                        else if (obj3.ObjectClass.Equals((ObjectClass)2) || obj3.ObjectClass.Equals((ObjectClass)3))
                        {
                            if ((!this.RecipeName.Equals("Opal") && !this.RecipeName.Equals("Green Garnet")) && !this.isImbue(RecipeName))
                            {
                                if (obj3.Values(LongValueKey.NumberTimesTinkered) >= 10)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at numTimesTikered check: " + obj3.Values(LongValueKey.NumberTimesTinkered));
                                    }
                                    return false;
                                }
                                if (obj3.Values(LongValueKey.Workmanship) <= 0)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at workmanship check: " + obj3.Values(LongValueKey.Workmanship));
                                    }
                                    return false;
                                }
                                if (_sayDebugMessages)
                                {
                                    WriteToChat("Crafting::validInteraction() - Passed initial Magic Item Tinkering Tinkering - Armor/Clothing checks.");
                                }
                                tinkeringTarget = obj3;
                                return true;
                            }
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Failed at Magic Item Tinkering - Armor/Clothing recipe check: " + RecipeName);
                            }
                            flag = false;
                        }
                        else
                        {
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Failed at Magic Item Tinkering Tinkering - else check.");
                            }
                            flag = false;
                        }
                    }
                    return flag;
                }
                if (curSkill.Equals("Item Tinkering"))
                {
                    if (_sayDebugMessages)
                    {
                        WriteToChat("Crafting::validInteraction() - Entering Item Tinkering checks.");
                    }
                    foreach (WorldObject obj4 in wObjTrade)
                    {
                        if (_sayDebugMessages)
                        {
                            WriteToChat("Crafting::validInteraction() - Testing item: " + obj4.Name);
                        }
                        if (((obj4.ObjectClass.Equals(ObjectClass.Armor) || obj4.ObjectClass.Equals(ObjectClass.Clothing)) || (obj4.ObjectClass.Equals(ObjectClass.Jewelry) || obj4.ObjectClass.Equals(ObjectClass.MeleeWeapon))) || (obj4.ObjectClass.Equals(ObjectClass.MissileWeapon) || obj4.ObjectClass.Equals(ObjectClass.WandStaffOrb)))
                        {
                            if (obj4.Values(LongValueKey.NumberTimesTinkered) >= 10)
                            {
                                if (_sayDebugMessages)
                                {
                                    WriteToChat("Crafting::validInteraction() - Failed at numTimesTikered check: " + obj4.Values(LongValueKey.NumberTimesTinkered));
                                }
                                return false;
                            }
                            if ((obj4.Values(LongValueKey.Imbued) > 0) && isImbue(RecipeName))
                            {
                                if (_sayDebugMessages)
                                {
                                    WriteToChat("Crafting::validInteraction() - Failed at imbued check: " + obj4.Values(LongValueKey.Imbued));
                                }
                                return false;
                            }
                            if (obj4.Values(LongValueKey.Workmanship) <= 0)
                            {
                                if (_sayDebugMessages)
                                {
                                    WriteToChat("Crafting::validInteraction() - Failed at workmanship check: " + obj4.Values(LongValueKey.Workmanship));
                                }
                                return false;
                            }
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Passed initial Item Tinkering checks.");
                            }
                            //if (RecipeName.Equals("Silk") && (obj4.Values(110) <= 0))
                            //{
                            //    if (_sayDebugMessages)
                            //    {
                            //        WriteToChat("Crafting::validInteraction() - Failed at silk check: " + obj4.Values(110));
                            //    }
                            //    return false;
                            //}
                            //if (RecipeName.Equals("Teak") && ((obj4.Values(0xbc) <= 0) || (obj4.Values(0xbc) == 1)))
                            //{
                            //    if (_sayDebugMessages)
                            //    {
                            //        WriteToChat("Crafting::validInteraction() - Failed at teak check: " + obj4.Values(0xbc));
                            //    }
                            //    return false;
                            //}
                            //if (RecipeName.Equals("Ebony") && ((obj4.Values(0xbc) <= 0) || (obj4.Values(0xbc) == 2)))
                            //{
                            //    if (_sayDebugMessages)
                            //    {
                            //        WriteToChat("Crafting::validInteraction() - Failed at ebony check: " + obj4.Values(0xbc));
                            //    }
                            //    return false;
                            //}
                            //if (RecipeName.Equals("Porcelain") && ((obj4.Values(0xbc) <= 0) || (obj4.Values(0xbc) == 3)))
                            //{
                            //    if (_sayDebugMessages)
                            //    {
                            //        WriteToChat("Crafting::validInteraction() - Failed at porcelain check: " + obj4.Values(0xbc));
                            //    }
                            //    return false;
                            //}
                            //if (RecipeName.Equals("Satin") && ((obj4.Values(0xbc) <= 0) || (obj4.Values(0xbc) == 4)))
                            //{
                            //    if (_sayDebugMessages)
                            //    {
                            //        WriteToChat("Crafting::validInteraction() - Failed at satin check: " + obj4.Values(0xbc));
                            //    }
                            //    return false;
                            //}
                            //if (RecipeName.Equals("Copper") && (obj4.Values(0xb0) != 7))
                            //{
                            //    if (_sayDebugMessages)
                            //    {
                            //        WriteToChat("Crafting::validInteraction() - Failed at copper check: " + obj4.Values(0xb0));
                            //    }
                            //    return false;
                            //}
                            //if (RecipeName.Equals("Silver") && (obj4.Values(0xb0) != 6))
                            //{
                            //    if (_sayDebugMessages)
                            //    {
                            //        WriteToChat("Crafting::validInteraction() - Failed at silver check: " + obj4.Values(0xb0));
                            //    }
                            //    return false;
                            //}
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Passed Item Tinkering checks.");
                            }
                            tinkeringTarget = obj4;
                            return true;
                        }
                        if (_sayDebugMessages)
                        {
                            WriteToChat("Crafting::validInteraction() - Failed at Item Tinkering else check.");
                        }
                        flag = false;
                    }
                    return flag;
                }
                if (curSkill.Equals("Armor Tinkering"))
                {
                    if (_sayDebugMessages)
                    {
                        WriteToChat("Crafting::validInteraction() - Entering Armor Tinkering checks.");
                    }
                    foreach (WorldObject obj5 in wObjTrade)
                    {
                        if (_sayDebugMessages)
                        {
                            WriteToChat("Crafting::validInteraction() - Testing item: " + obj5.Name);
                        }
                        if (obj5.ObjectClass.Equals(ObjectClass.Armor) || (obj5.ObjectClass.Equals(ObjectClass.Clothing) && (obj5.Values(LongValueKey.ArmorLevel) > 0)))
                        {
                            if (!obj5.Name.Contains("Covenant"))
                            {
                                if (obj5.Values(LongValueKey.NumberTimesTinkered) >= 10)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at numTimesTikered check: " + obj5.Values(LongValueKey.NumberTimesTinkered));
                                    }
                                    return false;
                                }
                                if ((obj5.Values(LongValueKey.Imbued) > 0) && isImbue(RecipeName))
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at imbued check: " + obj5.Values(LongValueKey.Imbued));
                                    }
                                    return false;
                                }
                                if (obj5.Values(LongValueKey.Workmanship) <= 0)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at workmanship check: " + obj5.Values(LongValueKey.Workmanship));
                                    }
                                    return false;
                                }
                                if (_sayDebugMessages)
                                {
                                    WriteToChat("Crafting::validInteraction() - Passed initial Armor Tinkering - Non-Covenant checks.");
                                }
                                tinkeringTarget = obj5;
                                return true;
                            }
                            if (!this.RecipeName.Equals("Steel"))
                            {
                                if (obj5.Values(LongValueKey.NumberTimesTinkered) >= 10)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at numTimesTikered check: " + obj5.Values(LongValueKey.NumberTimesTinkered));
                                    }
                                    return false;
                                }
                                if ((obj5.Values(LongValueKey.Imbued) > 0) && isImbue(RecipeName))
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at imbued check: " + obj5.Values(LongValueKey.Imbued));
                                    }
                                    return false;
                                }
                                if (obj5.Values(LongValueKey.Workmanship) <= 0)
                                {
                                    if (_sayDebugMessages)
                                    {
                                        WriteToChat("Crafting::validInteraction() - Failed at workmanship check: " + obj5.Values(LongValueKey.Workmanship));
                                    }
                                    return false;
                                }
                                if (_sayDebugMessages)
                                {
                                    WriteToChat("Crafting::validInteraction() - Passed initial Armor Tinkering - Covenant checks.");
                                }
                                tinkeringTarget = obj5;
                                return true;
                            }
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Failed at Armor Tinkering - Covenant recipe check: " + RecipeName);
                            }
                            flag = false;
                        }
                        else
                        {
                            if (_sayDebugMessages)
                            {
                                WriteToChat("Crafting::validInteraction() - Failed at Armor Tinkering - Else check.");
                            }
                            flag = false;
                        }
                    }
                    return flag;
                }
                if (_sayDebugMessages)
                {
                    WriteToChat("Crafting::validInteraction() - Passed tinkering checks. Skill: " + curSkill);
                }
                return true;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return false;
            }
        }

        public string debugFile
        {
            get
            {
                return (personalFolderPath + @"\debug.txt");
            }
        }

        public string errorLogFile
        {
            get
            {
                return (personalFolderPath + @"\errorLog.txt");
            }
        }

        public string giftFile
        {
            get
            {
                return (personalFolderPath + @"\gifts.txt");
            }
        }

        public string mailFile
        {
            get
            {
                return (personalFolderPath + @"\mail.txt");
            }
        }

        public string mailFileXML
        {
            get
            {
                return (personalFolderPath + @"\mail.xml");
            }
        }

        public string riFile
        {
            get
            {
                return (personalFolderPath + @"\return_items.xml");
            }
        }

        public double getChanceOfSuccess(int i) 
        {
            try
            {
                int num = 0;
                int num2 = 0;
                int num3 = 0;
                int num4 = 0;
                int num5 = 0;
                int num6 = 0;
                int num7 = 0;
                int num8 = 0;
                if (Settings.Default.useMajorsForSkillCheck)
                {
                    num += 30;
                    num2 += 30;
                    num3 += 30;
                    num4 += 30;
                    num5 += 0x19;
                    num6 += 0x19;
                    num7 += 0x19;
                    num8 += 0x19;
                }
                if (Settings.Default.useArtisanPetsSkillCheck)
                {
                    num5 += 30;
                    num6 += 30;
                    num7 += 30;
                    num8 += 30;
                }
                else if (Settings.Default.useMasterPetsSkillCheck)
                {
                    num5 += 20;
                    num6 += 20;
                    num7 += 20;
                    num8 += 20;
                }
                else if (Settings.Default.useJourneymanPetsSkillChecks)
                {
                    num5 += 10;
                    num6 += 10;
                    num7 += 10;
                    num8 += 10;
                }
                if (wObjTrade != null)
                {
                    bool flag = false;
                    foreach (WorldObject obj2 in wObjTrade)
                    {
                        if (obj2.Name.Equals("Smithy's Crystal") && !flag)
                        {
                            num += 250;
                            flag = true;
                        }
                        else if (obj2.Name.Equals("Tinker's Crystal") && !flag)
                        {
                            num2 += 250;
                            flag = true;
                        }
                        else if (obj2.Name.Equals("Imbuer's Crystal") && !flag)
                        {
                            num3 += 250;
                            flag = true;
                        }
                        else if (obj2.Name.Equals("Artist's Crystal") && !flag)
                        {
                            num4 += 250;
                            flag = true;
                        }
                        else if (obj2.Name.Equals("Alchemist's Crystal") && !flag)
                        {
                            num6 += 250;
                            flag = true;
                        }
                        else if (obj2.Name.Equals("Chef's Crystal") && !flag)
                        {
                            num7 += 250;
                            flag = true;
                        }
                        else if (obj2.Name.Equals("Fletcher's Crystal") && !flag)
                        {
                            num8 += 250;
                            flag = true;
                        }
                        else if (obj2.Name.Equals("Thief's Crystal") && !flag)
                        {
                            num5 += 250;
                            flag = true;
                        }
                        else if (obj2.Name.Equals("Lugian's Pearl") && !flag)
                        {
                            num4 += 0x7d;
                            flag = true;
                        }
                        else if (obj2.Name.Equals("Ursuin's Pearl") && !flag)
                        {
                            num += 0x7d;
                            flag = true;
                        }
                        else if (obj2.Name.Equals("Wayfarer's Pearl") && !flag)
                        {
                            num2 += 0x7d;
                            num6 += 0x53;
                            num7 += 0x53;
                            num8 += 0x53;
                            num5 += 0x53;
                            flag = true;
                        }
                        else if (obj2.Name.Equals("Magus's Pearl") && !flag)
                        {
                            num += 0x7d;
                            num2 += 0x7d;
                            num3 += 250;
                            num4 += 250;
                            num6 += 0x53;
                            num7 += 0x53;
                            num8 += 0x53;
                            num5 += 0x53;
                            flag = true;
                        }
                        else if (obj2.Name.Equals("Tusker Spit Ale"))
                        {
                            num += 5;
                            num2 += 5;
                            num3 += 10;
                            num4 += 5;
                            num6 += 3;
                            num7 += 3;
                            num8 += 3;
                            num5 += 3;
                        }
                        else if (obj2.Name.Equals("Amber Ape"))
                        {
                            num2 += 5;
                            num6 += 3;
                            num7 += 3;
                            num8 += 3;
                            num5 += 3;
                        }
                        else if (obj2.Name.Equals("Apothecary Zongo's Stout"))
                        {
                            num4 += 5;
                        }
                        else if (obj2.Name.Equals("Hunter's Stock Amber"))
                        {
                            num += 5;
                        }
                    }
                }
                if ((curSkill.Equals("Armor Tinkering") || curSkill.Equals("Item Tinkering")) || (curSkill.Equals("Magic Item Tinkering") || curSkill.Equals("Weapon Tinkering")))
                {
                    Salvage salvage = sortedSalvage[i];
                    string str = salvage.getName();
                    int index = str.IndexOf('(');
                    if (index > 0)
                    {
                        str = str.Substring(0, index - 1);
                    }

                    //string key = str;
                    //if (key != null)
                    //{
                    //    int num16;
                    //    if (_dictionaryCmds4 == null)
                    //    {
                    //        Dictionary<string, int> dictionary1 = new Dictionary<string, int>(0x34);
                    //        dictionary1.Add("Salvaged Alabaster", 0);
                    //        dictionary1.Add("Salvaged Armoredillo Hide", 1);
                    //        dictionary1.Add("Salvaged Bronze", 2);
                    //        dictionary1.Add("Salvaged Ceramic", 3);
                    //        dictionary1.Add("Salvaged Marble", 4);
                    //        dictionary1.Add("Salvaged Peridot", 5);
                    //        dictionary1.Add("Salvaged Reedshark Hide", 6);
                    //        dictionary1.Add("Salvaged Steel", 7);
                    //        dictionary1.Add("Salvaged Wool", 8);
                    //        dictionary1.Add("Salvaged Yellow Topaz", 9);
                    //        dictionary1.Add("Salvaged Zircon", 10);
                    //        dictionary1.Add("Salvaged Copper", 11);
                    //        dictionary1.Add("Salvaged Ebony", 12);
                    //        dictionary1.Add("Salvaged Gold", 13);
                    //        dictionary1.Add("Salvaged Linen", 14);
                    //        dictionary1.Add("Salvaged Moonstone", 15);
                    //        dictionary1.Add("Salvaged Pine", 0x10);
                    //        dictionary1.Add("Salvaged Porcelain", 0x11);
                    //        dictionary1.Add("Salvaged Satin", 0x12);
                    //        dictionary1.Add("Salvaged Silk", 0x13);
                    //        dictionary1.Add("Salvaged Silver", 20);
                    //        dictionary1.Add("Salvaged Teak", 0x15);
                    //        dictionary1.Add("Salvaged Agate", 0x16);
                    //        dictionary1.Add("Salvaged Azurite", 0x17);
                    //        dictionary1.Add("Salvaged Black Opal", 0x18);
                    //        dictionary1.Add("Salvaged Bloodstone", 0x19);
                    //        dictionary1.Add("Salvaged Carnelian", 0x1a);
                    //        dictionary1.Add("Salvaged Citrine", 0x1b);
                    //        dictionary1.Add("Salvaged Fire Opal", 0x1c);
                    //        dictionary1.Add("Salvaged Green Garnet", 0x1d);
                    //        dictionary1.Add("Salvaged Hematite", 30);
                    //        dictionary1.Add("Salvaged Lapis Lazuli", 0x1f);
                    //        dictionary1.Add("Salvaged Lavender Jade", 0x20);
                    //        dictionary1.Add("Salvaged Malachite", 0x21);
                    //        dictionary1.Add("Salvaged Opal", 0x22);
                    //        dictionary1.Add("Salvaged Red Jade", 0x23);
                    //        dictionary1.Add("Salvaged Rose Quartz", 0x24);
                    //        dictionary1.Add("Salvaged Smoky Quartz", 0x25);
                    //        dictionary1.Add("Salvaged Sunstone", 0x26);
                    //        dictionary1.Add("Salvaged Aquamarine", 0x27);
                    //        dictionary1.Add("Salvaged Black Garnet", 40);
                    //        dictionary1.Add("Salvaged Brass", 0x29);
                    //        dictionary1.Add("Salvaged Emerald", 0x2a);
                    //        dictionary1.Add("Salvaged Granite", 0x2b);
                    //        dictionary1.Add("Salvaged Imperial Topaz", 0x2c);
                    //        dictionary1.Add("Salvaged Iron", 0x2d);
                    //        dictionary1.Add("Salvaged Jet", 0x2e);
                    //        dictionary1.Add("Salvaged Mahogany", 0x2f);
                    //        dictionary1.Add("Salvaged Oak", 0x30);
                    //        dictionary1.Add("Salvaged Red Garnet", 0x31);
                    //        dictionary1.Add("Salvaged Velvet", 50);
                    //        dictionary1.Add("Salvaged White Sapphire", 0x33);
                    //        _dictionaryCmds4 = dictionary1;
                    //    }
                    //    if (_dictionaryCmds4.TryGetValue(key, out num16))
                    //    {

                            switch (salvage.getSalvageType())
                            {
                                case (int)Salvages.Alabaster:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                                case (int)Salvages.Armoredillo_Hide :
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                                case (int)Salvages.Bronze:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                                case (int)Salvages.Ceramic:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                                case (int)Salvages.Marble:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                                case (int)Salvages.Peridot:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                                case (int)Salvages.Reed_Shark_Hide:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                                case (int)Salvages.Steel:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                                case (int)Salvages.Wool:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                                case (int)Salvages.Yellow_Topaz:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                                case (int)Salvages.Zircon:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                                case (int)Salvages.Copper:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 15, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                                case (int)Salvages.Ebony:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                                case (int)Salvages.Gold:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 10, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                                case (int)Salvages.Linen:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                                case (int)Salvages.Moonstone:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                                case (int)Salvages.Pine:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                                case (int)Salvages.Porcelain:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                                case (int)Salvages.Satin:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                                case (int)Salvages.Silk:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                                case (int)Salvages.Silver:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 15, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                                case (int)Salvages.Teak:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                                case (int)Salvages.Agate:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Azurite:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Black_Opal :
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Bloodstone:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Carnelian:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Citrine:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Fire_Opal:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Green_Garnet:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Hematite:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Lapis_Lazuli:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Lavender_Jade:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Malachite:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Opal:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Red_Jade:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Rose_Quartz:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Smokey_Quartz:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Sunstone:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                                case (int)Salvages.Aquamarine:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                                case (int)Salvages.Black_Garnet:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                                case (int)Salvages.Brass:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                                case (int)Salvages.Emerald:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                                case (int)Salvages.Granite:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                                case (int)Salvages.Imperial_Topaz:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                                case (int)Salvages.Iron:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                                case (int)Salvages.Jet:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                                case (int)Salvages.Mahogany:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                                case (int)Salvages.Oak:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 10, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                                case (int)Salvages.Red_Garnet:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                                case (int)Salvages.Velvet:
                                    tinkerCount++;
                                    return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                                case (int)Salvages.White_Sapphire:
                                    tinkerCount++;
                                    return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);
                            }


                            //string key = str;
                            //if (key != null)
                            //{
                            //    int num16;
                            //    if (_dictionaryCmds4 == null)
                            //    {
                            //        Dictionary<string, int> dictionary1 = new Dictionary<string, int>(0x34);
                            //        dictionary1.Add("Salvaged Alabaster", 0);
                            //        dictionary1.Add("Salvaged Armoredillo Hide", 1);
                            //        dictionary1.Add("Salvaged Bronze", 2);
                            //        dictionary1.Add("Salvaged Ceramic", 3);
                            //        dictionary1.Add("Salvaged Marble", 4);
                            //        dictionary1.Add("Salvaged Peridot", 5);
                            //        dictionary1.Add("Salvaged Reedshark Hide", 6);
                            //        dictionary1.Add("Salvaged Steel", 7);
                            //        dictionary1.Add("Salvaged Wool", 8);
                            //        dictionary1.Add("Salvaged Yellow Topaz", 9);
                            //        dictionary1.Add("Salvaged Zircon", 10);
                            //        dictionary1.Add("Salvaged Copper", 11);
                            //        dictionary1.Add("Salvaged Ebony", 12);
                            //        dictionary1.Add("Salvaged Gold", 13);
                            //        dictionary1.Add("Salvaged Linen", 14);
                            //        dictionary1.Add("Salvaged Moonstone", 15);
                            //        dictionary1.Add("Salvaged Pine", 0x10);
                            //        dictionary1.Add("Salvaged Porcelain", 0x11);
                            //        dictionary1.Add("Salvaged Satin", 0x12);
                            //        dictionary1.Add("Salvaged Silk", 0x13);
                            //        dictionary1.Add("Salvaged Silver", 20);
                            //        dictionary1.Add("Salvaged Teak", 0x15);
                            //        dictionary1.Add("Salvaged Agate", 0x16);
                            //        dictionary1.Add("Salvaged Azurite", 0x17);
                            //        dictionary1.Add("Salvaged Black Opal", 0x18);
                            //        dictionary1.Add("Salvaged Bloodstone", 0x19);
                            //        dictionary1.Add("Salvaged Carnelian", 0x1a);
                            //        dictionary1.Add("Salvaged Citrine", 0x1b);
                            //        dictionary1.Add("Salvaged Fire Opal", 0x1c);
                            //        dictionary1.Add("Salvaged Green Garnet", 0x1d);
                            //        dictionary1.Add("Salvaged Hematite", 30);
                            //        dictionary1.Add("Salvaged Lapis Lazuli", 0x1f);
                            //        dictionary1.Add("Salvaged Lavender Jade", 0x20);
                            //        dictionary1.Add("Salvaged Malachite", 0x21);
                            //        dictionary1.Add("Salvaged Opal", 0x22);
                            //        dictionary1.Add("Salvaged Red Jade", 0x23);
                            //        dictionary1.Add("Salvaged Rose Quartz", 0x24);
                            //        dictionary1.Add("Salvaged Smoky Quartz", 0x25);
                            //        dictionary1.Add("Salvaged Sunstone", 0x26);
                            //        dictionary1.Add("Salvaged Aquamarine", 0x27);
                            //        dictionary1.Add("Salvaged Black Garnet", 40);
                            //        dictionary1.Add("Salvaged Brass", 0x29);
                            //        dictionary1.Add("Salvaged Emerald", 0x2a);
                            //        dictionary1.Add("Salvaged Granite", 0x2b);
                            //        dictionary1.Add("Salvaged Imperial Topaz", 0x2c);
                            //        dictionary1.Add("Salvaged Iron", 0x2d);
                            //        dictionary1.Add("Salvaged Jet", 0x2e);
                            //        dictionary1.Add("Salvaged Mahogany", 0x2f);
                            //        dictionary1.Add("Salvaged Oak", 0x30);
                            //        dictionary1.Add("Salvaged Red Garnet", 0x31);
                            //        dictionary1.Add("Salvaged Velvet", 50);
                            //        dictionary1.Add("Salvaged White Sapphire", 0x33);
                            //        _dictionaryCmds4 = dictionary1;
                            //    }
                            //    if (_dictionaryCmds4.TryGetValue(key, out num16))
                            //    {

                            //switch (num16)
                            //{
                            //    case 0:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                            //    case 1:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                            //    case 2:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                            //    case 3:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                            //    case 4:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                            //    case 5:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                            //    case 6:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                            //    case 7:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                            //    case 8:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                            //    case 9:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                            //    case 10:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ArmorTinkering] + 0x19) + num);

                            //    case 11:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 15, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                            //    case 12:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                            //    case 13:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 10, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                            //    case 14:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                            //    case 15:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                            //    case 0x10:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                            //    case 0x11:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                            //    case 0x12:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                            //    case 0x13:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                            //    case 20:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 15, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                            //    case 0x15:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.ItemTinkering] + 0x19) + num2);

                            //    case 0x16:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x17:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x18:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x19:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x1a:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x1b:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x1c:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x1d:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 30:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x1f:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x20:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x21:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x22:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x23:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x24:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x25:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 0x19, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x26:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.MagicItemTinkering] + 50) + num3);

                            //    case 0x27:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                            //    case 40:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                            //    case 0x29:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                            //    case 0x2a:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                            //    case 0x2b:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                            //    case 0x2c:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                            //    case 0x2d:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                            //    case 0x2e:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                            //    case 0x2f:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 12, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                            //    case 0x30:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 10, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                            //    case 0x31:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                            //    case 50:
                            //        tinkerCount++;
                            //        return calculateDifficulty(false, charmedSmith, 11, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);

                            //    case 0x33:
                            //        tinkerCount++;
                            //        return calculateDifficulty(true, charmedSmith, 20, tinkeringTarget.Values(LongValueKey.Workmanship), salvage.getWork(), tinkerCount, (base.Core.CharacterFilter.EffectiveSkill[CharFilterSkillType.WeaponTinkering] + 0x19) + num4);
                            //}
                    //    }
                    //}
                    return 0.0;
                }
                int num10 = 100;
                int num11 = 0;
                foreach (string str2 in _SkillChecks)
                {
                    if (str2 != null)
                    {
                        int length = str2.LastIndexOf('-');
                        string s = str2.Substring(0, length);
                        string str4 = str2.Substring(length + 1);
                        if (str4.Equals("Armor Tinkering") && !Settings.Default.useArmorTinkering)
                        {
                            e(str4);
                            resetCraftingState();
                        }
                        else if (str4.Equals("Item Tinkering") && !Settings.Default.useItemTinerking)
                        {
                            e(str4);
                            resetCraftingState();
                        }
                        else if (str4.Equals("Magic Item Tinkering") && !Settings.Default.useMagicItemTinkering)
                        {
                            e(str4);
                            resetCraftingState();
                        }
                        else if (str4.Equals("Weapon Tinkering") && !Settings.Default.useWeaponTinkering)
                        {
                            e(str4);
                            resetCraftingState();
                        }
                        else if (str4.Equals("Alchemy") && !Settings.Default.useAlchemy)
                        {
                            e(str4);
                            resetCraftingState();
                        }
                        else if (str4.Equals("Cooking") && !Settings.Default.useCooking)
                        {
                            e(str4);
                            resetCraftingState();
                        }
                        else if (str4.Equals("Fletching") && !Settings.Default.useFletching)
                        {
                            e(str4);
                            resetCraftingState();
                        }
                        else if (str4.Equals("Lockpick") && !Settings.Default.useLockpick)
                        {
                            e(str4);
                            resetCraftingState();
                        }
                        else if (str4.Equals("Rare Tier 4") && !Settings.Default.useTier4Rares)
                        {
                            e(str4);
                            resetCraftingState();
                        }
                        int num13 = int.Parse(s);
                        num11 = 0;
                        if (str4.Equals("Alchemy"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Alchemy].Buffed + num6;
                        }
                        else if (str4.Equals("Arcane Lore"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.ArcaneLore].Buffed;
                        }
                        else if (str4.Equals("Assess Creature"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.AssessCreature].Buffed;
                        }
                        else if (str4.Equals("Assess Person"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.AssessPerson].Buffed;
                        }
                        else if (curSkill.Equals("Axe"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Axe].Buffed;
                        }
                        else if (str4.Equals("Bow"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Bow].Buffed;
                        }
                        else if (str4.Equals("Cooking"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Cooking].Buffed + num7;
                        }
                        else if (str4.Equals("Creature Enchantment"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.CreatureEnchantment].Buffed;
                        }
                        else if (str4.Equals("Crossbow"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Crossbow].Buffed;
                        }
                        else if (str4.Equals("Dagger"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Dagger].Buffed;
                        }
                        else if (str4.Equals("Deception"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Deception].Buffed;
                        }
                        else if (str4.Equals("Fletching"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Fletching].Buffed + num8;
                        }
                        else if (str4.Equals("Healing"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Healing].Buffed;
                        }
                        else if (str4.Equals("Item Enchantment"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.ItemEnchantment].Buffed;
                        }
                        else if (str4.Equals("Jump"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Jump].Buffed;
                        }
                        else if (str4.Equals("Leadership"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Leadership].Buffed;
                        }
                        else if (str4.Equals("Life Magic"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.LifeMagic].Buffed;
                        }
                        else if (str4.Equals("Lockpick"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Lockpick].Buffed + num5;
                        }
                        else if (str4.Equals("Loyalty"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Loyalty].Buffed;
                        }
                        else if (str4.Equals("Mace"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Mace].Buffed;
                        }
                        else if (str4.Equals("Magic Defense"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.MagicDefense].Buffed;
                        }
                        else if (str4.Equals("Mana Conversion"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.ManaConversion].Buffed;
                        }
                        else if (str4.Equals("Melee Defense"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.MeleeDefense].Buffed;
                        }
                        else if (str4.Equals("Missile Defense"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.MissileDefense].Buffed;
                        }
                        else if (str4.Equals("Run"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Run].Buffed;
                        }
                        else if (str4.Equals("Salvaging"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Salvaging].Buffed;
                        }
                        else if (str4.Equals("Spear"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Spear].Buffed;
                        }
                        else if (str4.Equals("Staff"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Staff].Buffed;
                        }
                        else if (str4.Equals("Sword"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Sword].Buffed;
                        }
                        else if (str4.Equals("Thrown Weapons"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.ThrownWeapons].Buffed;
                        }
                        else if (str4.Equals("Unarmed Combat"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.Unarmed].Buffed;
                        }
                        else if (str4.Equals("War Magic"))
                        {
                            num11 = base.Core.CharacterFilter.Skills[CharFilterSkillType.WarMagic].Buffed;
                        }
                        else
                        {
                            num11 = 0;
                        }
                        int num14 = (int) Math.Floor((double) ((1.0 - (1.0 / (1.0 + Math.Exp(0.03 * (num11 - num13))))) * 100.0));
                        if (num14 < num10)
                        {
                            num10 = num14;
                        }
                    }
                }
                return num10;
            }
            catch (Exception exception)
            {
                clsMessageWriter.Write_Error(errorLogFile, exception);
                return 0.0;
            }
            return 0.0;
        }

        public double calculateDifficulty(bool imbue, bool charmedSmith, int salvageType, int itemWork, double salvageQuality, int tinkerNum, int skill)
        {
            if (((itemWork <= 0) || (itemWork > 10)) || ((tinkerNum < 0) || (tinkerNum > 10)))
            {
                clsMessageWriter.Write_Split_Message(debugFile, string.Concat(new object[] { "Out of bounds! Returning a negative tinker value. Debug: itemWork:", itemWork, " tinkerNum: ", tinkerNum }));
                return -1.0;
            }
            double num = 0.0;
            switch (tinkerNum)
            {
                case 0:
                    num = 1.0;
                    break;

                case 1:
                    num = 1.0;
                    break;

                case 2:
                    num = 1.1;
                    break;

                case 3:
                    num = 1.3;
                    break;

                case 4:
                    num = 1.6;
                    break;

                case 5:
                    num = 2.0;
                    break;

                case 6:
                    num = 2.5;
                    break;

                case 7:
                    num = 3.0;
                    break;

                case 8:
                    num = 3.5;
                    break;

                case 9:
                    num = 4.0;
                    break;

                case 10:
                    num = 4.5;
                    break;

                default:
                    clsMessageWriter.Write_Split_Message(debugFile, "Default case found for tinker success!");
                    num = 1.0;
                    break;
            }
            int num2 = 0;
            if (salvageQuality < itemWork)
            {
                num2 = 1;
            }
            else
            {
                num2 = 2;
            }
            double num3 = Math.Floor((double)((((5 * salvageType) + ((2 * itemWork) * salvageType)) - (((salvageQuality * num2) * salvageType) / 5.0)) * num));
            double num4 = Math.Floor((double)((1.0 - (1.0 / (1.0 + Math.Exp(0.03 * (skill - num3))))) * 100.0));
            if (imbue)
            {
                num4 = Math.Ceiling((double)(num4 / 3.0));
                if (charmedSmith)
                {
                    num4 += 5.0;
                }
                if (num4 > 38.0)
                {
                    num4 = 38.0;
                }
            }
            return num4;
        }

        #endregion
    }
}

